/* this file has been generated automatically; do not edit */

#include <php.h>
#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#include <lasso/lasso.h>
#include "php_lasso.h"
#include "../ghashtable.h"
#define LASSO_LOG_STATIC

#if defined(__GNUC__)
#  define lasso_log(level, filename, line, function, format, args...) \
        g_log("Lasso", level, "%s:%i:%s" format, filename, line, function, ##args)
#elif defined(HAVE_VARIADIC_MACROS)
#  define lasso_log(level, format, line, function, ...)  \
        g_log("Lasso", leve, "%s:%i:%s" format, filename, line, function, __VA_ARGS__)
#else
static inline void lasso_log(GLogLevelFlags level, const char *filename,
    int line, const char *function, const char *format, ...)
{
	va_list ap;
	char s[1024];
	va_start(ap, format);
	g_vsnprintf(s, 1024, format, ap);
	va_end(ap);
    g_log("Lasso", level, "%s:%i:%s %s", filename, line, function, s);
}
#define lasso_log lasso_log
#endif

#include "../../lasso/utils.h"
#include "../utils.c"

/* utility functions */
static void free_glist(GList **list, GFunc free_function);

/* Define the Lasso PHP module */

int le_lasso_server;

ZEND_GET_MODULE(lasso)

/* Wrapper around GObject to get the dynamic typename */

typedef struct {
	GObject *obj;
	char *typename;
} PhpGObjectPtr;

/** FIXME: implement caching of objects inside GObjects using a GQuark */
static PhpGObjectPtr*
PhpGObjectPtr_New(GObject *obj)
{
	PhpGObjectPtr *self;

	if (obj == NULL) {
		return NULL;
	}

	self = (PhpGObjectPtr *)malloc(sizeof(PhpGObjectPtr));
	self->obj = g_object_ref(obj);
	self->typename = strdup(G_OBJECT_TYPE_NAME(obj));
        //printf("Allocating container %p for object %p of type %s with refcnt %i\n", self, obj, self->typename, obj->ref_count);

	return self;
}
PHP_FUNCTION(lasso_init)
{
	RETURN_NULL();
}
PHP_FUNCTION(lasso_shutdown)
{
	RETURN_NULL();
}
PHP_FUNCTION(lasso_get_object_typename)
{
	PhpGObjectPtr *self;
	zval *zval_self;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_self) == FAILURE) {
		RETURN_FALSE;
	}

	ZEND_FETCH_RESOURCE(self, PhpGObjectPtr *, &zval_self, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
	RETURN_STRING(self->typename, 1);
}

/* Generic destructor for PHP GObject  */
static void php_gobject_generic_destructor(zend_rsrc_list_entry *rsrc TSRMLS_DC)
{
    PhpGObjectPtr* gobject = (PhpGObjectPtr*)rsrc->ptr;

    if (gobject) {
        if (gobject->obj) {
            //printf("Deallocating container %p\n", gobject);
            //printf("Deallocating %p that has %u refcounts\n", gobject->obj, gobject->obj->ref_count);
            g_object_unref(G_OBJECT(gobject->obj));
            //printf("now %u refcounts\n", gobject->obj->ref_count);
        }
        if (gobject->typename) {
            free(gobject->typename);
        }
        free(gobject);
    }
}

/* List handling */
static void
free_glist(GList **list, GFunc free_function) {
    lasso_return_if_fail(list);
    if (*list) {
        if (free_function) {
            g_list_foreach(*list, free_function, NULL);
        }
        g_list_free(*list);
    }
    *list = NULL;
}
/* Conversion functions */

static xmlBuffer*
xmlnode_to_xmlbuffer(xmlNode *node)
{
	xmlOutputBufferPtr output_buffer;
	xmlBuffer *buffer;

	if (! node)
		return NULL;

	buffer = xmlBufferCreate();
	output_buffer = xmlOutputBufferCreateBuffer(buffer, NULL);
	xmlNodeDumpOutput(output_buffer, NULL, node, 0, 0, NULL);
	xmlOutputBufferClose(output_buffer);
	xmlBufferAdd(buffer, BAD_CAST "", 1);

	return buffer;
}

static char*
get_string_from_xml_node(xmlNode *xmlnode)
{
	xmlBuffer *buffer;
	char *result;

	if (xmlnode == NULL) {
		return NULL;
	}
	buffer = xmlnode_to_xmlbuffer(xmlnode);
	if (buffer == NULL) {
		result = NULL;
	} else {
		result = estrdup((char*)xmlBufferContent(buffer));
		xmlBufferFree(buffer);
	}
	return result;
}

static xmlNode*
get_xml_node_from_string(char *string)
{
	return lasso_string_fragment_to_xmlnode(string, 0);
}

static GList*
get_list_from_array_of_strings(zval* array)
{
	HashTable* hashtable;
	HashPosition pointer;
	int size;
	zval** data;
	zval temp;
	GList* result = NULL;

	hashtable = Z_ARRVAL_P(array);
	size = zend_hash_num_elements(hashtable);
	for (zend_hash_internal_pointer_reset_ex(hashtable, &pointer);
			zend_hash_get_current_data_ex(hashtable, (void**) &data, &pointer) == SUCCESS;
			zend_hash_move_forward_ex(hashtable, &pointer)) {
		temp = **data;
		zval_copy_ctor(&temp);
		convert_to_string(&temp);
		result = g_list_append(result, g_strndup(Z_STRVAL(temp), Z_STRLEN(temp)));
		zval_dtor(&temp);
	}
	return result;
}

static void
set_array_from_list_of_strings(GList* list, zval **array) {
	GList* item;

	array_init(*array);
	for (item = g_list_first(list); item != NULL; item = g_list_next(item)) {
		if (item->data != NULL) {
			add_next_index_string(*array, item->data, 1);
		} else {
			add_next_index_null(*array);
		}
	}
}

static GList*
get_list_from_array_of_xmlnodes(zval* array)
{
	HashTable* hashtable;
	HashPosition pointer;
	int size;
	zval** data;
	zval temp;
	GList* result = NULL;

	hashtable = Z_ARRVAL_P(array);
	size = zend_hash_num_elements(hashtable);
	for (zend_hash_internal_pointer_reset_ex(hashtable, &pointer);
			zend_hash_get_current_data_ex(hashtable, (void**) &data, &pointer) == SUCCESS;
			zend_hash_move_forward_ex(hashtable, &pointer)) {
		xmlNode *value;

		temp = **data;
		zval_copy_ctor(&temp);
		convert_to_string(&temp);
		value = get_xml_node_from_string(Z_STRVAL(temp));
		if (value) {
			lasso_list_add_new_xml_node(result, value);
		}
		zval_dtor(&temp);
	}
	return result;
}

static void
set_array_from_list_of_xmlnodes(GList* list, zval **array) {
	GList* item;

	array_init(*array);
	for (item = g_list_first(list); item != NULL; item = g_list_next(item)) {
		if (item->data != NULL) {
			add_next_index_string(*array, get_string_from_xml_node(item->data), 0);
		} else {
			add_next_index_null(*array);
		}
	}
}

static GList*
get_list_from_array_of_objects(zval *array)
{
	HashTable *hashtable;
	HashPosition pointer;
	int size;
	zval **data;
	PhpGObjectPtr *cvt_temp;
	GList *result = NULL;

	hashtable = Z_ARRVAL_P(array);
	size = zend_hash_num_elements(hashtable);
	for (zend_hash_internal_pointer_reset_ex(hashtable, &pointer);
			zend_hash_get_current_data_ex(hashtable, (void**) &data, &pointer) == SUCCESS;
			zend_hash_move_forward_ex(hashtable, &pointer)) {
		cvt_temp = (PhpGObjectPtr*) zend_fetch_resource(data TSRMLS_CC, -1, PHP_LASSO_SERVER_RES_NAME, NULL, 1, le_lasso_server);
		if (cvt_temp != NULL) {
                        g_object_ref(cvt_temp->obj);
			result = g_list_append(result, cvt_temp->obj);
		} else {
			result = g_list_append(result, NULL);
		}
	}
	return result;
}

static void
set_array_from_list_of_objects(GList *list, zval **array)
{
	GList *item = NULL;
	zval *zval_item = NULL;

	array_init(*array);
	for (item = g_list_first(list); item != NULL; item = g_list_next(item)) {
		if (item->data != NULL) {
                        MAKE_STD_ZVAL(zval_item);
			ZEND_REGISTER_RESOURCE(zval_item, PhpGObjectPtr_New(item->data), le_lasso_server);
			add_next_index_zval(*array, zval_item);
		} else {
			add_next_index_null(*array);
		}
	}
}

/* FIXME: This function doesn't work yet */
static GHashTable*
get_hashtable_from_array_of_objects(zval *array)
{
	HashTable *hashtable = NULL;
	HashPosition pointer;
	int size;
	char *key = NULL;
	unsigned int key_len;
	unsigned long index;
	zval **data = NULL;
	PhpGObjectPtr *cvt_temp = NULL;
	GHashTable *result = NULL;

	result = g_hash_table_new(g_str_hash, g_str_equal);
	hashtable = Z_ARRVAL_P(array);
	size = zend_hash_num_elements(hashtable);
	for (zend_hash_internal_pointer_reset_ex(hashtable, &pointer);
			zend_hash_get_current_data_ex(hashtable, (void**) &data, &pointer) == SUCCESS;
			zend_hash_move_forward_ex(hashtable, &pointer)) {
		cvt_temp = (PhpGObjectPtr*) zend_fetch_resource(data TSRMLS_CC, -1, PHP_LASSO_SERVER_RES_NAME, NULL, 1, le_lasso_server);
		if (zend_hash_get_current_key_ex(hashtable, &key, &key_len, &index, 0, &pointer) == HASH_KEY_IS_STRING) {
			g_hash_table_insert(result, key, lasso_ref(cvt_temp->obj));
		} else {
			/* FIXME: throw an exception */
		}
	}
	return result;
}

G_GNUC_UNUSED static GHashTable*
get_hashtable_from_array_of_strings(zval *array)
{
	HashTable *hashtable = NULL;
	HashPosition pointer;
	int size;
	char *key = NULL;
	unsigned int key_len;
	unsigned long index;
	zval **data = NULL;
	GHashTable *result = NULL;

	result = g_hash_table_new(g_str_hash, g_str_equal);
	hashtable = Z_ARRVAL_P(array);
	size = zend_hash_num_elements(hashtable);
	for (zend_hash_internal_pointer_reset_ex(hashtable, &pointer);
			zend_hash_get_current_data_ex(hashtable, (void**) &data, &pointer) == SUCCESS;
			zend_hash_move_forward_ex(hashtable, &pointer)) {
		if (Z_TYPE_PP(data) == IS_STRING) {
			if (zend_hash_get_current_key_ex(hashtable, &key, &key_len, &index, 0, &pointer) == HASH_KEY_IS_STRING) {
				g_hash_table_insert(result, g_strdup(key), g_strdup(Z_STRVAL_PP(data)));
			} else {
				/* FIXME: throw an exception */
			}
		}
	}
	return result;
}

static void
set_array_from_hashtable_of_objects(GHashTable *hashtable, zval **array)
{
	GList *keys = NULL;
	GObject *item = NULL;
	zval *zval_item = NULL;

	array_init(*array);
	for (keys = g_hash_table_get_keys(hashtable); keys; keys = g_list_next(keys)) {
		item = g_hash_table_lookup(hashtable, keys->data);
		if (item) {
			MAKE_STD_ZVAL(zval_item);
			ZEND_REGISTER_RESOURCE(zval_item, PhpGObjectPtr_New(item), le_lasso_server);
			add_assoc_zval(*array, (char*)keys->data, zval_item);
		} else {
			add_assoc_null(*array, (char*)keys->data);
		}
	}
	g_list_free(keys);
}

G_GNUC_UNUSED static void
set_array_from_hashtable_of_strings(GHashTable *hashtable, zval **array)
{
	GList *keys = NULL;
	zval *zval_item = NULL;

	array_init(*array);
	for (keys = g_hash_table_get_keys(hashtable); keys; keys = g_list_next(keys)) {
		char *item = g_hash_table_lookup(hashtable, keys->data);
		if (item) {
			MAKE_STD_ZVAL(zval_item);
			ZVAL_STRING(zval_item, item, 1);
			add_assoc_zval(*array, (char*)keys->data, zval_item);
		} else {
			add_assoc_null(*array, (char*)keys->data);
		}
	}
	g_list_free(keys);
}


#include <lasso/errors.h>
#include <lasso/lasso.h>
#include <lasso/key.h>
#include <lasso/ctypes.h>
#include <lasso/logging.h>
#include <lasso/registry.h>
#include <lasso/backward_comp.h>
#include <lasso/debug.h>
#include <lasso/export.h>
#include <lasso/utils.h>
#include <lasso/id-ff/identity.h>
#include <lasso/id-ff/provider.h>
#include <lasso/id-ff/defederation.h>
#include <lasso/id-ff/profile.h>
#include <lasso/id-ff/server.h>
#include <lasso/id-ff/logout.h>
#include <lasso/id-ff/name_identifier_mapping.h>
#include <lasso/id-ff/session.h>
#include <lasso/id-ff/lecp.h>
#include <lasso/id-ff/login.h>
#include <lasso/id-ff/federation.h>
#include <lasso/id-ff/name_registration.h>
#include <lasso/saml-2.0/provider.h>
#include <lasso/saml-2.0/profile.h>
#include <lasso/saml-2.0/saml2_helper.h>
#include <lasso/saml-2.0/ecp.h>
#include <lasso/saml-2.0/name_id_management.h>
#include <lasso/saml-2.0/assertion_query.h>
#include <lasso/xml/saml_assertion.h>
#include <lasso/xml/lib_request_authn_context.h>
#include <lasso/xml/lib_authn_request_envelope.h>
#include <lasso/xml/samlp_request.h>
#include <lasso/xml/lib_authn_response.h>
#include <lasso/xml/misc_text_node.h>
#include <lasso/xml/tools.h>
#include <lasso/xml/lib_logout_response.h>
#include <lasso/xml/saml_subject_statement_abstract.h>
#include <lasso/xml/lib_authn_context.h>
#include <lasso/xml/samlp_status.h>
#include <lasso/xml/xml_enc.h>
#include <lasso/xml/xml.h>
#include <lasso/xml/saml_audience_restriction_condition.h>
#include <lasso/xml/saml_subject_confirmation.h>
#include <lasso/xml/saml_authentication_statement.h>
#include <lasso/xml/lib_idp_list.h>
#include <lasso/xml/lib_register_name_identifier_response.h>
#include <lasso/xml/saml_attribute_statement.h>
#include <lasso/xml/saml_subject_locality.h>
#include <lasso/xml/lib_federation_termination_notification.h>
#include <lasso/xml/saml_attribute_value.h>
#include <lasso/xml/saml_condition_abstract.h>
#include <lasso/xml/lib_scoping.h>
#include <lasso/xml/lib_name_identifier_mapping_response.h>
#include <lasso/xml/samlp_response.h>
#include <lasso/xml/saml_subject_statement.h>
#include <lasso/xml/lib_authn_request.h>
#include <lasso/xml/lib_authn_response_envelope.h>
#include <lasso/xml/saml_attribute_designator.h>
#include <lasso/xml/lib_idp_entries.h>
#include <lasso/xml/lib_subject.h>
#include <lasso/xml/saml_advice.h>
#include <lasso/xml/lib_assertion.h>
#include <lasso/xml/samlp_response_abstract.h>
#include <lasso/xml/lib_status_response.h>
#include <lasso/xml/saml_statement_abstract.h>
#include <lasso/xml/saml_name_identifier.h>
#include <lasso/xml/saml_authority_binding.h>
#include <lasso/xml/saml_subject.h>
#include <lasso/xml/lib_authentication_statement.h>
#include <lasso/xml/saml_conditions.h>
#include <lasso/xml/strings.h>
#include <lasso/xml/lib_logout_request.h>
#include <lasso/xml/lib_idp_entry.h>
#include <lasso/xml/lib_register_name_identifier_request.h>
#include <lasso/xml/saml_attribute.h>
#include <lasso/xml/samlp_status_code.h>
#include <lasso/xml/samlp_request_abstract.h>
#include <lasso/xml/lib_name_identifier_mapping_request.h>
#include <lasso/xml/saml-2.0/saml2_base_idabstract.h>
#include <lasso/xml/saml-2.0/samlp2_attribute_query.h>
#include <lasso/xml/saml-2.0/samlp2_assertion_id_request.h>
#include <lasso/xml/saml-2.0/saml2_condition_abstract.h>
#include <lasso/xml/saml-2.0/saml2_attribute_value.h>
#include <lasso/xml/saml-2.0/samlp2_name_id_policy.h>
#include <lasso/xml/saml-2.0/samlp2_status_code.h>
#include <lasso/xml/saml-2.0/samlp2_manage_name_id_response.h>
#include <lasso/xml/saml-2.0/samlp2_name_id_mapping_request.h>
#include <lasso/xml/saml-2.0/saml2_one_time_use.h>
#include <lasso/xml/saml-2.0/saml2_key_info_confirmation_data.h>
#include <lasso/xml/saml-2.0/saml2_subject_confirmation_data.h>
#include <lasso/xml/saml-2.0/saml2_subject.h>
#include <lasso/xml/saml-2.0/saml2_conditions.h>
#include <lasso/xml/saml-2.0/samlp2_status_response.h>
#include <lasso/xml/saml-2.0/saml2_statement_abstract.h>
#include <lasso/xml/saml-2.0/samlp2_artifact_resolve.h>
#include <lasso/xml/saml-2.0/saml2_proxy_restriction.h>
#include <lasso/xml/saml-2.0/samlp2_manage_name_id_request.h>
#include <lasso/xml/saml-2.0/saml2_advice.h>
#include <lasso/xml/saml-2.0/samlp2_artifact_response.h>
#include <lasso/xml/saml-2.0/saml2_attribute.h>
#include <lasso/xml/saml-2.0/samlp2_logout_response.h>
#include <lasso/xml/saml-2.0/samlp2_idp_list.h>
#include <lasso/xml/saml-2.0/samlp2_status.h>
#include <lasso/xml/saml-2.0/saml2_encrypted_element.h>
#include <lasso/xml/saml-2.0/saml2_subject_confirmation.h>
#include <lasso/xml/saml-2.0/samlp2_idp_entry.h>
#include <lasso/xml/saml-2.0/saml2_audience_restriction.h>
#include <lasso/xml/saml-2.0/samlp2_requested_authn_context.h>
#include <lasso/xml/saml-2.0/samlp2_extensions.h>
#include <lasso/xml/saml-2.0/saml2_attribute_statement.h>
#include <lasso/xml/saml-2.0/saml2_authz_decision_statement.h>
#include <lasso/xml/saml-2.0/saml2_evidence.h>
#include <lasso/xml/saml-2.0/saml2_key_info_confirmation_data_type.h>
#include <lasso/xml/saml-2.0/samlp2_scoping.h>
#include <lasso/xml/saml-2.0/saml2_authn_context.h>
#include <lasso/xml/saml-2.0/samlp2_status_detail.h>
#include <lasso/xml/saml-2.0/samlp2_authz_decision_query.h>
#include <lasso/xml/saml-2.0/saml2_assertion.h>
#include <lasso/xml/saml-2.0/samlp2_logout_request.h>
#include <lasso/xml/saml-2.0/saml2_name_id.h>
#include <lasso/xml/saml-2.0/samlp2_name_id_mapping_response.h>
#include <lasso/xml/saml-2.0/saml2_action.h>
#include <lasso/xml/saml-2.0/samlp2_response.h>
#include <lasso/xml/saml-2.0/saml2_subject_locality.h>
#include <lasso/xml/saml-2.0/samlp2_request_abstract.h>
#include <lasso/xml/saml-2.0/samlp2_subject_query_abstract.h>
#include <lasso/xml/saml-2.0/samlp2_terminate.h>
#include <lasso/xml/saml-2.0/saml2_strings.h>
#include <lasso/xml/saml-2.0/saml2_authn_statement.h>
#include <lasso/xml/saml-2.0/samlp2_authn_query.h>
#include <lasso/xml/saml-2.0/samlp2_authn_request.h>
#include <lasso/xml/soap-1.1/soap_body.h>
#include <lasso/xml/soap-1.1/soap_fault.h>
#include <lasso/xml/soap-1.1/soap_header.h>
#include <lasso/xml/soap-1.1/soap_detail.h>
#include <lasso/xml/soap-1.1/soap_envelope.h>
#include <lasso/xml/dsig/ds_x509_data.h>
#include <lasso/xml/dsig/ds_key_value.h>
#include <lasso/xml/dsig/xml_dsig.h>
#include <lasso/xml/dsig/ds_key_info.h>
#include <lasso/xml/dsig/strings.h>
#include <lasso/xml/dsig/ds_rsa_key_value.h>

PHP_MINIT_FUNCTION(lasso)
{
    le_lasso_server = zend_register_list_destructors_ex(php_gobject_generic_destructor, NULL, PHP_LASSO_SERVER_RES_NAME, module_number);
    lasso_init();

    /* Constants (both enums and defines) */
    REGISTER_LONG_CONSTANT("LASSO_ERROR_UNDEFINED", LASSO_ERROR_UNDEFINED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ERROR_UNIMPLEMENTED", LASSO_ERROR_UNIMPLEMENTED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ERROR_OUT_OF_MEMORY", LASSO_ERROR_OUT_OF_MEMORY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ERROR_CAST_FAILED", LASSO_ERROR_CAST_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_NODE_NOT_FOUND", LASSO_XML_ERROR_NODE_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_NODE_CONTENT_NOT_FOUND", LASSO_XML_ERROR_NODE_CONTENT_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_ATTR_NOT_FOUND", LASSO_XML_ERROR_ATTR_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_ATTR_VALUE_NOT_FOUND", LASSO_XML_ERROR_ATTR_VALUE_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_INVALID_FILE", LASSO_XML_ERROR_INVALID_FILE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_OBJECT_CONSTRUCTION_FAILED", LASSO_XML_ERROR_OBJECT_CONSTRUCTION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_MISSING_NAMESPACE", LASSO_XML_ERROR_MISSING_NAMESPACE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XML_ERROR_SCHEMA_INVALID_FRAGMENT", LASSO_XML_ERROR_SCHEMA_INVALID_FRAGMENT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_SIGNATURE_NOT_FOUND", LASSO_DS_ERROR_SIGNATURE_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_INVALID_SIGNATURE", LASSO_DS_ERROR_INVALID_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED", LASSO_DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_CONTEXT_CREATION_FAILED", LASSO_DS_ERROR_CONTEXT_CREATION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_PUBLIC_KEY_LOAD_FAILED", LASSO_DS_ERROR_PUBLIC_KEY_LOAD_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED", LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_CERTIFICATE_LOAD_FAILED", LASSO_DS_ERROR_CERTIFICATE_LOAD_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_SIGNATURE_FAILED", LASSO_DS_ERROR_SIGNATURE_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_KEYS_MNGR_CREATION_FAILED", LASSO_DS_ERROR_KEYS_MNGR_CREATION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_KEYS_MNGR_INIT_FAILED", LASSO_DS_ERROR_KEYS_MNGR_INIT_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED", LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED", LASSO_DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_INVALID_SIGALG", LASSO_DS_ERROR_INVALID_SIGALG, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_DIGEST_COMPUTE_FAILED", LASSO_DS_ERROR_DIGEST_COMPUTE_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND", LASSO_DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_TOO_MUCH_REFERENCES", LASSO_DS_ERROR_TOO_MUCH_REFERENCES, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_INVALID_REFERENCE_FOR_SAML", LASSO_DS_ERROR_INVALID_REFERENCE_FOR_SAML, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_DECRYPTION_FAILED", LASSO_DS_ERROR_DECRYPTION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_ENCRYPTION_FAILED", LASSO_DS_ERROR_ENCRYPTION_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DS_ERROR_DECRYPTION_FAILED_MISSING_PRIVATE_KEY", LASSO_DS_ERROR_DECRYPTION_FAILED_MISSING_PRIVATE_KEY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND", LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_ERROR_ADD_PROVIDER_FAILED", LASSO_SERVER_ERROR_ADD_PROVIDER_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH", LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED", LASSO_SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_ERROR_INVALID_XML", LASSO_SERVER_ERROR_INVALID_XML, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_ERROR_NO_PROVIDER_LOADED", LASSO_SERVER_ERROR_NO_PROVIDER_LOADED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE", LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGOUT_ERROR_REQUEST_DENIED", LASSO_LOGOUT_ERROR_REQUEST_DENIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGOUT_ERROR_FEDERATION_NOT_FOUND", LASSO_LOGOUT_ERROR_FEDERATION_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGOUT_ERROR_UNKNOWN_PRINCIPAL", LASSO_LOGOUT_ERROR_UNKNOWN_PRINCIPAL, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGOUT_ERROR_PARTIAL_LOGOUT", LASSO_LOGOUT_ERROR_PARTIAL_LOGOUT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_QUERY", LASSO_PROFILE_ERROR_INVALID_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_POST_MSG", LASSO_PROFILE_ERROR_INVALID_POST_MSG, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_SOAP_MSG", LASSO_PROFILE_ERROR_INVALID_SOAP_MSG, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_REQUEST", LASSO_PROFILE_ERROR_MISSING_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD", LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE", LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_MSG", LASSO_PROFILE_ERROR_INVALID_MSG, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID", LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE", LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL", LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND", LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND", LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND", LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED", LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED", LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_BUILDING_MESSAGE_FAILED", LASSO_PROFILE_ERROR_BUILDING_MESSAGE_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED", LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_SESSION_NOT_FOUND", LASSO_PROFILE_ERROR_SESSION_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_BAD_IDENTITY_DUMP", LASSO_PROFILE_ERROR_BAD_IDENTITY_DUMP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_BAD_SESSION_DUMP", LASSO_PROFILE_ERROR_BAD_SESSION_DUMP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_RESPONSE", LASSO_PROFILE_ERROR_MISSING_RESPONSE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_STATUS_CODE", LASSO_PROFILE_ERROR_MISSING_STATUS_CODE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_ARTIFACT", LASSO_PROFILE_ERROR_MISSING_ARTIFACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_RESOURCE_OFFERING", LASSO_PROFILE_ERROR_MISSING_RESOURCE_OFFERING, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION", LASSO_PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_SERVICE_TYPE", LASSO_PROFILE_ERROR_MISSING_SERVICE_TYPE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_ASSERTION", LASSO_PROFILE_ERROR_MISSING_ASSERTION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_SUBJECT", LASSO_PROFILE_ERROR_MISSING_SUBJECT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER", LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_ARTIFACT", LASSO_PROFILE_ERROR_INVALID_ARTIFACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY", LASSO_PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_STATUS_NOT_SUCCESS", LASSO_PROFILE_ERROR_STATUS_NOT_SUCCESS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_ISSUER", LASSO_PROFILE_ERROR_MISSING_ISSUER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_SERVICE_INSTANCE", LASSO_PROFILE_ERROR_MISSING_SERVICE_INSTANCE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE", LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS", LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_ISSUER", LASSO_PROFILE_ERROR_INVALID_ISSUER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_MISSING_SERVER", LASSO_PROFILE_ERROR_MISSING_SERVER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_UNKNOWN_PROVIDER", LASSO_PROFILE_ERROR_UNKNOWN_PROVIDER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_CANNOT_VERIFY_SIGNATURE", LASSO_PROFILE_ERROR_CANNOT_VERIFY_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_CANNOT_FIND_A_PROVIDER", LASSO_PROFILE_ERROR_CANNOT_FIND_A_PROVIDER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_RESPONSE_DOES_NOT_MATCH_REQUEST", LASSO_PROFILE_ERROR_RESPONSE_DOES_NOT_MATCH_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_REQUEST", LASSO_PROFILE_ERROR_INVALID_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_RESPONSE", LASSO_PROFILE_ERROR_INVALID_RESPONSE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_UNSUPPORTED_BINDING", LASSO_PROFILE_ERROR_UNSUPPORTED_BINDING, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_ASSERTION_CONDITIONS", LASSO_PROFILE_ERROR_INVALID_ASSERTION_CONDITIONS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_INVALID_ASSERTION", LASSO_PROFILE_ERROR_INVALID_ASSERTION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_UNKNOWN_ISSUER", LASSO_PROFILE_ERROR_UNKNOWN_ISSUER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_ISSUER_IS_NOT_AN_IDP", LASSO_PROFILE_ERROR_ISSUER_IS_NOT_AN_IDP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_REQUEST_DENIED", LASSO_PROFILE_ERROR_REQUEST_DENIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_ERROR_ENDPOINT_INDEX_NOT_FOUND", LASSO_PROFILE_ERROR_ENDPOINT_INDEX_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ", LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PARAM_ERROR_INVALID_VALUE", LASSO_PARAM_ERROR_INVALID_VALUE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PARAM_ERROR_CHECK_FAILED", LASSO_PARAM_ERROR_CHECK_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PARAM_ERROR_NON_INITIALIZED_OBJECT", LASSO_PARAM_ERROR_NON_INITIALIZED_OBJECT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND", LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED", LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY", LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_REQUEST_DENIED", LASSO_LOGIN_ERROR_REQUEST_DENIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_INVALID_SIGNATURE", LASSO_LOGIN_ERROR_INVALID_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST", LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS", LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL", LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_NO_DEFAULT_ENDPOINT", LASSO_LOGIN_ERROR_NO_DEFAULT_ENDPOINT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_ASSERTION_REPLAY", LASSO_LOGIN_ERROR_ASSERTION_REPLAY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_ASSERTION_DOES_NOT_MATCH_REQUEST_ID", LASSO_LOGIN_ERROR_ASSERTION_DOES_NOT_MATCH_REQUEST_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_ERROR_INVALID_ASSERTION_SIGNATURE", LASSO_LOGIN_ERROR_INVALID_ASSERTION_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER", LASSO_DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SOAP_ERROR_REDIRECT_REQUEST_FAULT", LASSO_SOAP_ERROR_REDIRECT_REQUEST_FAULT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SOAP_FAULT_REDIRECT_REQUEST", LASSO_SOAP_FAULT_REDIRECT_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SOAP_ERROR_MISSING_ENVELOPE", LASSO_SOAP_ERROR_MISSING_ENVELOPE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SOAP_ERROR_MISSING_HEADER", LASSO_SOAP_ERROR_MISSING_HEADER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SOAP_ERROR_MISSING_BODY", LASSO_SOAP_ERROR_MISSING_BODY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL", LASSO_SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE", LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE", LASSO_NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER", LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DATA_SERVICE_ERROR_UNREGISTERED_DST", LASSO_DATA_SERVICE_ERROR_UNREGISTERED_DST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DATA_SERVICE_ERROR_CANNOT_ADD_ITEM", LASSO_DATA_SERVICE_ERROR_CANNOT_ADD_ITEM, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_CORRELATION", LASSO_WSF_PROFILE_ERROR_MISSING_CORRELATION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_SECURITY", LASSO_WSF_PROFILE_ERROR_MISSING_SECURITY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_ASSERTION_ID", LASSO_WSF_PROFILE_ERROR_MISSING_ASSERTION_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_ENDPOINT", LASSO_WSF_PROFILE_ERROR_MISSING_ENDPOINT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_SOAP_FAULT", LASSO_WSF_PROFILE_ERROR_SOAP_FAULT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM", LASSO_WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_DESCRIPTION", LASSO_WSF_PROFILE_ERROR_MISSING_DESCRIPTION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_RESOURCE_ID", LASSO_WSF_PROFILE_ERROR_MISSING_RESOURCE_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_CREDENTIAL_REF", LASSO_WSF_PROFILE_ERROR_MISSING_CREDENTIAL_REF, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_INVALID_OR_MISSING_REFERENCE_TO_MESSAGE_ID", LASSO_WSF_PROFILE_ERROR_INVALID_OR_MISSING_REFERENCE_TO_MESSAGE_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_SECURITY_MECHANISM_CHECK_FAILED", LASSO_WSF_PROFILE_ERROR_SECURITY_MECHANISM_CHECK_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_UNKNOWN_STATUS_CODE", LASSO_WSF_PROFILE_ERROR_UNKNOWN_STATUS_CODE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED", LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED_FOR_DATA", LASSO_WSF_PROFILE_ERROR_SERVER_INTERACTION_REQUIRED_FOR_DATA, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST", LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST_UNSUPPORTED_BY_REQUESTER", LASSO_WSF_PROFILE_ERROR_REDIRECT_REQUEST_UNSUPPORTED_BY_REQUESTER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSF_PROFILE_ERROR_MISSING_SENDER_ID", LASSO_WSF_PROFILE_ERROR_MISSING_SENDER_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED", LASSO_DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED", LASSO_DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE", LASSO_DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE", LASSO_DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_MISSING_SERVICE_DATA", LASSO_DST_ERROR_MISSING_SERVICE_DATA, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_QUERY_FAILED", LASSO_DST_ERROR_QUERY_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_QUERY_PARTIALLY_FAILED", LASSO_DST_ERROR_QUERY_PARTIALLY_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_MODIFY_FAILED", LASSO_DST_ERROR_MODIFY_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_MODIFY_PARTIALLY_FAILED", LASSO_DST_ERROR_MODIFY_PARTIALLY_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_NEW_DATA_MISSING", LASSO_DST_ERROR_NEW_DATA_MISSING, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_QUERY_NOT_FOUND", LASSO_DST_ERROR_QUERY_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_NO_DATA", LASSO_DST_ERROR_NO_DATA, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_MALFORMED_QUERY", LASSO_DST_ERROR_MALFORMED_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DST_ERROR_EMPTY_REQUEST", LASSO_DST_ERROR_EMPTY_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REGISTRY_ERROR_KEY_EXISTS", LASSO_REGISTRY_ERROR_KEY_EXISTS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ERROR_MISSING_PUBLIC_KEY", LASSO_PROVIDER_ERROR_MISSING_PUBLIC_KEY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSSEC_ERROR_MISSING_SECURITY_TOKEN", LASSO_WSSEC_ERROR_MISSING_SECURITY_TOKEN, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_WSSEC_ERROR_BAD_PASSWORD", LASSO_WSSEC_ERROR_BAD_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DISCOVERY_ERROR_FAILED", LASSO_IDWSF2_DISCOVERY_ERROR_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DISCOVERY_ERROR_FORBIDDEN", LASSO_IDWSF2_DISCOVERY_ERROR_FORBIDDEN, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DISCOVERY_ERROR_DUPLICATE", LASSO_IDWSF2_DISCOVERY_ERROR_DUPLICATE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DISCOVERY_ERROR_LOGICAL_DUPLICATE", LASSO_IDWSF2_DISCOVERY_ERROR_LOGICAL_DUPLICATE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DISCOVERY_ERROR_NO_RESULTS", LASSO_IDWSF2_DISCOVERY_ERROR_NO_RESULTS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DISCOVERY_ERROR_NOT_FOUND", LASSO_IDWSF2_DISCOVERY_ERROR_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DST_ERROR_DUPLICATE_ITEM", LASSO_IDWSF2_DST_ERROR_DUPLICATE_ITEM, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DST_ERROR_PARTIAL_FAILURE", LASSO_IDWSF2_DST_ERROR_PARTIAL_FAILURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DST_ERROR_UNKNOWN_STATUS_CODE", LASSO_IDWSF2_DST_ERROR_UNKNOWN_STATUS_CODE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_IDWSF2_DST_ERROR_ITEM_NOT_FOUND", LASSO_IDWSF2_DST_ERROR_ITEM_NOT_FOUND, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_ERROR_ATTRIBUTE_REQUEST_ALREADY_EXIST", LASSO_ASSERTION_QUERY_ERROR_ATTRIBUTE_REQUEST_ALREADY_EXIST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_ERROR_NOT_AN_ATTRIBUTE_QUERY", LASSO_ASSERTION_QUERY_ERROR_NOT_AN_ATTRIBUTE_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_XMLENC_ERROR_INVALID_ENCRYPTED_DATA", LASSO_XMLENC_ERROR_INVALID_ENCRYPTED_DATA, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_CHECK_VERSION_EXACT", LASSO_CHECK_VERSION_EXACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_CHECK_VERSIONABI_COMPATIBLE", LASSO_CHECK_VERSIONABI_COMPATIBLE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_CHECK_VERSION_NUMERIC", LASSO_CHECK_VERSION_NUMERIC, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("BACKWARD_COMP_H", BACKWARD_COMP_H, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_NONE", LASSO_HTTP_METHOD_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_ANY", LASSO_HTTP_METHOD_ANY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_IDP_INITIATED", LASSO_HTTP_METHOD_IDP_INITIATED, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_GET", LASSO_HTTP_METHOD_GET, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_POST", LASSO_HTTP_METHOD_POST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_REDIRECT", LASSO_HTTP_METHOD_REDIRECT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_SOAP", LASSO_HTTP_METHOD_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_ARTIFACT_GET", LASSO_HTTP_METHOD_ARTIFACT_GET, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_ARTIFACT_POST", LASSO_HTTP_METHOD_ARTIFACT_POST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_PAOS", LASSO_HTTP_METHOD_PAOS, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_HTTP_METHOD_LAST", LASSO_HTTP_METHOD_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_FEDERATION_TERMINATION", LASSO_MD_PROTOCOL_TYPE_FEDERATION_TERMINATION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_NAME_IDENTIFIER_MAPPING", LASSO_MD_PROTOCOL_TYPE_NAME_IDENTIFIER_MAPPING, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_REGISTER_NAME_IDENTIFIER", LASSO_MD_PROTOCOL_TYPE_REGISTER_NAME_IDENTIFIER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_SINGLE_LOGOUT", LASSO_MD_PROTOCOL_TYPE_SINGLE_LOGOUT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_SINGLE_SIGN_ON", LASSO_MD_PROTOCOL_TYPE_SINGLE_SIGN_ON, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_ARTIFACT_RESOLUTION", LASSO_MD_PROTOCOL_TYPE_ARTIFACT_RESOLUTION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_MANAGE_NAME_ID", LASSO_MD_PROTOCOL_TYPE_MANAGE_NAME_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_ASSERTION_ID_REQUEST", LASSO_MD_PROTOCOL_TYPE_ASSERTION_ID_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_AUTHN_QUERY", LASSO_MD_PROTOCOL_TYPE_AUTHN_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_AUTHZ", LASSO_MD_PROTOCOL_TYPE_AUTHZ, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_ATTRIBUTE", LASSO_MD_PROTOCOL_TYPE_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MD_PROTOCOL_TYPE_LAST", LASSO_MD_PROTOCOL_TYPE_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_ANY", LASSO_PROVIDER_ROLE_ANY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_NONE", LASSO_PROVIDER_ROLE_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_SP", LASSO_PROVIDER_ROLE_SP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_IDP", LASSO_PROVIDER_ROLE_IDP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_BOTH", LASSO_PROVIDER_ROLE_BOTH, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_AUTHN_AUTHORITY", LASSO_PROVIDER_ROLE_AUTHN_AUTHORITY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_AUTHZ_AUTHORITY", LASSO_PROVIDER_ROLE_AUTHZ_AUTHORITY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_ATTRIBUTE_AUTHORITY", LASSO_PROVIDER_ROLE_ATTRIBUTE_AUTHORITY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_LAST", LASSO_PROVIDER_ROLE_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROVIDER_ROLE_ALL", LASSO_PROVIDER_ROLE_ALL, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROTOCOL_NONE", LASSO_PROTOCOL_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROTOCOL_LIBERTY_1_0", LASSO_PROTOCOL_LIBERTY_1_0, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROTOCOL_LIBERTY_1_1", LASSO_PROTOCOL_LIBERTY_1_1, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROTOCOL_LIBERTY_1_2", LASSO_PROTOCOL_LIBERTY_1_2, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROTOCOL_SAML_2_0", LASSO_PROTOCOL_SAML_2_0, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_MODE_NONE", LASSO_ENCRYPTION_MODE_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_MODE_NAMEID", LASSO_ENCRYPTION_MODE_NAMEID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_MODE_ASSERTION", LASSO_ENCRYPTION_MODE_ASSERTION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_INVALID", LASSO_REQUEST_TYPE_INVALID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_LOGIN", LASSO_REQUEST_TYPE_LOGIN, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_LOGOUT", LASSO_REQUEST_TYPE_LOGOUT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_DEFEDERATION", LASSO_REQUEST_TYPE_DEFEDERATION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_NAME_REGISTRATION", LASSO_REQUEST_TYPE_NAME_REGISTRATION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_NAME_IDENTIFIER_MAPPING", LASSO_REQUEST_TYPE_NAME_IDENTIFIER_MAPPING, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_LECP", LASSO_REQUEST_TYPE_LECP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_DISCO_QUERY", LASSO_REQUEST_TYPE_DISCO_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_DISCO_MODIFY", LASSO_REQUEST_TYPE_DISCO_MODIFY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_DST_QUERY", LASSO_REQUEST_TYPE_DST_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_DST_MODIFY", LASSO_REQUEST_TYPE_DST_MODIFY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_SASL_REQUEST", LASSO_REQUEST_TYPE_SASL_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_NAME_ID_MANAGEMENT", LASSO_REQUEST_TYPE_NAME_ID_MANAGEMENT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_IDWSF2_DISCO_SVCMD_REGISTER", LASSO_REQUEST_TYPE_IDWSF2_DISCO_SVCMD_REGISTER, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_IDWSF2_DISCO_SVCMD_ASSOCIATION_ADD", LASSO_REQUEST_TYPE_IDWSF2_DISCO_SVCMD_ASSOCIATION_ADD, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_REQUEST_TYPE_IDWSF2_DISCO_QUERY", LASSO_REQUEST_TYPE_IDWSF2_DISCO_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_HINT_MAYBE", LASSO_PROFILE_SIGNATURE_HINT_MAYBE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_HINT_FORCE", LASSO_PROFILE_SIGNATURE_HINT_FORCE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_HINT_FORBID", LASSO_PROFILE_SIGNATURE_HINT_FORBID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_VERIFY_HINT_MAYBE", LASSO_PROFILE_SIGNATURE_VERIFY_HINT_MAYBE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_VERIFY_HINT_FORCE", LASSO_PROFILE_SIGNATURE_VERIFY_HINT_FORCE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_VERIFY_HINT_IGNORE", LASSO_PROFILE_SIGNATURE_VERIFY_HINT_IGNORE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_PROFILE_SIGNATURE_VERIFY_HINT_LAST", LASSO_PROFILE_SIGNATURE_VERIFY_HINT_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_LOAD_METADATA_FLAG_DEFAULT", LASSO_SERVER_LOAD_METADATA_FLAG_DEFAULT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_LOAD_METADATA_FLAG_CHECK_ENTITIES_DESCRIPTOR_SIGNATURE", LASSO_SERVER_LOAD_METADATA_FLAG_CHECK_ENTITIES_DESCRIPTOR_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_LOAD_METADATA_FLAG_CHECK_ENTITY_DESCRIPTOR_SIGNATURE", LASSO_SERVER_LOAD_METADATA_FLAG_CHECK_ENTITY_DESCRIPTOR_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SERVER_LOAD_METADATA_FLAG_INHERIT_SIGNATURE", LASSO_SERVER_LOAD_METADATA_FLAG_INHERIT_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_ART", LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_ART, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_POST", LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_POST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_LECP", LASSO_LOGIN_PROTOCOL_PROFILE_BRWS_LECP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LOGIN_PROTOCOL_PROFILE_REDIRECT", LASSO_LOGIN_PROTOCOL_PROFILE_REDIRECT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SAML2_ASSERTION_VALID", LASSO_SAML2_ASSERTION_VALID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SAML2_ASSERTION_INVALID", LASSO_SAML2_ASSERTION_INVALID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SAML2_ASSERTION_INDETERMINATE", LASSO_SAML2_ASSERTION_INDETERMINATE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DURATION_MINUTE", LASSO_DURATION_MINUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DURATION_HOUR", LASSO_DURATION_HOUR, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DURATION_DAY", LASSO_DURATION_DAY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_DURATION_WEEK", LASSO_DURATION_WEEK, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_REQUEST_TYPE_UNSET", LASSO_ASSERTION_QUERY_REQUEST_TYPE_UNSET, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_REQUEST_TYPE_ASSERTION_ID", LASSO_ASSERTION_QUERY_REQUEST_TYPE_ASSERTION_ID, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_REQUEST_TYPE_AUTHN", LASSO_ASSERTION_QUERY_REQUEST_TYPE_AUTHN, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_REQUEST_TYPE_ATTRIBUTE", LASSO_ASSERTION_QUERY_REQUEST_TYPE_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_REQUEST_TYPE_AUTHZ_DECISION", LASSO_ASSERTION_QUERY_REQUEST_TYPE_AUTHZ_DECISION, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ASSERTION_QUERY_REQUEST_TYPE_LAST", LASSO_ASSERTION_QUERY_REQUEST_TYPE_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_SYM_KEY_TYPE_DEFAULT", LASSO_ENCRYPTION_SYM_KEY_TYPE_DEFAULT, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_SYM_KEY_TYPE_AES_256", LASSO_ENCRYPTION_SYM_KEY_TYPE_AES_256, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_SYM_KEY_TYPE_AES_128", LASSO_ENCRYPTION_SYM_KEY_TYPE_AES_128, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYPTION_SYM_KEY_TYPE_3DES", LASSO_ENCRYPTION_SYM_KEY_TYPE_3DES, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_ENCRYTPION_SYM_KEY_TYPE_LAST", LASSO_ENCRYTPION_SYM_KEY_TYPE_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_XSCHEMA_ERROR", LASSO_MESSAGE_FORMAT_XSCHEMA_ERROR, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_ERROR", LASSO_MESSAGE_FORMAT_ERROR, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_UNKNOWN", LASSO_MESSAGE_FORMAT_UNKNOWN, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_XML", LASSO_MESSAGE_FORMAT_XML, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_BASE64", LASSO_MESSAGE_FORMAT_BASE64, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_QUERY", LASSO_MESSAGE_FORMAT_QUERY, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_MESSAGE_FORMAT_SOAP", LASSO_MESSAGE_FORMAT_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_TYPE_NONE", LASSO_SIGNATURE_TYPE_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_TYPE_SIMPLE", LASSO_SIGNATURE_TYPE_SIMPLE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_TYPE_WITHX509", LASSO_SIGNATURE_TYPE_WITHX509, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_TYPE_LAST", LASSO_SIGNATURE_TYPE_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_METHOD_NONE", LASSO_SIGNATURE_METHOD_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_METHOD_RSA_SHA1", LASSO_SIGNATURE_METHOD_RSA_SHA1, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_METHOD_DSA_SHA1", LASSO_SIGNATURE_METHOD_DSA_SHA1, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_METHOD_HMAC_SHA1", LASSO_SIGNATURE_METHOD_HMAC_SHA1, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SIGNATURE_METHOD_LAST", LASSO_SIGNATURE_METHOD_LAST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_ENV_HREF", (char*) LASSO_SOAP_ENV_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_ENV_PREFIX", (char*) LASSO_SOAP_ENV_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_ENV_ACTOR", (char*) LASSO_SOAP_ENV_ACTOR, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_FAULT_CODE_SERVER", (char*) LASSO_SOAP_FAULT_CODE_SERVER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_FAULT_CODE_CLIENT", (char*) LASSO_SOAP_FAULT_CODE_CLIENT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_FAULT_CODE_MUST_UNDERSTAND", (char*) LASSO_SOAP_FAULT_CODE_MUST_UNDERSTAND, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SOAP_FAULT_CODE_VERSION_MISMATCH", (char*) LASSO_SOAP_FAULT_CODE_VERSION_MISMATCH, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_PRIVATE_STATUS_CODE_FAILED_TO_RESTORE_ARTIFACT", (char*) LASSO_PRIVATE_STATUS_CODE_FAILED_TO_RESTORE_ARTIFACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_WSUTIL1_HREF", (char*) LASSO_WSUTIL1_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_WSUTIL1_PREFIX", (char*) LASSO_WSUTIL1_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_XMLENC_HREF", (char*) LASSO_XMLENC_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_XMLENC_PREFIX", (char*) LASSO_XMLENC_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LASSO_HREF", (char*) LASSO_LASSO_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LASSO_PREFIX", (char*) LASSO_LASSO_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_PYTHON_HREF", (char*) LASSO_PYTHON_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SIGNATURE_TYPE_ATTRIBUTE", (char*) LASSO_SIGNATURE_TYPE_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SIGNATURE_METHOD_ATTRIBUTE", (char*) LASSO_SIGNATURE_METHOD_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_PRIVATE_KEY_ATTRIBUTE", (char*) LASSO_PRIVATE_KEY_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_PRIVATE_KEY_PASSWORD_ATTRIBUTE", (char*) LASSO_PRIVATE_KEY_PASSWORD_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_CERTIFICATE_ATTRIBUTE", (char*) LASSO_CERTIFICATE_ATTRIBUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_HREF", (char*) LASSO_LIB_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PREFIX", (char*) LASSO_LIB_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LIB_MAJOR_VERSION_N", LASSO_LIB_MAJOR_VERSION_N, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_LIB_MINOR_VERSION_N", LASSO_LIB_MINOR_VERSION_N, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAMEID_POLICY_TYPE_NONE", (char*) LASSO_LIB_NAMEID_POLICY_TYPE_NONE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAMEID_POLICY_TYPE_ONE_TIME", (char*) LASSO_LIB_NAMEID_POLICY_TYPE_ONE_TIME, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAMEID_POLICY_TYPE_FEDERATED", (char*) LASSO_LIB_NAMEID_POLICY_TYPE_FEDERATED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAMEID_POLICY_TYPE_ANY", (char*) LASSO_LIB_NAMEID_POLICY_TYPE_ANY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL_PASSWORD", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_UNREGISTERED", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_UNREGISTERED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_UNREGISTERED", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_UNREGISTERED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_CONTRACT", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_CONTRACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_CONTRACT", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_CONTRACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD_PROTECTED_TRANSPORT", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD_PROTECTED_TRANSPORT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_PREVIOUS_SESSION", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_PREVIOUS_SESSION, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD_PKI", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_SOFTWARE_PKI", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_SOFTWARE_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_TIME_SYNC_TOKEN", (char*) LASSO_LIB_AUTHN_CONTEXT_CLASS_REF_TIME_SYNC_TOKEN, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_COMPARISON_EXACT", (char*) LASSO_LIB_AUTHN_CONTEXT_COMPARISON_EXACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_COMPARISON_MINIMUM", (char*) LASSO_LIB_AUTHN_CONTEXT_COMPARISON_MINIMUM, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_COMPARISON_MAXIMUM", (char*) LASSO_LIB_AUTHN_CONTEXT_COMPARISON_MAXIMUM, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_AUTHN_CONTEXT_COMPARISON_BETTER", (char*) LASSO_LIB_AUTHN_CONTEXT_COMPARISON_BETTER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_FEDERATION_DOES_NOT_EXIST", (char*) LASSO_LIB_STATUS_CODE_FEDERATION_DOES_NOT_EXIST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_INVALID_ASSERTION_CONSUMER_SERVICE_INDEX", (char*) LASSO_LIB_STATUS_CODE_INVALID_ASSERTION_CONSUMER_SERVICE_INDEX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_INVALID_SIGNATURE", (char*) LASSO_LIB_STATUS_CODE_INVALID_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_NO_AUTHN_CONTEXT", (char*) LASSO_LIB_STATUS_CODE_NO_AUTHN_CONTEXT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_NO_AVAILABLEIDP", (char*) LASSO_LIB_STATUS_CODE_NO_AVAILABLEIDP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_NO_PASSIVE", (char*) LASSO_LIB_STATUS_CODE_NO_PASSIVE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_NO_SUPPORTEDIDP", (char*) LASSO_LIB_STATUS_CODE_NO_SUPPORTEDIDP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_PROXY_COUNT_EXCEEDED", (char*) LASSO_LIB_STATUS_CODE_PROXY_COUNT_EXCEEDED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_UNKNOWN_PRINCIPAL", (char*) LASSO_LIB_STATUS_CODE_UNKNOWN_PRINCIPAL, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_UNSIGNED_AUTHN_REQUEST", (char*) LASSO_LIB_STATUS_CODE_UNSIGNED_AUTHN_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_STATUS_CODE_UNSUPPORTED_PROFILE", (char*) LASSO_LIB_STATUS_CODE_UNSUPPORTED_PROFILE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_BRWS_ART", (char*) LASSO_LIB_PROTOCOL_PROFILE_BRWS_ART, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_BRWS_POST", (char*) LASSO_LIB_PROTOCOL_PROFILE_BRWS_POST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_BRWS_LECP", (char*) LASSO_LIB_PROTOCOL_PROFILE_BRWS_LECP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_IDP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_IDP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_IDP_SOAP", (char*) LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_IDP_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_SP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_SP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_SP_SOAP", (char*) LASSO_LIB_PROTOCOL_PROFILE_FED_TERM_SP_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_NIM_SP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_NIM_SP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_RNI_IDP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_RNI_IDP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_RNI_IDP_SOAP", (char*) LASSO_LIB_PROTOCOL_PROFILE_RNI_IDP_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_RNI_SP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_RNI_SP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_RNI_SP_SOAP", (char*) LASSO_LIB_PROTOCOL_PROFILE_RNI_SP_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_SLO_SP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_SLO_SP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_SLO_SP_SOAP", (char*) LASSO_LIB_PROTOCOL_PROFILE_SLO_SP_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_SLO_IDP_HTTP", (char*) LASSO_LIB_PROTOCOL_PROFILE_SLO_IDP_HTTP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_PROTOCOL_PROFILE_SLO_IDP_SOAP", (char*) LASSO_LIB_PROTOCOL_PROFILE_SLO_IDP_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAME_IDENTIFIER_FORMAT_FEDERATED", (char*) LASSO_LIB_NAME_IDENTIFIER_FORMAT_FEDERATED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAME_IDENTIFIER_FORMAT_ONE_TIME", (char*) LASSO_LIB_NAME_IDENTIFIER_FORMAT_ONE_TIME, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAME_IDENTIFIER_FORMAT_ENCRYPTED", (char*) LASSO_LIB_NAME_IDENTIFIER_FORMAT_ENCRYPTED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_NAME_IDENTIFIER_FORMAT_ENTITYID", (char*) LASSO_LIB_NAME_IDENTIFIER_FORMAT_ENTITYID, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_CONSENT_OBTAINED", (char*) LASSO_LIB_CONSENT_OBTAINED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_CONSENT_OBTAINED_PRIOR", (char*) LASSO_LIB_CONSENT_OBTAINED_PRIOR, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_CONSENT_OBTAINED_CURRENT_IMPLICIT", (char*) LASSO_LIB_CONSENT_OBTAINED_CURRENT_IMPLICIT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_CONSENT_OBTAINED_CURRENT_EXPLICIT", (char*) LASSO_LIB_CONSENT_OBTAINED_CURRENT_EXPLICIT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_CONSENT_UNAVAILABLE", (char*) LASSO_LIB_CONSENT_UNAVAILABLE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_LIB_CONSENT_INAPPLICABLE", (char*) LASSO_LIB_CONSENT_INAPPLICABLE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_METADATA_HREF", (char*) LASSO_METADATA_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_METADATA_PREFIX", (char*) LASSO_METADATA_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_ASSERTION_HREF", (char*) LASSO_SAML_ASSERTION_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_ASSERTION_PREFIX", (char*) LASSO_SAML_ASSERTION_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_PROTOCOL_HREF", (char*) LASSO_SAML_PROTOCOL_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_PROTOCOL_PREFIX", (char*) LASSO_SAML_PROTOCOL_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SAML_MAJOR_VERSION_N", LASSO_SAML_MAJOR_VERSION_N, CONST_CS|CONST_PERSISTENT);
    REGISTER_LONG_CONSTANT("LASSO_SAML_MINOR_VERSION_N", LASSO_SAML_MINOR_VERSION_N, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_SUCCESS", (char*) LASSO_SAML_STATUS_CODE_SUCCESS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_VERSION_MISMATCH", (char*) LASSO_SAML_STATUS_CODE_VERSION_MISMATCH, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_REQUESTER", (char*) LASSO_SAML_STATUS_CODE_REQUESTER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_RESPONDER", (char*) LASSO_SAML_STATUS_CODE_RESPONDER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_REQUEST_VERSION_TOO_HIGH", (char*) LASSO_SAML_STATUS_CODE_REQUEST_VERSION_TOO_HIGH, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_REQUEST_VERSION_TOO_LOW", (char*) LASSO_SAML_STATUS_CODE_REQUEST_VERSION_TOO_LOW, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_REQUEST_VERSION_DEPRECATED", (char*) LASSO_SAML_STATUS_CODE_REQUEST_VERSION_DEPRECATED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_TOO_MANY_RESPONSES", (char*) LASSO_SAML_STATUS_CODE_TOO_MANY_RESPONSES, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_RESOURCE_NOT_RECOGNIZED", (char*) LASSO_SAML_STATUS_CODE_RESOURCE_NOT_RECOGNIZED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_STATUS_CODE_REQUEST_DENIED", (char*) LASSO_SAML_STATUS_CODE_REQUEST_DENIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_PASSWORD", (char*) LASSO_SAML_AUTHENTICATION_METHOD_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_KERBEROS", (char*) LASSO_SAML_AUTHENTICATION_METHOD_KERBEROS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_SECURE_REMOTE_PASSWORD", (char*) LASSO_SAML_AUTHENTICATION_METHOD_SECURE_REMOTE_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_HARDWARE_TOKEN", (char*) LASSO_SAML_AUTHENTICATION_METHOD_HARDWARE_TOKEN, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_SMARTCARD_PKI", (char*) LASSO_SAML_AUTHENTICATION_METHOD_SMARTCARD_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_SOFTWARE_PKI", (char*) LASSO_SAML_AUTHENTICATION_METHOD_SOFTWARE_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_PGP", (char*) LASSO_SAML_AUTHENTICATION_METHOD_PGP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHODS_PKI", (char*) LASSO_SAML_AUTHENTICATION_METHODS_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_XKMS", (char*) LASSO_SAML_AUTHENTICATION_METHOD_XKMS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_XMLD_SIG", (char*) LASSO_SAML_AUTHENTICATION_METHOD_XMLD_SIG, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_UNSPECIFIED", (char*) LASSO_SAML_AUTHENTICATION_METHOD_UNSPECIFIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_AUTHENTICATION_METHOD_LIBERTY", (char*) LASSO_SAML_AUTHENTICATION_METHOD_LIBERTY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_CONFIRMATION_METHOD_ARTIFACT", (char*) LASSO_SAML_CONFIRMATION_METHOD_ARTIFACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_CONFIRMATION_METHOD_ARTIFACT01", (char*) LASSO_SAML_CONFIRMATION_METHOD_ARTIFACT01, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_CONFIRMATION_METHOD_BEARER", (char*) LASSO_SAML_CONFIRMATION_METHOD_BEARER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_CONFIRMATION_METHOD_HOLDER_OF_KEY", (char*) LASSO_SAML_CONFIRMATION_METHOD_HOLDER_OF_KEY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML_CONFIRMATION_METHOD_SENDER_VOUCHES", (char*) LASSO_SAML_CONFIRMATION_METHOD_SENDER_VOUCHES, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_PAOS_HREF", (char*) LASSO_PAOS_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_PAOS_PREFIX", (char*) LASSO_PAOS_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_ECP_HREF", (char*) LASSO_ECP_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_ECP_PREFIX", (char*) LASSO_ECP_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_XSI_HREF", (char*) LASSO_XSI_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_XSI_PREFIX", (char*) LASSO_XSI_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_HREF", (char*) LASSO_SAML2_METADATA_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_PREFIX", (char*) LASSO_SAML2_METADATA_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_PROTOCOL_HREF", (char*) LASSO_SAML2_PROTOCOL_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_PROTOCOL_PREFIX", (char*) LASSO_SAML2_PROTOCOL_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ASSERTION_HREF", (char*) LASSO_SAML2_ASSERTION_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ASSERTION_PREFIX", (char*) LASSO_SAML2_ASSERTION_PREFIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_BINDING_SOAP", (char*) LASSO_SAML2_METADATA_BINDING_SOAP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_BINDING_REDIRECT", (char*) LASSO_SAML2_METADATA_BINDING_REDIRECT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_BINDING_POST", (char*) LASSO_SAML2_METADATA_BINDING_POST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_BINDING_ARTIFACT", (char*) LASSO_SAML2_METADATA_BINDING_ARTIFACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_BINDING_PAOS", (char*) LASSO_SAML2_METADATA_BINDING_PAOS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_METADATA_BINDING_URI", (char*) LASSO_SAML2_METADATA_BINDING_URI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_DEFLATE_ENCODING", (char*) LASSO_SAML2_DEFLATE_ENCODING, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_UNSPECIFIED", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_UNSPECIFIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_EMAIL", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_EMAIL, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_X509", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_X509, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_WINDOWS", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_WINDOWS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_KERBEROS", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_KERBEROS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_ENTITY", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_ENTITY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_PERSISTENT", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_PERSISTENT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_TRANSIENT", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_TRANSIENT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_NAME_IDENTIFIER_FORMAT_ENCRYPTED", (char*) LASSO_SAML2_NAME_IDENTIFIER_FORMAT_ENCRYPTED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_NAME_EPR", (char*) LASSO_SAML2_ATTRIBUTE_NAME_EPR, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_NAME_FORMAT_UNSPECIFIED", (char*) LASSO_SAML2_ATTRIBUTE_NAME_FORMAT_UNSPECIFIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_NAME_FORMAT_URI", (char*) LASSO_SAML2_ATTRIBUTE_NAME_FORMAT_URI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_NAME_FORMAT_BASIC", (char*) LASSO_SAML2_ATTRIBUTE_NAME_FORMAT_BASIC, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_NAMESPACE_RWEDC", (char*) LASSO_SAML2_ACTION_NAMESPACE_RWEDC, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_NAMESPACE_RWEDC_NEGATION", (char*) LASSO_SAML2_ACTION_NAMESPACE_RWEDC_NEGATION, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_NAMESPACE_GHPP", (char*) LASSO_SAML2_ACTION_NAMESPACE_GHPP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_NAMESPACE_UNIX", (char*) LASSO_SAML2_ACTION_NAMESPACE_UNIX, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_RWEDC_READ", (char*) LASSO_SAML2_ACTION_RWEDC_READ, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_RWEDC_WRITE", (char*) LASSO_SAML2_ACTION_RWEDC_WRITE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_RWEDC_EXECUTE", (char*) LASSO_SAML2_ACTION_RWEDC_EXECUTE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_RWEDC_DELETE", (char*) LASSO_SAML2_ACTION_RWEDC_DELETE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_RWEDC_CONTROL", (char*) LASSO_SAML2_ACTION_RWEDC_CONTROL, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_RWEDC_NEGATION", (char*) LASSO_SAML2_ACTION_RWEDC_NEGATION, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_GHPP_GET", (char*) LASSO_SAML2_ACTION_GHPP_GET, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_GHPP_HEAD", (char*) LASSO_SAML2_ACTION_GHPP_HEAD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_GHPP_PUT", (char*) LASSO_SAML2_ACTION_GHPP_PUT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ACTION_GHPP_POST", (char*) LASSO_SAML2_ACTION_GHPP_POST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONSENT_OBTAINED", (char*) LASSO_SAML2_CONSENT_OBTAINED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONSENT_PRIOR", (char*) LASSO_SAML2_CONSENT_PRIOR, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONSENT_IMPLICIT", (char*) LASSO_SAML2_CONSENT_IMPLICIT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONSENT_EXPLICIT", (char*) LASSO_SAML2_CONSENT_EXPLICIT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONSENT_UNAVAILABLE", (char*) LASSO_SAML2_CONSENT_UNAVAILABLE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONSENT_INAPPLICABLE", (char*) LASSO_SAML2_CONSENT_INAPPLICABLE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_SUCCESS", (char*) LASSO_SAML2_STATUS_CODE_SUCCESS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_REQUESTER", (char*) LASSO_SAML2_STATUS_CODE_REQUESTER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_RESPONDER", (char*) LASSO_SAML2_STATUS_CODE_RESPONDER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_VERSION_MISMATCH", (char*) LASSO_SAML2_STATUS_CODE_VERSION_MISMATCH, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_AUTHN_FAILED", (char*) LASSO_SAML2_STATUS_CODE_AUTHN_FAILED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_INVALID_ATTR_NAME", (char*) LASSO_SAML2_STATUS_CODE_INVALID_ATTR_NAME, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_INVALID_NAME_ID_POLICY", (char*) LASSO_SAML2_STATUS_CODE_INVALID_NAME_ID_POLICY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_NO_AUTHN_CONTEXT", (char*) LASSO_SAML2_STATUS_CODE_NO_AUTHN_CONTEXT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_NO_AVAILABLE_IDP", (char*) LASSO_SAML2_STATUS_CODE_NO_AVAILABLE_IDP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_NO_PASSIVE", (char*) LASSO_SAML2_STATUS_CODE_NO_PASSIVE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_NO_SUPPORTED_IDP", (char*) LASSO_SAML2_STATUS_CODE_NO_SUPPORTED_IDP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_PARTIAL_LOGOUT", (char*) LASSO_SAML2_STATUS_CODE_PARTIAL_LOGOUT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_PROXY_COUNT_EXCEEDED", (char*) LASSO_SAML2_STATUS_CODE_PROXY_COUNT_EXCEEDED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_REQUEST_DENIED", (char*) LASSO_SAML2_STATUS_CODE_REQUEST_DENIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_REQUEST_UNSUPPORTED", (char*) LASSO_SAML2_STATUS_CODE_REQUEST_UNSUPPORTED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_REQUEST_VERSION_DEPRECATED", (char*) LASSO_SAML2_STATUS_CODE_REQUEST_VERSION_DEPRECATED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_REQUEST_VERSION_TOO_HIGH", (char*) LASSO_SAML2_STATUS_CODE_REQUEST_VERSION_TOO_HIGH, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_REQUEST_VERSION_TOO_LOW", (char*) LASSO_SAML2_STATUS_CODE_REQUEST_VERSION_TOO_LOW, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_RESOURCE_NOT_RECOGNIZED", (char*) LASSO_SAML2_STATUS_CODE_RESOURCE_NOT_RECOGNIZED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_TOO_MANY_RESPONSES", (char*) LASSO_SAML2_STATUS_CODE_TOO_MANY_RESPONSES, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_UNKNOWN_ATTR_PROFILE", (char*) LASSO_SAML2_STATUS_CODE_UNKNOWN_ATTR_PROFILE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_UNKNOWN_PRINCIPAL", (char*) LASSO_SAML2_STATUS_CODE_UNKNOWN_PRINCIPAL, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_STATUS_CODE_UNSUPPORTED_BINDING", (char*) LASSO_SAML2_STATUS_CODE_UNSUPPORTED_BINDING, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_AUTHENTICATED_TELEPHONY", (char*) LASSO_SAML2_AUTHN_CONTEXT_AUTHENTICATED_TELEPHONY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL", (char*) LASSO_SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL_PASSWORD", (char*) LASSO_SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_KERBEROS", (char*) LASSO_SAML2_AUTHN_CONTEXT_KERBEROS, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_CONTRACT", (char*) LASSO_SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_CONTRACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_UNREGISTERED", (char*) LASSO_SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_UNREGISTERED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_CONTRACT", (char*) LASSO_SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_CONTRACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_UNREGISTERED", (char*) LASSO_SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_UNREGISTERED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_NOMAD_TELEPHONY", (char*) LASSO_SAML2_AUTHN_CONTEXT_NOMAD_TELEPHONY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_PERSONALIZED_TELEPHONY", (char*) LASSO_SAML2_AUTHN_CONTEXT_PERSONALIZED_TELEPHONY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_PGP", (char*) LASSO_SAML2_AUTHN_CONTEXT_PGP, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_PASSWORD_PROTECTED_TRANSPORT", (char*) LASSO_SAML2_AUTHN_CONTEXT_PASSWORD_PROTECTED_TRANSPORT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_PASSWORD", (char*) LASSO_SAML2_AUTHN_CONTEXT_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_PREVIOUS_SESSION", (char*) LASSO_SAML2_AUTHN_CONTEXT_PREVIOUS_SESSION, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_SMARTCARD", (char*) LASSO_SAML2_AUTHN_CONTEXT_SMARTCARD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_SMARTCARD_PKI", (char*) LASSO_SAML2_AUTHN_CONTEXT_SMARTCARD_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_SOFTWARE_PKI", (char*) LASSO_SAML2_AUTHN_CONTEXT_SOFTWARE_PKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_SPKI", (char*) LASSO_SAML2_AUTHN_CONTEXT_SPKI, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_SECURE_REMOTE_PASSWORD", (char*) LASSO_SAML2_AUTHN_CONTEXT_SECURE_REMOTE_PASSWORD, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_TLS_CLIENT", (char*) LASSO_SAML2_AUTHN_CONTEXT_TLS_CLIENT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_X509", (char*) LASSO_SAML2_AUTHN_CONTEXT_X509, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_TELEPHONY", (char*) LASSO_SAML2_AUTHN_CONTEXT_TELEPHONY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_TIME_SYNC_TOKEN", (char*) LASSO_SAML2_AUTHN_CONTEXT_TIME_SYNC_TOKEN, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_XMLDSIG", (char*) LASSO_SAML2_AUTHN_CONTEXT_XMLDSIG, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_AUTHN_CONTEXT_UNSPECIFIED", (char*) LASSO_SAML2_AUTHN_CONTEXT_UNSPECIFIED, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONFIRMATION_METHOD_BEARER", (char*) LASSO_SAML2_CONFIRMATION_METHOD_BEARER, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_CONFIRMATION_METHOD_HOLDER_OF_KEY", (char*) LASSO_SAML2_CONFIRMATION_METHOD_HOLDER_OF_KEY, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_ENCODING", (char*) LASSO_SAML2_FIELD_ENCODING, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_RESPONSE", (char*) LASSO_SAML2_FIELD_RESPONSE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_REQUEST", (char*) LASSO_SAML2_FIELD_REQUEST, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_ARTIFACT", (char*) LASSO_SAML2_FIELD_ARTIFACT, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_RELAYSTATE", (char*) LASSO_SAML2_FIELD_RELAYSTATE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_SIGNATURE", (char*) LASSO_SAML2_FIELD_SIGNATURE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_FIELD_SIGALG", (char*) LASSO_SAML2_FIELD_SIGALG, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_PROFILE_BASIC", (char*) LASSO_SAML2_ATTRIBUTE_PROFILE_BASIC, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_PROFILE_X500", (char*) LASSO_SAML2_ATTRIBUTE_PROFILE_X500, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_PROFILE_UUID", (char*) LASSO_SAML2_ATTRIBUTE_PROFILE_UUID, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_SAML2_ATTRIBUTE_PROFILE_DCE", (char*) LASSO_SAML2_ATTRIBUTE_PROFILE_DCE, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_DS_HREF", (char*) LASSO_DS_HREF, CONST_CS|CONST_PERSISTENT);
    REGISTER_STRING_CONSTANT("LASSO_DS_PREFIX", (char*) LASSO_DS_PREFIX, CONST_CS|CONST_PERSISTENT);
#ifdef LASSO_WSF_ENABLED
    REGISTER_LONG_CONSTANT("LASSO_WSF_ENABLED", 1, CONST_CS|CONST_PERSISTENT);
#else
    REGISTER_LONG_CONSTANT("LASSO_WSF_ENABLED", 0, CONST_CS|CONST_PERSISTENT);
#endif

    return SUCCESS;
}

PHP_MSHUTDOWN_FUNCTION(lasso)
{
    lasso_shutdown();
    return SUCCESS;
}


PHP_FUNCTION(strError)
{
    long error_code;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &error_code) == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  lasso_strerror(error_code);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_check_version)
{
    long major;
    long minor;
    long subminor;
    long mode;
    int return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "llll", &major, &minor, &subminor, &mode) == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  lasso_check_version(major, minor, subminor, mode);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_set_flag)
{
    char* flag = NULL;
    char* flag_str = NULL;
    int flag_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &flag_str, &flag_len) == FAILURE) {
        RETURN_FALSE;
    }

        flag = flag_str;
    lasso_set_flag(flag);
}

PHP_FUNCTION(lasso_key_new_for_signature_from_base64_string)
{
    char* base64_string = NULL;
    char* base64_string_str = NULL;
    int base64_string_len = 0;
    char* password = NULL;
    char* password_str = NULL;
    int password_len = 0;
    long signature_method;
    char* certificate = NULL;
    char* certificate_str = NULL;
    int certificate_len = 0;
    LassoKey* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!ls!", &base64_string_str, &base64_string_len, &password_str, &password_len, &signature_method, &certificate_str, &certificate_len) == FAILURE) {
        RETURN_FALSE;
    }

        base64_string = base64_string_str;
        password = password_str;
        certificate = certificate_str;
    return_c_value =  (LassoKey*) lasso_key_new_for_signature_from_base64_string(base64_string, password, signature_method, certificate);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_key_new_for_signature_from_file)
{
    char* filename_or_buffer = NULL;
    char* filename_or_buffer_str = NULL;
    int filename_or_buffer_len = 0;
    char* password = NULL;
    char* password_str = NULL;
    int password_len = 0;
    long signature_method;
    char* certificate = NULL;
    char* certificate_str = NULL;
    int certificate_len = 0;
    LassoKey* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!ls!", &filename_or_buffer_str, &filename_or_buffer_len, &password_str, &password_len, &signature_method, &certificate_str, &certificate_len) == FAILURE) {
        RETURN_FALSE;
    }

        filename_or_buffer = filename_or_buffer_str;
        password = password_str;
        certificate = certificate_str;
    return_c_value =  (LassoKey*) lasso_key_new_for_signature_from_file(filename_or_buffer, password, signature_method, certificate);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_identity_new)
{
    LassoIdentity* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoIdentity*) lasso_identity_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_identity_new_from_dump)
{
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoIdentity* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

        dump = dump_str;
    return_c_value =  (LassoIdentity*) lasso_identity_new_from_dump(dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_provider_new)
{
    long role;
    char* metadata = NULL;
    char* metadata_str = NULL;
    int metadata_len = 0;
    char* public_key = NULL;
    char* public_key_str = NULL;
    int public_key_len = 0;
    char* ca_cert_chain = NULL;
    char* ca_cert_chain_str = NULL;
    int ca_cert_chain_len = 0;
    LassoProvider* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls!s!s!", &role, &metadata_str, &metadata_len, &public_key_str, &public_key_len, &ca_cert_chain_str, &ca_cert_chain_len) == FAILURE) {
        RETURN_FALSE;
    }

        metadata = metadata_str;
        public_key = public_key_str;
        ca_cert_chain = ca_cert_chain_str;
    return_c_value =  (LassoProvider*) lasso_provider_new(role, metadata, public_key, ca_cert_chain);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_provider_new_from_buffer)
{
    long role;
    char* metadata = NULL;
    char* metadata_str = NULL;
    int metadata_len = 0;
    char* public_key = NULL;
    char* public_key_str = NULL;
    int public_key_len = 0;
    char* ca_cert_chain = NULL;
    char* ca_cert_chain_str = NULL;
    int ca_cert_chain_len = 0;
    LassoProvider* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls!s!s!", &role, &metadata_str, &metadata_len, &public_key_str, &public_key_len, &ca_cert_chain_str, &ca_cert_chain_len) == FAILURE) {
        RETURN_FALSE;
    }

        metadata = metadata_str;
        public_key = public_key_str;
        ca_cert_chain = ca_cert_chain_str;
    return_c_value =  (LassoProvider*) lasso_provider_new_from_buffer(role, metadata, public_key, ca_cert_chain);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_provider_new_from_dump)
{
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoProvider* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

        dump = dump_str;
    return_c_value =  (LassoProvider*) lasso_provider_new_from_dump(dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_defederation_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoDefederation* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoDefederation*) lasso_defederation_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_get_request_type_from_soap_msg)
{
    char* soap = NULL;
    char* soap_str = NULL;
    int soap_len = 0;
    LassoRequestType return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &soap_str, &soap_len) == FAILURE) {
        RETURN_FALSE;
    }

        soap = soap_str;
    return_c_value =  lasso_profile_get_request_type_from_soap_msg(soap);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(isLibertyQuery)
{
    char* query = NULL;
    char* query_str = NULL;
    int query_len = 0;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &query_str, &query_len) == FAILURE) {
        RETURN_FALSE;
    }

        query = query_str;
    return_c_value =  lasso_profile_is_liberty_query(query);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_server_new)
{
    char* metadata = NULL;
    char* metadata_str = NULL;
    int metadata_len = 0;
    char* private_key = NULL;
    char* private_key_str = NULL;
    int private_key_len = 0;
    char* private_key_password = NULL;
    char* private_key_password_str = NULL;
    int private_key_password_len = 0;
    char* certificate = NULL;
    char* certificate_str = NULL;
    int certificate_len = 0;
    LassoServer* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!s!s!", &metadata_str, &metadata_len, &private_key_str, &private_key_len, &private_key_password_str, &private_key_password_len, &certificate_str, &certificate_len) == FAILURE) {
        RETURN_FALSE;
    }

        metadata = metadata_str;
        private_key = private_key_str;
        private_key_password = private_key_password_str;
        certificate = certificate_str;
    return_c_value =  (LassoServer*) lasso_server_new(metadata, private_key, private_key_password, certificate);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_server_new_from_buffers)
{
    char* metadata = NULL;
    char* metadata_str = NULL;
    int metadata_len = 0;
    char* private_key_content = NULL;
    char* private_key_content_str = NULL;
    int private_key_content_len = 0;
    char* private_key_password = NULL;
    char* private_key_password_str = NULL;
    int private_key_password_len = 0;
    char* certificate_content = NULL;
    char* certificate_content_str = NULL;
    int certificate_content_len = 0;
    LassoServer* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!s!s!", &metadata_str, &metadata_len, &private_key_content_str, &private_key_content_len, &private_key_password_str, &private_key_password_len, &certificate_content_str, &certificate_content_len) == FAILURE) {
        RETURN_FALSE;
    }

        metadata = metadata_str;
        private_key_content = private_key_content_str;
        private_key_password = private_key_password_str;
        certificate_content = certificate_content_str;
    return_c_value =  (LassoServer*) lasso_server_new_from_buffers(metadata, private_key_content, private_key_password, certificate_content);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_server_new_from_dump)
{
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoServer* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

        dump = dump_str;
    return_c_value =  (LassoServer*) lasso_server_new_from_dump(dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_logout_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoLogout* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoLogout*) lasso_logout_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_logout_new_from_dump)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoLogout* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        dump = dump_str;
    return_c_value =  (LassoLogout*) lasso_logout_new_from_dump(server, dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_name_identifier_mapping_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoNameIdentifierMapping* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoNameIdentifierMapping*) lasso_name_identifier_mapping_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_session_new)
{
    LassoSession* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSession*) lasso_session_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_session_new_from_dump)
{
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoSession* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

        dump = dump_str;
    return_c_value =  (LassoSession*) lasso_session_new_from_dump(dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lecp_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoLecp* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoLecp*) lasso_lecp_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_login_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoLogin* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoLogin*) lasso_login_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_login_new_from_dump)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoLogin* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        dump = dump_str;
    return_c_value =  (LassoLogin*) lasso_login_new_from_dump(server, dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_federation_new)
{
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    LassoFederation* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

        remote_providerID = remote_providerID_str;
    return_c_value =  (LassoFederation*) lasso_federation_new(remote_providerID);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoNameRegistration* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoNameRegistration*) lasso_name_registration_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_new_from_dump)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoNameRegistration* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        dump = dump_str;
    return_c_value =  (LassoNameRegistration*) lasso_name_registration_new_from_dump(server, dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(isSamlQuery)
{
    char* query = NULL;
    char* query_str = NULL;
    int query_len = 0;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &query_str, &query_len) == FAILURE) {
        RETURN_FALSE;
    }

        query = query_str;
    return_c_value =  lasso_profile_is_saml_query(query);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_saml2_name_id_build_persistent)
{
    char* id = NULL;
    char* id_str = NULL;
    int id_len = 0;
    char* idpID = NULL;
    char* idpID_str = NULL;
    int idpID_len = 0;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoSaml2NameID* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!s!", &id_str, &id_len, &idpID_str, &idpID_len, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

        id = id_str;
        idpID = idpID_str;
        providerID = providerID_str;
    return_c_value =  lasso_saml2_name_id_build_persistent(id, idpID, providerID);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_encrypted_element_build_encrypted_persistent_name_id)
{
    char* id = NULL;
    char* id_str = NULL;
    int id_len = 0;
    char* idpID = NULL;
    char* idpID_str = NULL;
    int idpID_len = 0;
    const LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoSaml2EncryptedElement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!r", &id_str, &id_len, &idpID_str, &idpID_len, &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

        id = id_str;
        idpID = idpID_str;
    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (const LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_saml2_encrypted_element_build_encrypted_persistent_name_id(id, idpID, provider);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_name_id_new_with_persistent_format)
{
    char* id = NULL;
    char* id_str = NULL;
    int id_len = 0;
    char* idpID = NULL;
    char* idpID_str = NULL;
    int idpID_len = 0;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoSaml2NameID* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!s!", &id_str, &id_len, &idpID_str, &idpID_len, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

        id = id_str;
        idpID = idpID_str;
        providerID = providerID_str;
    return_c_value =  (LassoSaml2NameID*) lasso_saml2_name_id_new_with_persistent_format(id, idpID, providerID);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_ecp_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoEcp* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoEcp*) lasso_ecp_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoNameIdManagement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoNameIdManagement*) lasso_name_id_management_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_new_from_dump)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoNameIdManagement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        dump = dump_str;
    return_c_value =  (LassoNameIdManagement*) lasso_name_id_management_new_from_dump(server, dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_new)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoAssertionQuery* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  (LassoAssertionQuery*) lasso_assertion_query_new(server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_assertion_new)
{
    LassoSamlAssertion* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlAssertion*) lasso_saml_assertion_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_request_authn_context_new)
{
    LassoLibRequestAuthnContext* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibRequestAuthnContext*) lasso_lib_request_authn_context_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authn_request_envelope_new)
{
    LassoLibAuthnRequestEnvelope* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibAuthnRequestEnvelope*) lasso_lib_authn_request_envelope_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authn_request_envelope_new_full)
{
    LassoLibAuthnRequest* authnRequest = NULL;
    zval* zval_authnRequest = NULL;
    PhpGObjectPtr* cvt_authnRequest = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    char* assertionConsumerServiceURL = NULL;
    char* assertionConsumerServiceURL_str = NULL;
    int assertionConsumerServiceURL_len = 0;
    LassoLibAuthnRequestEnvelope* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_authnRequest, &providerID_str, &providerID_len, &assertionConsumerServiceURL_str, &assertionConsumerServiceURL_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_authnRequest, PhpGObjectPtr *, &zval_authnRequest, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    authnRequest = (LassoLibAuthnRequest*)cvt_authnRequest->obj;
        providerID = providerID_str;
        assertionConsumerServiceURL = assertionConsumerServiceURL_str;
    return_c_value =  (LassoLibAuthnRequestEnvelope*) lasso_lib_authn_request_envelope_new_full(authnRequest, providerID, assertionConsumerServiceURL);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authn_response_new)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoLibAuthnRequest* request = NULL;
    zval* zval_request = NULL;
    PhpGObjectPtr* cvt_request = NULL;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!r", &providerID_str, &providerID_len, &zval_request) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_request, PhpGObjectPtr *, &zval_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    request = (LassoLibAuthnRequest*)cvt_request->obj;
    return_c_value =  (LassoNode*) lasso_lib_authn_response_new(providerID, request);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_misc_text_node_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_misc_text_node_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_misc_text_node_new_with_string)
{
    char* content = NULL;
    char* content_str = NULL;
    int content_len = 0;
    LassoMiscTextNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &content_str, &content_len) == FAILURE) {
        RETURN_FALSE;
    }

        content = content_str;
    return_c_value =  (LassoMiscTextNode*) lasso_misc_text_node_new_with_string(content);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_misc_text_node_new_with_xml_node)
{
    xmlNode* xml_node = NULL;
    char* xml_node_str = NULL;
    int xml_node_len = 0;
    LassoMiscTextNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &xml_node_str, &xml_node_len) == FAILURE) {
        RETURN_FALSE;
    }

        xml_node = get_xml_node_from_string(xml_node_str);
    return_c_value =  (LassoMiscTextNode*) lasso_misc_text_node_new_with_xml_node(xml_node);
    xmlFree(xml_node);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_build_unique_id)
{
    long size;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &size) == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  lasso_build_unique_id(size);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_lib_logout_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_logout_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_logout_response_new_full)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    char* statusCodeValue = NULL;
    char* statusCodeValue_str = NULL;
    int statusCodeValue_len = 0;
    LassoLibLogoutRequest* request = NULL;
    zval* zval_request = NULL;
    PhpGObjectPtr* cvt_request = NULL;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!rll", &providerID_str, &providerID_len, &statusCodeValue_str, &statusCodeValue_len, &zval_request, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
        statusCodeValue = statusCodeValue_str;
    ZEND_FETCH_RESOURCE(cvt_request, PhpGObjectPtr *, &zval_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    request = (LassoLibLogoutRequest*)cvt_request->obj;
    return_c_value =  (LassoNode*) lasso_lib_logout_response_new_full(providerID, statusCodeValue, request, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authn_context_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_authn_context_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp_status_new)
{
    LassoSamlpStatus* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlpStatus*) lasso_samlp_status_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_node_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_node_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_node_new_from_dump)
{
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

        dump = dump_str;
    return_c_value =  (LassoNode*) lasso_node_new_from_dump(dump);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_node_new_from_soap)
{
    char* soap = NULL;
    char* soap_str = NULL;
    int soap_len = 0;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &soap_str, &soap_len) == FAILURE) {
        RETURN_FALSE;
    }

        soap = soap_str;
    return_c_value =  (LassoNode*) lasso_node_new_from_soap(soap);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_node_new_from_xmlNode)
{
    xmlNode* node = NULL;
    char* node_str = NULL;
    int node_len = 0;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &node_str, &node_len) == FAILURE) {
        RETURN_FALSE;
    }

        node = get_xml_node_from_string(node_str);
    return_c_value =  (LassoNode*) lasso_node_new_from_xmlNode(node);
    xmlFree(node);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_register_dst_service)
{
    char* prefix = NULL;
    char* prefix_str = NULL;
    int prefix_len = 0;
    char* href = NULL;
    char* href_str = NULL;
    int href_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!", &prefix_str, &prefix_len, &href_str, &href_len) == FAILURE) {
        RETURN_FALSE;
    }

        prefix = prefix_str;
        href = href_str;
    lasso_register_dst_service(prefix, href);
}

PHP_FUNCTION(lasso_get_prefix_for_dst_service_href)
{
    char* href = NULL;
    char* href_str = NULL;
    int href_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &href_str, &href_len) == FAILURE) {
        RETURN_FALSE;
    }

        href = href_str;
    return_c_value =  lasso_get_prefix_for_dst_service_href(href);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_register_idwsf2_dst_service)
{
    char* prefix = NULL;
    char* prefix_str = NULL;
    int prefix_len = 0;
    char* href = NULL;
    char* href_str = NULL;
    int href_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!", &prefix_str, &prefix_len, &href_str, &href_len) == FAILURE) {
        RETURN_FALSE;
    }

        prefix = prefix_str;
        href = href_str;
    lasso_register_idwsf2_dst_service(prefix, href);
}

PHP_FUNCTION(lasso_get_prefix_for_idwsf2_dst_service_href)
{
    char* href = NULL;
    char* href_str = NULL;
    int href_len = 0;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &href_str, &href_len) == FAILURE) {
        RETURN_FALSE;
    }

        href = href_str;
    return_c_value =  lasso_get_prefix_for_idwsf2_dst_service_href(href);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_saml_audience_restriction_condition_new)
{
    LassoSamlAudienceRestrictionCondition* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlAudienceRestrictionCondition*) lasso_saml_audience_restriction_condition_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_audience_restriction_condition_new_full)
{
    char* audience = NULL;
    char* audience_str = NULL;
    int audience_len = 0;
    LassoSamlAudienceRestrictionCondition* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &audience_str, &audience_len) == FAILURE) {
        RETURN_FALSE;
    }

        audience = audience_str;
    return_c_value =  (LassoSamlAudienceRestrictionCondition*) lasso_saml_audience_restriction_condition_new_full(audience);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_subject_confirmation_new)
{
    LassoSamlSubjectConfirmation* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlSubjectConfirmation*) lasso_saml_subject_confirmation_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_authentication_statement_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_authentication_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_idp_list_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_idp_list_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_register_name_identifier_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_register_name_identifier_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_register_name_identifier_response_new_full)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    char* statusCodeValue = NULL;
    char* statusCodeValue_str = NULL;
    int statusCodeValue_len = 0;
    LassoLibRegisterNameIdentifierRequest* request = NULL;
    zval* zval_request = NULL;
    PhpGObjectPtr* cvt_request = NULL;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!rll", &providerID_str, &providerID_len, &statusCodeValue_str, &statusCodeValue_len, &zval_request, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
        statusCodeValue = statusCodeValue_str;
    ZEND_FETCH_RESOURCE(cvt_request, PhpGObjectPtr *, &zval_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    request = (LassoLibRegisterNameIdentifierRequest*)cvt_request->obj;
    return_c_value =  (LassoNode*) lasso_lib_register_name_identifier_response_new_full(providerID, statusCodeValue, request, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_attribute_statement_new)
{
    LassoSamlAttributeStatement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlAttributeStatement*) lasso_saml_attribute_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_subject_locality_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_subject_locality_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_federation_termination_notification_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_federation_termination_notification_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_federation_termination_notification_new_full)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoSamlNameIdentifier* nameIdentifier = NULL;
    zval* zval_nameIdentifier = NULL;
    PhpGObjectPtr* cvt_nameIdentifier = NULL;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!rll", &providerID_str, &providerID_len, &zval_nameIdentifier, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_nameIdentifier, PhpGObjectPtr *, &zval_nameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    nameIdentifier = (LassoSamlNameIdentifier*)cvt_nameIdentifier->obj;
    return_c_value =  (LassoNode*) lasso_lib_federation_termination_notification_new_full(providerID, nameIdentifier, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_attribute_value_new)
{
    LassoSamlAttributeValue* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlAttributeValue*) lasso_saml_attribute_value_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_scoping_new)
{
    LassoLibScoping* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibScoping*) lasso_lib_scoping_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_name_identifier_mapping_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_name_identifier_mapping_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_name_identifier_mapping_response_new_full)
{
    char* provideRID = NULL;
    char* provideRID_str = NULL;
    int provideRID_len = 0;
    char* statusCodeValue = NULL;
    char* statusCodeValue_str = NULL;
    int statusCodeValue_len = 0;
    LassoLibNameIdentifierMappingRequest* request = NULL;
    zval* zval_request = NULL;
    PhpGObjectPtr* cvt_request = NULL;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!rll", &provideRID_str, &provideRID_len, &statusCodeValue_str, &statusCodeValue_len, &zval_request, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        provideRID = provideRID_str;
        statusCodeValue = statusCodeValue_str;
    ZEND_FETCH_RESOURCE(cvt_request, PhpGObjectPtr *, &zval_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    request = (LassoLibNameIdentifierMappingRequest*)cvt_request->obj;
    return_c_value =  (LassoNode*) lasso_lib_name_identifier_mapping_response_new_full(provideRID, statusCodeValue, request, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_subject_statement_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_subject_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authn_request_new)
{
    LassoLibAuthnRequest* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibAuthnRequest*) lasso_lib_authn_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authn_response_envelope_new)
{
    LassoLibAuthnResponse* response = NULL;
    zval* zval_response = NULL;
    PhpGObjectPtr* cvt_response = NULL;
    char* assertionConsumerServiceURL = NULL;
    char* assertionConsumerServiceURL_str = NULL;
    int assertionConsumerServiceURL_len = 0;
    LassoLibAuthnResponseEnvelope* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_response, &assertionConsumerServiceURL_str, &assertionConsumerServiceURL_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_response, PhpGObjectPtr *, &zval_response, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    response = (LassoLibAuthnResponse*)cvt_response->obj;
        assertionConsumerServiceURL = assertionConsumerServiceURL_str;
    return_c_value =  (LassoLibAuthnResponseEnvelope*) lasso_lib_authn_response_envelope_new(response, assertionConsumerServiceURL);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_attribute_designator_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_attribute_designator_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_idp_entries_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_idp_entries_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_subject_new)
{
    LassoLibSubject* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibSubject*) lasso_lib_subject_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_advice_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_advice_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_assertion_new)
{
    LassoLibAssertion* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibAssertion*) lasso_lib_assertion_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_assertion_new_full)
{
    char* issuer = NULL;
    char* issuer_str = NULL;
    int issuer_len = 0;
    char* requestID = NULL;
    char* requestID_str = NULL;
    int requestID_len = 0;
    char* audience = NULL;
    char* audience_str = NULL;
    int audience_len = 0;
    char* notBefore = NULL;
    char* notBefore_str = NULL;
    int notBefore_len = 0;
    char* notOnOrAfter = NULL;
    char* notOnOrAfter_str = NULL;
    int notOnOrAfter_len = 0;
    LassoLibAssertion* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!s!s!s!", &issuer_str, &issuer_len, &requestID_str, &requestID_len, &audience_str, &audience_len, &notBefore_str, &notBefore_len, &notOnOrAfter_str, &notOnOrAfter_len) == FAILURE) {
        RETURN_FALSE;
    }

        issuer = issuer_str;
        requestID = requestID_str;
        audience = audience_str;
        notBefore = notBefore_str;
        notOnOrAfter = notOnOrAfter_str;
    return_c_value =  (LassoLibAssertion*) lasso_lib_assertion_new_full(issuer, requestID, audience, notBefore, notOnOrAfter);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_status_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_status_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_name_identifier_new)
{
    LassoSamlNameIdentifier* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlNameIdentifier*) lasso_saml_name_identifier_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_name_identifier_new_from_xmlNode)
{
    xmlNode* xmlnode = NULL;
    char* xmlnode_str = NULL;
    int xmlnode_len = 0;
    LassoSamlNameIdentifier* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &xmlnode_str, &xmlnode_len) == FAILURE) {
        RETURN_FALSE;
    }

        xmlnode = get_xml_node_from_string(xmlnode_str);
    return_c_value =  (LassoSamlNameIdentifier*) lasso_saml_name_identifier_new_from_xmlNode(xmlnode);
    xmlFree(xmlnode);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_authority_binding_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_authority_binding_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_subject_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml_subject_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authentication_statement_new)
{
    LassoLibAuthenticationStatement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoLibAuthenticationStatement*) lasso_lib_authentication_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_authentication_statement_new_full)
{
    char* authenticationMethod = NULL;
    char* authenticationMethod_str = NULL;
    int authenticationMethod_len = 0;
    char* authenticationInstant = NULL;
    char* authenticationInstant_str = NULL;
    int authenticationInstant_len = 0;
    char* reauthenticateOnOrAfter = NULL;
    char* reauthenticateOnOrAfter_str = NULL;
    int reauthenticateOnOrAfter_len = 0;
    LassoSamlNameIdentifier* sp_identifier = NULL;
    zval* zval_sp_identifier = NULL;
    PhpGObjectPtr* cvt_sp_identifier = NULL;
    LassoSamlNameIdentifier* idp_identifier = NULL;
    zval* zval_idp_identifier = NULL;
    PhpGObjectPtr* cvt_idp_identifier = NULL;
    LassoLibAuthenticationStatement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!s!rr", &authenticationMethod_str, &authenticationMethod_len, &authenticationInstant_str, &authenticationInstant_len, &reauthenticateOnOrAfter_str, &reauthenticateOnOrAfter_len, &zval_sp_identifier, &zval_idp_identifier) == FAILURE) {
        RETURN_FALSE;
    }

        authenticationMethod = authenticationMethod_str;
        authenticationInstant = authenticationInstant_str;
        reauthenticateOnOrAfter = reauthenticateOnOrAfter_str;
    ZEND_FETCH_RESOURCE(cvt_sp_identifier, PhpGObjectPtr *, &zval_sp_identifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    sp_identifier = (LassoSamlNameIdentifier*)cvt_sp_identifier->obj;
    ZEND_FETCH_RESOURCE(cvt_idp_identifier, PhpGObjectPtr *, &zval_idp_identifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    idp_identifier = (LassoSamlNameIdentifier*)cvt_idp_identifier->obj;
    return_c_value =  (LassoLibAuthenticationStatement*) lasso_lib_authentication_statement_new_full(authenticationMethod, authenticationInstant, reauthenticateOnOrAfter, sp_identifier, idp_identifier);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_conditions_new)
{
    LassoSamlConditions* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlConditions*) lasso_saml_conditions_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_logout_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_logout_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_logout_request_new_full)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoSamlNameIdentifier* nameIdentifier = NULL;
    zval* zval_nameIdentifier = NULL;
    PhpGObjectPtr* cvt_nameIdentifier = NULL;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!rll", &providerID_str, &providerID_len, &zval_nameIdentifier, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_nameIdentifier, PhpGObjectPtr *, &zval_nameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    nameIdentifier = (LassoSamlNameIdentifier*)cvt_nameIdentifier->obj;
    return_c_value =  (LassoNode*) lasso_lib_logout_request_new_full(providerID, nameIdentifier, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_idp_entry_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_idp_entry_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_register_name_identifier_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_register_name_identifier_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_register_name_identifier_request_new_full)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoSamlNameIdentifier* idpNameIdentifier = NULL;
    zval* zval_idpNameIdentifier = NULL;
    PhpGObjectPtr* cvt_idpNameIdentifier = NULL;
    LassoSamlNameIdentifier* spNameIdentifier = NULL;
    zval* zval_spNameIdentifier = NULL;
    PhpGObjectPtr* cvt_spNameIdentifier = NULL;
    LassoSamlNameIdentifier* oldNameIdentifier = NULL;
    zval* zval_oldNameIdentifier = NULL;
    PhpGObjectPtr* cvt_oldNameIdentifier = NULL;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!rrrll", &providerID_str, &providerID_len, &zval_idpNameIdentifier, &zval_spNameIdentifier, &zval_oldNameIdentifier, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_idpNameIdentifier, PhpGObjectPtr *, &zval_idpNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    idpNameIdentifier = (LassoSamlNameIdentifier*)cvt_idpNameIdentifier->obj;
    ZEND_FETCH_RESOURCE(cvt_spNameIdentifier, PhpGObjectPtr *, &zval_spNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    spNameIdentifier = (LassoSamlNameIdentifier*)cvt_spNameIdentifier->obj;
    ZEND_FETCH_RESOURCE(cvt_oldNameIdentifier, PhpGObjectPtr *, &zval_oldNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    oldNameIdentifier = (LassoSamlNameIdentifier*)cvt_oldNameIdentifier->obj;
    return_c_value =  (LassoNode*) lasso_lib_register_name_identifier_request_new_full(providerID, idpNameIdentifier, spNameIdentifier, oldNameIdentifier, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml_attribute_new)
{
    LassoSamlAttribute* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlAttribute*) lasso_saml_attribute_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp_status_code_new)
{
    LassoSamlpStatusCode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSamlpStatusCode*) lasso_samlp_status_code_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_name_identifier_mapping_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_lib_name_identifier_mapping_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_lib_name_identifier_mapping_request_new_full)
{
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoSamlNameIdentifier* nameIdentifier = NULL;
    zval* zval_nameIdentifier = NULL;
    PhpGObjectPtr* cvt_nameIdentifier = NULL;
    char* targetNamespace = NULL;
    char* targetNamespace_str = NULL;
    int targetNamespace_len = 0;
    long sign_type;
    long sign_method;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!rs!ll", &providerID_str, &providerID_len, &zval_nameIdentifier, &targetNamespace_str, &targetNamespace_len, &sign_type, &sign_method) == FAILURE) {
        RETURN_FALSE;
    }

        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_nameIdentifier, PhpGObjectPtr *, &zval_nameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    nameIdentifier = (LassoSamlNameIdentifier*)cvt_nameIdentifier->obj;
        targetNamespace = targetNamespace_str;
    return_c_value =  (LassoNode*) lasso_lib_name_identifier_mapping_request_new_full(providerID, nameIdentifier, targetNamespace, sign_type, sign_method);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_base_idabstract_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_base_idabstract_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_attribute_query_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_attribute_query_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_assertion_id_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_assertion_id_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_condition_abstract_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_condition_abstract_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_attribute_value_new)
{
    LassoSaml2AttributeValue* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSaml2AttributeValue*) lasso_saml2_attribute_value_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_name_id_policy_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_name_id_policy_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_status_code_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_status_code_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_manage_name_id_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_manage_name_id_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_name_id_mapping_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_name_id_mapping_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_one_time_use_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_one_time_use_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_key_info_confirmation_data_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_key_info_confirmation_data_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_subject_confirmation_data_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_subject_confirmation_data_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_subject_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_subject_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_conditions_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_conditions_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_status_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_status_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_statement_abstract_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_statement_abstract_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_artifact_resolve_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_artifact_resolve_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_proxy_restriction_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_proxy_restriction_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_manage_name_id_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_manage_name_id_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_advice_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_advice_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_artifact_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_artifact_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_attribute_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_attribute_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_logout_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_logout_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_idp_list_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_idp_list_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_status_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_status_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_encrypted_element_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_encrypted_element_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_subject_confirmation_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_subject_confirmation_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_idp_entry_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_idp_entry_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_audience_restriction_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_audience_restriction_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_requested_authn_context_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_requested_authn_context_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_extensions_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_extensions_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_attribute_statement_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_attribute_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_authz_decision_statement_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_authz_decision_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_evidence_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_evidence_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_key_info_confirmation_data_type_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_key_info_confirmation_data_type_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_scoping_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_scoping_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_authn_context_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_authn_context_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_status_detail_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_status_detail_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_authz_decision_query_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_authz_decision_query_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_assertion_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_logout_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_logout_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_name_id_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_name_id_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_name_id_new_with_string)
{
    char* content = NULL;
    char* content_str = NULL;
    int content_len = 0;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &content_str, &content_len) == FAILURE) {
        RETURN_FALSE;
    }

        content = content_str;
    return_c_value =  (LassoNode*) lasso_saml2_name_id_new_with_string(content);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_name_id_mapping_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_name_id_mapping_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_action_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_action_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_action_new_with_string)
{
    char* content = NULL;
    char* content_str = NULL;
    int content_len = 0;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &content_str, &content_len) == FAILURE) {
        RETURN_FALSE;
    }

        content = content_str;
    return_c_value =  (LassoNode*) lasso_saml2_action_new_with_string(content);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_response_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_response_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_subject_locality_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_subject_locality_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_request_abstract_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_request_abstract_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_subject_query_abstract_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_subject_query_abstract_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_terminate_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_terminate_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_authn_statement_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_saml2_authn_statement_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_authn_query_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_authn_query_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_authn_request_new)
{
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoNode*) lasso_samlp2_authn_request_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_body_new)
{
    LassoSoapBody* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSoapBody*) lasso_soap_body_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_body_new_from_message)
{
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    LassoSoapBody* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

        message = message_str;
    return_c_value =  (LassoSoapBody*) lasso_soap_body_new_from_message(message);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_fault_new)
{
    LassoSoapFault* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSoapFault*) lasso_soap_fault_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_fault_new_from_message)
{
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    LassoSoapFault* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

        message = message_str;
    return_c_value =  (LassoSoapFault*) lasso_soap_fault_new_from_message(message);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_fault_new_full)
{
    char* faultcode = NULL;
    char* faultcode_str = NULL;
    int faultcode_len = 0;
    char* faultstring = NULL;
    char* faultstring_str = NULL;
    int faultstring_len = 0;
    LassoSoapFault* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!s!", &faultcode_str, &faultcode_len, &faultstring_str, &faultstring_len) == FAILURE) {
        RETURN_FALSE;
    }

        faultcode = faultcode_str;
        faultstring = faultstring_str;
    return_c_value =  (LassoSoapFault*) lasso_soap_fault_new_full(faultcode, faultstring);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_header_new)
{
    LassoSoapHeader* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSoapHeader*) lasso_soap_header_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_header_new_from_message)
{
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    LassoSoapHeader* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

        message = message_str;
    return_c_value =  (LassoSoapHeader*) lasso_soap_header_new_from_message(message);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_detail_new)
{
    LassoSoapDetail* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoSoapDetail*) lasso_soap_detail_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_detail_new_from_message)
{
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    LassoSoapDetail* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

        message = message_str;
    return_c_value =  (LassoSoapDetail*) lasso_soap_detail_new_from_message(message);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_envelope_new)
{
    LassoSoapBody* body = NULL;
    zval* zval_body = NULL;
    PhpGObjectPtr* cvt_body = NULL;
    LassoSoapEnvelope* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_body) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_body, PhpGObjectPtr *, &zval_body, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    body = (LassoSoapBody*)cvt_body->obj;
    return_c_value =  (LassoSoapEnvelope*) lasso_soap_envelope_new(body);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_soap_envelope_new_from_message)
{
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    LassoSoapEnvelope* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s!", &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

        message = message_str;
    return_c_value =  (LassoSoapEnvelope*) lasso_soap_envelope_new_from_message(message);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_ds_x509_data_new)
{
    LassoDsX509Data* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoDsX509Data*) lasso_ds_x509_data_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_ds_key_value_new)
{
    LassoDsKeyValue* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoDsKeyValue*) lasso_ds_key_value_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_ds_key_info_new)
{
    LassoDsKeyInfo* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoDsKeyInfo*) lasso_ds_key_info_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_ds_rsa_key_value_new)
{
    LassoDsRsaKeyValue* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "") == FAILURE) {
        RETURN_FALSE;
    }

    return_c_value =  (LassoDsRsaKeyValue*) lasso_ds_rsa_key_value_new();
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_node_cleanup_original_xmlnodes)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    lasso_node_cleanup_original_xmlnodes(node);
}

PHP_FUNCTION(lasso_node_dump)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_dump(node);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_base64)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_export_to_base64(node);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_query)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    long sign_method;
    char* private_key_file = NULL;
    char* private_key_file_str = NULL;
    int private_key_file_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!", &zval_node, &sign_method, &private_key_file_str, &private_key_file_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        private_key_file = private_key_file_str;
    return_c_value =  lasso_node_export_to_query(node, sign_method, private_key_file);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_query_with_password)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    long sign_method;
    char* private_key_file = NULL;
    char* private_key_file_str = NULL;
    int private_key_file_len = 0;
    char* private_key_file_password = NULL;
    char* private_key_file_password_str = NULL;
    int private_key_file_password_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!s!", &zval_node, &sign_method, &private_key_file_str, &private_key_file_len, &private_key_file_password_str, &private_key_file_password_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        private_key_file = private_key_file_str;
        private_key_file_password = private_key_file_password_str;
    return_c_value =  lasso_node_export_to_query_with_password(node, sign_method, private_key_file, private_key_file_password);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_soap)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_export_to_soap(node);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_xml)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_export_to_xml(node);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_paos_request)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* issuer = NULL;
    char* issuer_str = NULL;
    int issuer_len = 0;
    char* responseConsumerURL = NULL;
    char* responseConsumerURL_str = NULL;
    int responseConsumerURL_len = 0;
    char* relay_state = NULL;
    char* relay_state_str = NULL;
    int relay_state_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!s!", &zval_node, &issuer_str, &issuer_len, &responseConsumerURL_str, &responseConsumerURL_len, &relay_state_str, &relay_state_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        issuer = issuer_str;
        responseConsumerURL = responseConsumerURL_str;
        relay_state = relay_state_str;
    return_c_value =  lasso_node_export_to_paos_request(node, issuer, responseConsumerURL, relay_state);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_export_to_ecp_soap_response)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* assertionConsumerURL = NULL;
    char* assertionConsumerURL_str = NULL;
    int assertionConsumerURL_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_node, &assertionConsumerURL_str, &assertionConsumerURL_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        assertionConsumerURL = assertionConsumerURL_str;
    return_c_value =  lasso_node_export_to_ecp_soap_response(node, assertionConsumerURL);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_node_get_xmlNode)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    long lasso_dump;
    xmlNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_node, &lasso_dump) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_get_xmlNode(node, lasso_dump);
    {
        char* xmlString = get_string_from_xml_node(return_c_value);
        if (xmlString) {
            RETVAL_STRING(xmlString, 0);
        } else {
            RETVAL_NULL();
        }
    }

    lasso_release_xml_node(return_c_value);
}

PHP_FUNCTION(lasso_node_get_original_xmlnode)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    xmlNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_get_original_xmlnode(node);
    {
        char* xmlString = get_string_from_xml_node(return_c_value);
        if (xmlString) {
            RETVAL_STRING(xmlString, 0);
        } else {
            RETVAL_NULL();
        }
    }

}

PHP_FUNCTION(lasso_node_set_original_xmlnode)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    xmlNode* xmlnode = NULL;
    char* xmlnode_str = NULL;
    int xmlnode_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_node, &xmlnode_str, &xmlnode_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        xmlnode = get_xml_node_from_string(xmlnode_str);
    lasso_node_set_original_xmlnode(node, xmlnode);
    xmlFree(xmlnode);
}

PHP_FUNCTION(lasso_node_set_custom_namespace)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* prefix = NULL;
    char* prefix_str = NULL;
    int prefix_len = 0;
    char* href = NULL;
    char* href_str = NULL;
    int href_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_node, &prefix_str, &prefix_len, &href_str, &href_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        prefix = prefix_str;
        href = href_str;
    lasso_node_set_custom_namespace(node, prefix, href);
}

PHP_FUNCTION(lasso_node_set_custom_nodename)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* nodename = NULL;
    char* nodename_str = NULL;
    int nodename_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_node, &nodename_str, &nodename_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        nodename = nodename_str;
    lasso_node_set_custom_nodename(node, nodename);
}

PHP_FUNCTION(lasso_node_get_name)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_get_name(node);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_node_get_namespace)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_get_namespace(node);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_node_init_from_message)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    LassoMessageFormat return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_node, &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        message = message_str;
    return_c_value =  lasso_node_init_from_message(node, message);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_node_init_from_query)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* query = NULL;
    char* query_str = NULL;
    int query_len = 0;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_node, &query_str, &query_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        query = query_str;
    return_c_value =  lasso_node_init_from_query(node, query);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_node_init_from_xml)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    xmlNode* xmlnode = NULL;
    char* xmlnode_str = NULL;
    int xmlnode_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_node, &xmlnode_str, &xmlnode_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        xmlnode = get_xml_node_from_string(xmlnode_str);
    return_c_value =  lasso_node_init_from_xml(node, xmlnode);
    xmlFree(xmlnode);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_node_debug)
{
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    long level;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_node, &level) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    return_c_value =  lasso_node_debug(node, level);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_key_query_verify)
{
    LassoKey* key = NULL;
    zval* zval_key = NULL;
    PhpGObjectPtr* cvt_key = NULL;
    char* query = NULL;
    char* query_str = NULL;
    int query_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_key, &query_str, &query_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_key, PhpGObjectPtr *, &zval_key, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key = (LassoKey*)cvt_key->obj;
        query = query_str;
    return_c_value =  lasso_key_query_verify(key, query);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_key_query_sign)
{
    LassoKey* key = NULL;
    zval* zval_key = NULL;
    PhpGObjectPtr* cvt_key = NULL;
    char* query = NULL;
    char* query_str = NULL;
    int query_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_key, &query_str, &query_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_key, PhpGObjectPtr *, &zval_key, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key = (LassoKey*)cvt_key->obj;
        query = query_str;
    return_c_value =  lasso_key_query_sign(key, query);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_key_saml2_xml_verify)
{
    LassoKey* key = NULL;
    zval* zval_key = NULL;
    PhpGObjectPtr* cvt_key = NULL;
    char* id = NULL;
    char* id_str = NULL;
    int id_len = 0;
    xmlNode* document = NULL;
    char* document_str = NULL;
    int document_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_key, &id_str, &id_len, &document_str, &document_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_key, PhpGObjectPtr *, &zval_key, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key = (LassoKey*)cvt_key->obj;
        id = id_str;
        document = get_xml_node_from_string(document_str);
    return_c_value =  lasso_key_saml2_xml_verify(key, id, document);
    xmlFree(document);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_key_saml2_xml_sign)
{
    LassoKey* key = NULL;
    zval* zval_key = NULL;
    PhpGObjectPtr* cvt_key = NULL;
    char* id = NULL;
    char* id_str = NULL;
    int id_len = 0;
    xmlNode* document = NULL;
    char* document_str = NULL;
    int document_len = 0;
    xmlNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_key, &id_str, &id_len, &document_str, &document_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_key, PhpGObjectPtr *, &zval_key, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key = (LassoKey*)cvt_key->obj;
        id = id_str;
        document = get_xml_node_from_string(document_str);
    return_c_value =  lasso_key_saml2_xml_sign(key, id, document);
    xmlFree(document);
    {
        char* xmlString = get_string_from_xml_node(return_c_value);
        if (xmlString) {
            RETVAL_STRING(xmlString, 0);
        } else {
            RETVAL_NULL();
        }
    }

    lasso_release_xml_node(return_c_value);
}

PHP_FUNCTION(LassoIdentity_federations_get)
{
    GHashTable* return_c_value;
    LassoIdentity* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoIdentity*)cvt_this->obj;

    return_c_value = (GHashTable*)this->federations;
    set_array_from_hashtable_of_objects(return_c_value, &return_value);

}

PHP_FUNCTION(LassoIdentity_federations_set)
{
    LassoIdentity* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_federations;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_federations) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoIdentity*)cvt_this->obj;

        {
            GHashTable *oldhash = this->federations;
            this->federations = get_hashtable_from_array_of_objects(zval_federations);
            g_hash_table_destroy(oldhash);
        }
}

PHP_FUNCTION(LassoIdentity_isDirty_get)
{
    gboolean return_c_value;
    LassoIdentity* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoIdentity*)cvt_this->obj;

    return_c_value = (gboolean)this->is_dirty;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoIdentity_isDirty_set)
{
    LassoIdentity* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long is_dirty;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &is_dirty) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoIdentity*)cvt_this->obj;

    this->is_dirty = is_dirty;
}

PHP_FUNCTION(lasso_identity_get_federation)
{
    LassoIdentity* identity = NULL;
    zval* zval_identity = NULL;
    PhpGObjectPtr* cvt_identity = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoFederation* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_identity, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_identity, PhpGObjectPtr *, &zval_identity, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    identity = (LassoIdentity*)cvt_identity->obj;
        providerID = providerID_str;
    return_c_value =  lasso_identity_get_federation(identity, providerID);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_identity_dump)
{
    LassoIdentity* identity = NULL;
    zval* zval_identity = NULL;
    PhpGObjectPtr* cvt_identity = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_identity) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_identity, PhpGObjectPtr *, &zval_identity, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    identity = (LassoIdentity*)cvt_identity->obj;
    return_c_value =  lasso_identity_dump(identity);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(LassoProvider_providerId_get)
{
    gchar* return_c_value;
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    return_c_value = (gchar*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProvider_providerId_set)
{
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoProvider_role_get)
{
    LassoProviderRole return_c_value;
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    return_c_value = (LassoProviderRole)this->role;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoProvider_role_set)
{
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long role;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &role) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    this->role = role;
}

PHP_FUNCTION(LassoProvider_metadataFilename_get)
{
    char* return_c_value;
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    return_c_value = (char*)this->metadata_filename;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProvider_metadataFilename_set)
{
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* metadata_filename_str = NULL;
    int metadata_filename_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &metadata_filename_str, &metadata_filename_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    lasso_assign_string(this->metadata_filename, metadata_filename_str);
}

PHP_FUNCTION(LassoProvider_publicKey_get)
{
    gchar* return_c_value;
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    return_c_value = (gchar*)this->public_key;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProvider_publicKey_set)
{
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* public_key_str = NULL;
    int public_key_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &public_key_str, &public_key_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    lasso_assign_string(this->public_key, public_key_str);
}

PHP_FUNCTION(LassoProvider_caCertChain_get)
{
    gchar* return_c_value;
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    return_c_value = (gchar*)this->ca_cert_chain;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProvider_caCertChain_set)
{
    LassoProvider* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ca_cert_chain_str = NULL;
    int ca_cert_chain_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ca_cert_chain_str, &ca_cert_chain_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProvider*)cvt_this->obj;

    lasso_assign_string(this->ca_cert_chain, ca_cert_chain_str);
}

PHP_FUNCTION(lasso_provider_get_assertion_consumer_service_url)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    char* service_id = NULL;
    char* service_id_str = NULL;
    int service_id_len = 0;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_provider, &service_id_str, &service_id_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
        service_id = service_id_str;
    return_c_value =  lasso_provider_get_assertion_consumer_service_url(provider, service_id);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_metadata_one)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    char* name = NULL;
    char* name_str = NULL;
    int name_len = 0;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_provider, &name_str, &name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
        name = name_str;
    return_c_value =  lasso_provider_get_metadata_one(provider, name);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_metadata_list)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    char* name = NULL;
    char* name_str = NULL;
    int name_len = 0;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_provider, &name_str, &name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
        name = name_str;
    return_c_value =  lasso_provider_get_metadata_list(provider, name);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(lasso_provider_get_first_http_method)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoProvider* remote_provider = NULL;
    zval* zval_remote_provider = NULL;
    PhpGObjectPtr* cvt_remote_provider = NULL;
    long protocol_type;
    LassoHttpMethod return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rrl", &zval_provider, &zval_remote_provider, &protocol_type) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_remote_provider, PhpGObjectPtr *, &zval_remote_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    remote_provider = (LassoProvider*)cvt_remote_provider->obj;
    return_c_value =  lasso_provider_get_first_http_method(provider, remote_provider, protocol_type);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_accept_http_method)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoProvider* remote_provider = NULL;
    zval* zval_remote_provider = NULL;
    PhpGObjectPtr* cvt_remote_provider = NULL;
    long protocol_type;
    long http_method;
    long initiate_profile;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rrlll", &zval_provider, &zval_remote_provider, &protocol_type, &http_method, &initiate_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_remote_provider, PhpGObjectPtr *, &zval_remote_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    remote_provider = (LassoProvider*)cvt_remote_provider->obj;
    return_c_value =  lasso_provider_accept_http_method(provider, remote_provider, protocol_type, http_method, initiate_profile);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_provider_has_protocol_profile)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    long protocol_type;
    char* protocol_profile = NULL;
    char* protocol_profile_str = NULL;
    int protocol_profile_len = 0;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!", &zval_provider, &protocol_type, &protocol_profile_str, &protocol_profile_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
        protocol_profile = protocol_profile_str;
    return_c_value =  lasso_provider_has_protocol_profile(provider, protocol_type, protocol_profile);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_base64_succinct_id)
{
    const LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (const LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_base64_succinct_id(provider);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_organization)
{
    const LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    xmlNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (const LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_organization(provider);
    {
        char* xmlString = get_string_from_xml_node(return_c_value);
        if (xmlString) {
            RETVAL_STRING(xmlString, 0);
        } else {
            RETVAL_NULL();
        }
    }

    lasso_release_xml_node(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_protocol_conformance)
{
    const LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoProtocolConformance return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (const LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_protocol_conformance(provider);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_set_encryption_mode)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    long encryption_mode;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_provider, &encryption_mode) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    lasso_provider_set_encryption_mode(provider, encryption_mode);
}

PHP_FUNCTION(lasso_provider_get_encryption_mode)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoEncryptionMode return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_encryption_mode(provider);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_set_encryption_sym_key_type)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    long encryption_sym_key_type;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_provider, &encryption_sym_key_type) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    lasso_provider_set_encryption_sym_key_type(provider, encryption_sym_key_type);
}

PHP_FUNCTION(lasso_provider_get_default_name_id_format)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_default_name_id_format(provider);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_sp_name_qualifier)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_sp_name_qualifier(provider);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_provider_verify_single_node_signature)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;
    char* id_attr_name = NULL;
    char* id_attr_name_str = NULL;
    int id_attr_name_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rrs!", &zval_provider, &zval_node, &id_attr_name_str, &id_attr_name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
        id_attr_name = id_attr_name_str;
    return_c_value =  lasso_provider_verify_single_node_signature(provider, node, id_attr_name);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_idp_supported_attributes)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_idp_supported_attributes(provider);
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(lasso_provider_get_valid_until)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_valid_until(provider);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_provider_get_cache_duration)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_cache_duration(provider);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_provider_get_metadata_one_for_role)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    long role;
    char* name = NULL;
    char* name_str = NULL;
    int name_len = 0;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!", &zval_provider, &role, &name_str, &name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
        name = name_str;
    return_c_value =  lasso_provider_get_metadata_one_for_role(provider, role, name);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_metadata_list_for_role)
{
    const LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    long role;
    char* name = NULL;
    char* name_str = NULL;
    int name_len = 0;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!", &zval_provider, &role, &name_str, &name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (const LassoProvider*)cvt_provider->obj;
        name = name_str;
    return_c_value =  lasso_provider_get_metadata_list_for_role(provider, role, name);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(lasso_provider_get_metadata_keys_for_role)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    long role;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_provider, &role) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_metadata_keys_for_role(provider, role);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

    lasso_release_list_of_strings(return_c_value);
}

PHP_FUNCTION(lasso_provider_get_roles)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoProviderRole return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_provider_get_roles(provider);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_match_conformance)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoProvider* another_provider = NULL;
    zval* zval_another_provider = NULL;
    PhpGObjectPtr* cvt_another_provider = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_provider, &zval_another_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_another_provider, PhpGObjectPtr *, &zval_another_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    another_provider = (LassoProvider*)cvt_another_provider->obj;
    return_c_value =  lasso_provider_match_conformance(provider, another_provider);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_provider_set_server_signing_key)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoKey* key = NULL;
    zval* zval_key = NULL;
    PhpGObjectPtr* cvt_key = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_provider, &zval_key) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_key, PhpGObjectPtr *, &zval_key, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key = (LassoKey*)cvt_key->obj;
    return_c_value =  lasso_provider_set_server_signing_key(provider, key);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_add_key)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoKey* key = NULL;
    zval* zval_key = NULL;
    PhpGObjectPtr* cvt_key = NULL;
    long after;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rrl", &zval_provider, &zval_key, &after) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_key, PhpGObjectPtr *, &zval_key, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key = (LassoKey*)cvt_key->obj;
    return_c_value =  lasso_provider_add_key(provider, key, after);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_verify_signature)
{
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;
    char* id_attr_name = NULL;
    char* id_attr_name_str = NULL;
    int id_attr_name_len = 0;
    long format;
    int return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!l", &zval_provider, &message_str, &message_len, &id_attr_name_str, &id_attr_name_len, &format) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
        message = message_str;
        id_attr_name = id_attr_name_str;
    return_c_value =  lasso_provider_verify_signature(provider, message, id_attr_name, format);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_provider_saml2_node_encrypt)
{
    const LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    LassoNode* lasso_node = NULL;
    zval* zval_lasso_node = NULL;
    PhpGObjectPtr* cvt_lasso_node = NULL;
    LassoSaml2EncryptedElement* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_provider, &zval_lasso_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (const LassoProvider*)cvt_provider->obj;
    ZEND_FETCH_RESOURCE(cvt_lasso_node, PhpGObjectPtr *, &zval_lasso_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_node = (LassoNode*)cvt_lasso_node->obj;
    return_c_value =  lasso_provider_saml2_node_encrypt(provider, lasso_node);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(LassoProfile_server_get)
{
    LassoServer* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (LassoServer*)this->server;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_server_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_server) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr*, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->server, cvt_server->obj);
}

PHP_FUNCTION(LassoProfile_request_get)
{
    LassoNode* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (LassoNode*)this->request;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_request_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_request = NULL;
    PhpGObjectPtr* cvt_request = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_request) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_request, PhpGObjectPtr*, &zval_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->request, cvt_request->obj);
}

PHP_FUNCTION(LassoProfile_response_get)
{
    LassoNode* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (LassoNode*)this->response;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_response_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_response = NULL;
    PhpGObjectPtr* cvt_response = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_response) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_response, PhpGObjectPtr*, &zval_response, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->response, cvt_response->obj);
}

PHP_FUNCTION(LassoProfile_nameIdentifier_get)
{
    LassoNode* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (LassoNode*)this->nameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_nameIdentifier_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_nameIdentifier = NULL;
    PhpGObjectPtr* cvt_nameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_nameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_nameIdentifier, PhpGObjectPtr*, &zval_nameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->nameIdentifier, cvt_nameIdentifier->obj);
}

PHP_FUNCTION(LassoProfile_remoteProviderId_get)
{
    gchar* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (gchar*)this->remote_providerID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_remoteProviderId_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    lasso_assign_string(this->remote_providerID, remote_providerID_str);
}

PHP_FUNCTION(LassoProfile_msgUrl_get)
{
    gchar* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (gchar*)this->msg_url;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_msgUrl_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* msg_url_str = NULL;
    int msg_url_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &msg_url_str, &msg_url_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    lasso_assign_string(this->msg_url, msg_url_str);
}

PHP_FUNCTION(LassoProfile_msgBody_get)
{
    gchar* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (gchar*)this->msg_body;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_msgBody_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* msg_body_str = NULL;
    int msg_body_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &msg_body_str, &msg_body_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    lasso_assign_string(this->msg_body, msg_body_str);
}

PHP_FUNCTION(LassoProfile_msgRelayState_get)
{
    gchar* return_c_value;
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    return_c_value = (gchar*)this->msg_relayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoProfile_msgRelayState_set)
{
    LassoProfile* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* msg_relayState_str = NULL;
    int msg_relayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &msg_relayState_str, &msg_relayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoProfile*)cvt_this->obj;

    lasso_assign_string(this->msg_relayState, msg_relayState_str);
}

PHP_FUNCTION(lasso_profile_get_identity)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    LassoIdentity* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_identity(profile);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_profile_get_session)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    LassoSession* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_session(profile);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_profile_has_dirty_identity)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_is_identity_dirty(profile);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_profile_has_dirty_session)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_is_session_dirty(profile);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_profile_set_identity_from_dump)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_profile, &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
        dump = dump_str;
    return_c_value =  lasso_profile_set_identity_from_dump(profile, dump);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_profile_set_session_from_dump)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* dump = NULL;
    char* dump_str = NULL;
    int dump_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_profile, &dump_str, &dump_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
        dump = dump_str;
    return_c_value =  lasso_profile_set_session_from_dump(profile, dump);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_profile_get_federation_nameIdentifier)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_nameIdentifier(profile);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_profile_get_artifact)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_artifact(profile);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_profile_get_artifact_message)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_artifact_message(profile);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_profile_set_artifact_message)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* message = NULL;
    char* message_str = NULL;
    int message_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_profile, &message_str, &message_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
        message = message_str;
    lasso_profile_set_artifact_message(profile, message);
}

PHP_FUNCTION(lasso_profile_set_signature_hint)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    long signature_hint;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_profile, &signature_hint) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    lasso_profile_set_signature_hint(profile, signature_hint);
}

PHP_FUNCTION(lasso_profile_get_signature_hint)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    LassoProfileSignatureHint return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_signature_hint(profile);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_profile_set_soap_fault_response)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* faultcode = NULL;
    char* faultcode_str = NULL;
    int faultcode_len = 0;
    char* faultstring = NULL;
    char* faultstring_str = NULL;
    int faultstring_len = 0;
    zval* zval_details = NULL;
    GList* details = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!a!", &zval_profile, &faultcode_str, &faultcode_len, &faultstring_str, &faultstring_len, &zval_details) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
        faultcode = faultcode_str;
        faultstring = faultstring_str;
    details = get_list_from_array_of_objects(zval_details);
    return_c_value =  lasso_profile_set_soap_fault_response(profile, faultcode, faultstring, details);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_profile_set_signature_verify_hint)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    long signature_verify_hint;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_profile, &signature_verify_hint) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    lasso_profile_set_signature_verify_hint(profile, signature_verify_hint);
}

PHP_FUNCTION(lasso_profile_get_signature_verify_hint)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    LassoProfileSignatureVerifyHint return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_signature_verify_hint(profile);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_profile_sso_role_with)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    char* remote_provider_id = NULL;
    char* remote_provider_id_str = NULL;
    int remote_provider_id_len = 0;
    LassoProviderRole return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_profile, &remote_provider_id_str, &remote_provider_id_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
        remote_provider_id = remote_provider_id_str;
    return_c_value =  lasso_profile_sso_role_with(profile, remote_provider_id);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_profile_get_signature_status)
{
    LassoProfile* profile = NULL;
    zval* zval_profile = NULL;
    PhpGObjectPtr* cvt_profile = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_profile) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_profile, PhpGObjectPtr *, &zval_profile, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    profile = (LassoProfile*)cvt_profile->obj;
    return_c_value =  lasso_profile_get_signature_status(profile);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_defederation_build_notification_msg)
{
    LassoDefederation* defederation = NULL;
    zval* zval_defederation = NULL;
    PhpGObjectPtr* cvt_defederation = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_defederation) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_defederation, PhpGObjectPtr *, &zval_defederation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    defederation = (LassoDefederation*)cvt_defederation->obj;
    return_c_value =  lasso_defederation_build_notification_msg(defederation);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_defederation_init_notification)
{
    LassoDefederation* defederation = NULL;
    zval* zval_defederation = NULL;
    PhpGObjectPtr* cvt_defederation = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    long http_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!l", &zval_defederation, &remote_providerID_str, &remote_providerID_len, &http_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_defederation, PhpGObjectPtr *, &zval_defederation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    defederation = (LassoDefederation*)cvt_defederation->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_defederation_init_notification(defederation, remote_providerID, http_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_defederation_process_notification_msg)
{
    LassoDefederation* defederation = NULL;
    zval* zval_defederation = NULL;
    PhpGObjectPtr* cvt_defederation = NULL;
    char* notification_msg = NULL;
    char* notification_msg_str = NULL;
    int notification_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_defederation, &notification_msg_str, &notification_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_defederation, PhpGObjectPtr *, &zval_defederation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    defederation = (LassoDefederation*)cvt_defederation->obj;
        notification_msg = notification_msg_str;
    return_c_value =  lasso_defederation_process_notification_msg(defederation, notification_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_defederation_validate_notification)
{
    LassoDefederation* defederation = NULL;
    zval* zval_defederation = NULL;
    PhpGObjectPtr* cvt_defederation = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_defederation) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_defederation, PhpGObjectPtr *, &zval_defederation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    defederation = (LassoDefederation*)cvt_defederation->obj;
    return_c_value =  lasso_defederation_validate_notification(defederation);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoServer_providers_get)
{
    GHashTable* return_c_value;
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    return_c_value = (GHashTable*)this->providers;
    set_array_from_hashtable_of_objects(return_c_value, &return_value);

}

PHP_FUNCTION(LassoServer_providers_set)
{
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_providers;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_providers) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

        {
            GHashTable *oldhash = this->providers;
            this->providers = get_hashtable_from_array_of_objects(zval_providers);
            g_hash_table_destroy(oldhash);
        }
}

PHP_FUNCTION(LassoServer_privateKey_get)
{
    gchar* return_c_value;
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    return_c_value = (gchar*)this->private_key;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoServer_privateKey_set)
{
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* private_key_str = NULL;
    int private_key_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &private_key_str, &private_key_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    lasso_assign_string(this->private_key, private_key_str);
}

PHP_FUNCTION(LassoServer_privateKeyPassword_get)
{
    gchar* return_c_value;
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    return_c_value = (gchar*)this->private_key_password;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoServer_privateKeyPassword_set)
{
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* private_key_password_str = NULL;
    int private_key_password_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &private_key_password_str, &private_key_password_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    lasso_assign_string(this->private_key_password, private_key_password_str);
}

PHP_FUNCTION(LassoServer_certificate_get)
{
    gchar* return_c_value;
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    return_c_value = (gchar*)this->certificate;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoServer_certificate_set)
{
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* certificate_str = NULL;
    int certificate_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &certificate_str, &certificate_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    lasso_assign_string(this->certificate, certificate_str);
}

PHP_FUNCTION(LassoServer_signatureMethod_get)
{
    LassoSignatureMethod return_c_value;
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    return_c_value = (LassoSignatureMethod)this->signature_method;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoServer_signatureMethod_set)
{
    LassoServer* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long signature_method;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &signature_method) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoServer*)cvt_this->obj;

    this->signature_method = signature_method;
}

PHP_FUNCTION(lasso_server_add_provider)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    long role;
    char* metadata = NULL;
    char* metadata_str = NULL;
    int metadata_len = 0;
    char* public_key = NULL;
    char* public_key_str = NULL;
    int public_key_len = 0;
    char* ca_cert_chain = NULL;
    char* ca_cert_chain_str = NULL;
    int ca_cert_chain_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!s!s!", &zval_server, &role, &metadata_str, &metadata_len, &public_key_str, &public_key_len, &ca_cert_chain_str, &ca_cert_chain_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        metadata = metadata_str;
        public_key = public_key_str;
        ca_cert_chain = ca_cert_chain_str;
    return_c_value =  lasso_server_add_provider(server, role, metadata, public_key, ca_cert_chain);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_add_provider_from_buffer)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    long role;
    char* metadata = NULL;
    char* metadata_str = NULL;
    int metadata_len = 0;
    char* public_key = NULL;
    char* public_key_str = NULL;
    int public_key_len = 0;
    char* ca_cert_chain = NULL;
    char* ca_cert_chain_str = NULL;
    int ca_cert_chain_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!s!s!", &zval_server, &role, &metadata_str, &metadata_len, &public_key_str, &public_key_len, &ca_cert_chain_str, &ca_cert_chain_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        metadata = metadata_str;
        public_key = public_key_str;
        ca_cert_chain = ca_cert_chain_str;
    return_c_value =  lasso_server_add_provider_from_buffer(server, role, metadata, public_key, ca_cert_chain);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_dump)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  lasso_server_dump(server);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_server_get_provider)
{
    const LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoProvider* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (const LassoServer*)cvt_server->obj;
        providerID = providerID_str;
    return_c_value =  lasso_server_get_provider(server, providerID);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_server_set_encryption_private_key)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* filename_or_buffer = NULL;
    char* filename_or_buffer_str = NULL;
    int filename_or_buffer_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &filename_or_buffer_str, &filename_or_buffer_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        filename_or_buffer = filename_or_buffer_str;
    return_c_value =  lasso_server_set_encryption_private_key(server, filename_or_buffer);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_load_affiliation)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* filename = NULL;
    char* filename_str = NULL;
    int filename_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_server, &filename_str, &filename_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        filename = filename_str;
    return_c_value =  lasso_server_load_affiliation(server, filename);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_set_encryption_private_key_with_password)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    char* filename_or_buffer = NULL;
    char* filename_or_buffer_str = NULL;
    int filename_or_buffer_len = 0;
    char* password = NULL;
    char* password_str = NULL;
    int password_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_server, &filename_or_buffer_str, &filename_or_buffer_len, &password_str, &password_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        filename_or_buffer = filename_or_buffer_str;
        password = password_str;
    return_c_value =  lasso_server_set_encryption_private_key_with_password(server, filename_or_buffer, password);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_load_metadata)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    long role;
    char* federation_file = NULL;
    char* federation_file_str = NULL;
    int federation_file_len = 0;
    char* trusted_roots = NULL;
    char* trusted_roots_str = NULL;
    int trusted_roots_len = 0;
    zval* zval_blacklisted_entity_ids = NULL;
    GList* blacklisted_entity_ids = NULL;
   zval *php_out_loaded_entity_ids = NULL;
   GList* loaded_entity_ids;
    long flags;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rls!s!a!z!l", &zval_server, &role, &federation_file_str, &federation_file_len, &trusted_roots_str, &trusted_roots_len, &zval_blacklisted_entity_ids, &php_out_loaded_entity_ids, &flags) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
        federation_file = federation_file_str;
        trusted_roots = trusted_roots_str;
    blacklisted_entity_ids = get_list_from_array_of_strings(zval_blacklisted_entity_ids);
    return_c_value =  lasso_server_load_metadata(server, role, federation_file, trusted_roots, blacklisted_entity_ids, &loaded_entity_ids, flags);
    if (blacklisted_entity_ids) {
        free_glist(&blacklisted_entity_ids,(GFunc)free);
    }
    zval_dtor(php_out_loaded_entity_ids);
    if (! loaded_entity_ids) {
       ZVAL_NULL(php_out_loaded_entity_ids);
    } else {
     set_array_from_list_of_strings((GList*)loaded_entity_ids, &php_out_loaded_entity_ids);
    free_glist(&loaded_entity_ids, (GFunc)free);
    }
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_add_provider2)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoProvider* provider = NULL;
    zval* zval_provider = NULL;
    PhpGObjectPtr* cvt_provider = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_server, &zval_provider) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    ZEND_FETCH_RESOURCE(cvt_provider, PhpGObjectPtr *, &zval_provider, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    provider = (LassoProvider*)cvt_provider->obj;
    return_c_value =  lasso_server_add_provider2(server, provider);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_server_saml2_assertion_setup_signature)
{
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_server, &zval_saml2_assertion) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    return_c_value =  lasso_server_saml2_assertion_setup_signature(server, saml2_assertion);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_build_request_msg)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
    return_c_value =  lasso_logout_build_request_msg(logout);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_build_response_msg)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
    return_c_value =  lasso_logout_build_response_msg(logout);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_dump)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
    return_c_value =  lasso_logout_dump(logout);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_logout_get_next_providerID)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
    return_c_value =  lasso_logout_get_next_providerID(logout);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_logout_init_request)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    long request_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!l", &zval_logout, &remote_providerID_str, &remote_providerID_len, &request_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_logout_init_request(logout, remote_providerID, request_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_process_request_msg)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_logout, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_logout_process_request_msg(logout, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_process_response_msg)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_logout, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_logout_process_response_msg(logout, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_reset_providerID_index)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
    return_c_value =  lasso_logout_reset_providerID_index(logout);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_logout_validate_request)
{
    LassoLogout* logout = NULL;
    zval* zval_logout = NULL;
    PhpGObjectPtr* cvt_logout = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout, PhpGObjectPtr *, &zval_logout, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout = (LassoLogout*)cvt_logout->obj;
    return_c_value =  lasso_logout_validate_request(logout);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoNameIdentifierMapping_targetNameIdentifier_get)
{
    gchar* return_c_value;
    LassoNameIdentifierMapping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoNameIdentifierMapping*)cvt_this->obj;

    return_c_value = (gchar*)this->targetNameIdentifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoNameIdentifierMapping_targetNameIdentifier_set)
{
    LassoNameIdentifierMapping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* targetNameIdentifier_str = NULL;
    int targetNameIdentifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &targetNameIdentifier_str, &targetNameIdentifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoNameIdentifierMapping*)cvt_this->obj;

    lasso_assign_string(this->targetNameIdentifier, targetNameIdentifier_str);
}

PHP_FUNCTION(lasso_name_identifier_mapping_build_request_msg)
{
    LassoNameIdentifierMapping* mapping = NULL;
    zval* zval_mapping = NULL;
    PhpGObjectPtr* cvt_mapping = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_mapping) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_mapping, PhpGObjectPtr *, &zval_mapping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    mapping = (LassoNameIdentifierMapping*)cvt_mapping->obj;
    return_c_value =  lasso_name_identifier_mapping_build_request_msg(mapping);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_identifier_mapping_build_response_msg)
{
    LassoNameIdentifierMapping* mapping = NULL;
    zval* zval_mapping = NULL;
    PhpGObjectPtr* cvt_mapping = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_mapping) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_mapping, PhpGObjectPtr *, &zval_mapping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    mapping = (LassoNameIdentifierMapping*)cvt_mapping->obj;
    return_c_value =  lasso_name_identifier_mapping_build_response_msg(mapping);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_identifier_mapping_init_request)
{
    LassoNameIdentifierMapping* mapping = NULL;
    zval* zval_mapping = NULL;
    PhpGObjectPtr* cvt_mapping = NULL;
    char* targetNamespace = NULL;
    char* targetNamespace_str = NULL;
    int targetNamespace_len = 0;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_mapping, &targetNamespace_str, &targetNamespace_len, &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_mapping, PhpGObjectPtr *, &zval_mapping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    mapping = (LassoNameIdentifierMapping*)cvt_mapping->obj;
        targetNamespace = targetNamespace_str;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_name_identifier_mapping_init_request(mapping, targetNamespace, remote_providerID);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_identifier_mapping_process_request_msg)
{
    LassoNameIdentifierMapping* mapping = NULL;
    zval* zval_mapping = NULL;
    PhpGObjectPtr* cvt_mapping = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_mapping, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_mapping, PhpGObjectPtr *, &zval_mapping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    mapping = (LassoNameIdentifierMapping*)cvt_mapping->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_name_identifier_mapping_process_request_msg(mapping, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_identifier_mapping_process_response_msg)
{
    LassoNameIdentifierMapping* mapping = NULL;
    zval* zval_mapping = NULL;
    PhpGObjectPtr* cvt_mapping = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_mapping, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_mapping, PhpGObjectPtr *, &zval_mapping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    mapping = (LassoNameIdentifierMapping*)cvt_mapping->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_name_identifier_mapping_process_response_msg(mapping, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_identifier_mapping_validate_request)
{
    LassoNameIdentifierMapping* mapping = NULL;
    zval* zval_mapping = NULL;
    PhpGObjectPtr* cvt_mapping = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_mapping) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_mapping, PhpGObjectPtr *, &zval_mapping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    mapping = (LassoNameIdentifierMapping*)cvt_mapping->obj;
    return_c_value =  lasso_name_identifier_mapping_validate_request(mapping);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSession_assertions_get)
{
    GHashTable* return_c_value;
    LassoSession* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSession*)cvt_this->obj;

    return_c_value = (GHashTable*)this->assertions;
    set_array_from_hashtable_of_objects(return_c_value, &return_value);

}

PHP_FUNCTION(LassoSession_assertions_set)
{
    LassoSession* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_assertions;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_assertions) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSession*)cvt_this->obj;

        {
            GHashTable *oldhash = this->assertions;
            this->assertions = get_hashtable_from_array_of_objects(zval_assertions);
            g_hash_table_destroy(oldhash);
        }
}

PHP_FUNCTION(LassoSession_isDirty_get)
{
    gboolean return_c_value;
    LassoSession* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSession*)cvt_this->obj;

    return_c_value = (gboolean)this->is_dirty;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoSession_isDirty_set)
{
    LassoSession* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long is_dirty;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &is_dirty) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSession*)cvt_this->obj;

    this->is_dirty = is_dirty;
}

PHP_FUNCTION(lasso_session_dump)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_session) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
    return_c_value =  lasso_session_dump(session);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_session_get_assertions)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* provider_id = NULL;
    char* provider_id_str = NULL;
    int provider_id_len = 0;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_session, &provider_id_str, &provider_id_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        provider_id = provider_id_str;
    return_c_value =  lasso_session_get_assertions(session, provider_id);
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(lasso_session_get_provider_index)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    long index;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_session, &index) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
    return_c_value =  lasso_session_get_provider_index(session, index);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_session_is_empty)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_session) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
    return_c_value =  lasso_session_is_empty(session);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_session_remove_assertion)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_session, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        providerID = providerID_str;
    return_c_value =  lasso_session_remove_assertion(session, providerID);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_session_get_assertion)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_session, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        providerID = providerID_str;
    return_c_value =  lasso_session_get_assertion(session, providerID);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_session_add_assertion)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoNode* assertion = NULL;
    zval* zval_assertion = NULL;
    PhpGObjectPtr* cvt_assertion = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!r", &zval_session, &providerID_str, &providerID_len, &zval_assertion) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_assertion, PhpGObjectPtr *, &zval_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion = (LassoNode*)cvt_assertion->obj;
    return_c_value =  lasso_session_add_assertion(session, providerID, assertion);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_session_get_name_ids)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_session, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        providerID = providerID_str;
    return_c_value =  lasso_session_get_name_ids(session, providerID);
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

    lasso_release_list_of_gobjects(return_c_value);
}

PHP_FUNCTION(lasso_session_get_session_indexes)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    LassoNode* name_id = NULL;
    zval* zval_name_id = NULL;
    PhpGObjectPtr* cvt_name_id = NULL;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!r", &zval_session, &providerID_str, &providerID_len, &zval_name_id) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        providerID = providerID_str;
    ZEND_FETCH_RESOURCE(cvt_name_id, PhpGObjectPtr *, &zval_name_id, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id = (LassoNode*)cvt_name_id->obj;
    return_c_value =  lasso_session_get_session_indexes(session, providerID, name_id);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

    lasso_release_list_of_strings(return_c_value);
}

PHP_FUNCTION(lasso_session_get_assertion_ids)
{
    LassoSession* session = NULL;
    zval* zval_session = NULL;
    PhpGObjectPtr* cvt_session = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_session, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_session, PhpGObjectPtr *, &zval_session, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    session = (LassoSession*)cvt_session->obj;
        providerID = providerID_str;
    return_c_value =  lasso_session_get_assertion_ids(session, providerID);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

    lasso_release_list_of_strings(return_c_value);
}

PHP_FUNCTION(LassoLogin_protocolProfile_get)
{
    LassoLoginProtocolProfile return_c_value;
    LassoLogin* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLogin*)cvt_this->obj;

    return_c_value = (LassoLoginProtocolProfile)this->protocolProfile;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoLogin_protocolProfile_set)
{
    LassoLogin* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long protocolProfile;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &protocolProfile) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLogin*)cvt_this->obj;

    this->protocolProfile = protocolProfile;
}

PHP_FUNCTION(LassoLogin_assertionArtifact_get)
{
    gchar* return_c_value;
    LassoLogin* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLogin*)cvt_this->obj;

    return_c_value = (gchar*)this->assertionArtifact;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLogin_assertionArtifact_set)
{
    LassoLogin* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* assertionArtifact_str = NULL;
    int assertionArtifact_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &assertionArtifact_str, &assertionArtifact_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLogin*)cvt_this->obj;

    lasso_assign_string(this->assertionArtifact, assertionArtifact_str);
}

PHP_FUNCTION(lasso_login_accept_sso)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_accept_sso(login);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_build_artifact_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    long http_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_login, &http_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_build_artifact_msg(login, http_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_build_assertion)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* authenticationMethod = NULL;
    char* authenticationMethod_str = NULL;
    int authenticationMethod_len = 0;
    char* authenticationInstant = NULL;
    char* authenticationInstant_str = NULL;
    int authenticationInstant_len = 0;
    char* reauthenticateOnOrAfter = NULL;
    char* reauthenticateOnOrAfter_str = NULL;
    int reauthenticateOnOrAfter_len = 0;
    char* notBefore = NULL;
    char* notBefore_str = NULL;
    int notBefore_len = 0;
    char* notOnOrAfter = NULL;
    char* notOnOrAfter_str = NULL;
    int notOnOrAfter_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!s!s!s!", &zval_login, &authenticationMethod_str, &authenticationMethod_len, &authenticationInstant_str, &authenticationInstant_len, &reauthenticateOnOrAfter_str, &reauthenticateOnOrAfter_len, &notBefore_str, &notBefore_len, &notOnOrAfter_str, &notOnOrAfter_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        authenticationMethod = authenticationMethod_str;
        authenticationInstant = authenticationInstant_str;
        reauthenticateOnOrAfter = reauthenticateOnOrAfter_str;
        notBefore = notBefore_str;
        notOnOrAfter = notOnOrAfter_str;
    return_c_value =  lasso_login_build_assertion(login, authenticationMethod, authenticationInstant, reauthenticateOnOrAfter, notBefore, notOnOrAfter);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_build_authn_request_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_build_authn_request_msg(login);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_build_authn_response_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_build_authn_response_msg(login);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_build_request_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_build_request_msg(login);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_build_response_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_login_build_response_msg(login, remote_providerID);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_dump)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_dump(login);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_login_init_authn_request)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    long http_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!l", &zval_login, &remote_providerID_str, &remote_providerID_len, &http_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_login_init_authn_request(login, remote_providerID, http_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_init_request)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    long response_http_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!l", &zval_login, &response_msg_str, &response_msg_len, &response_http_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_login_init_request(login, response_msg, response_http_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_init_idp_initiated_authn_request)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_login_init_idp_initiated_authn_request(login, remote_providerID);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_must_ask_for_consent)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_must_ask_for_consent(login);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_login_must_authenticate)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_must_authenticate(login);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_login_process_authn_request_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* authn_request_msg = NULL;
    char* authn_request_msg_str = NULL;
    int authn_request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &authn_request_msg_str, &authn_request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        authn_request_msg = authn_request_msg_str;
    return_c_value =  lasso_login_process_authn_request_msg(login, authn_request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_process_authn_response_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* authn_response_msg = NULL;
    char* authn_response_msg_str = NULL;
    int authn_response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &authn_response_msg_str, &authn_response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        authn_response_msg = authn_response_msg_str;
    return_c_value =  lasso_login_process_authn_response_msg(login, authn_response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_process_request_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_login_process_request_msg(login, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_process_response_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_login_process_response_msg(login, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_validate_request_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    long authentication_result;
    long is_consent_obtained;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rll", &zval_login, &authentication_result, &is_consent_obtained) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_validate_request_msg(login, authentication_result, is_consent_obtained);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_process_paos_response_msg)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    char* msg = NULL;
    char* msg_str = NULL;
    int msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_login, &msg_str, &msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
        msg = msg_str;
    return_c_value =  lasso_login_process_paos_response_msg(login, msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_login_get_assertion)
{
    LassoLogin* login = NULL;
    zval* zval_login = NULL;
    PhpGObjectPtr* cvt_login = NULL;
    LassoNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_login) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_login, PhpGObjectPtr *, &zval_login, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    login = (LassoLogin*)cvt_login->obj;
    return_c_value =  lasso_login_get_assertion(login);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(LassoLecp_authnRequestEnvelope_get)
{
    LassoLibAuthnRequestEnvelope* return_c_value;
    LassoLecp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLecp*)cvt_this->obj;

    return_c_value = (LassoLibAuthnRequestEnvelope*)this->authnRequestEnvelope;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLecp_authnRequestEnvelope_set)
{
    LassoLecp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_authnRequestEnvelope = NULL;
    PhpGObjectPtr* cvt_authnRequestEnvelope = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_authnRequestEnvelope) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLecp*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_authnRequestEnvelope, PhpGObjectPtr*, &zval_authnRequestEnvelope, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->authnRequestEnvelope, cvt_authnRequestEnvelope->obj);
}

PHP_FUNCTION(LassoLecp_authnResponseEnvelope_get)
{
    LassoLibAuthnResponseEnvelope* return_c_value;
    LassoLecp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLecp*)cvt_this->obj;

    return_c_value = (LassoLibAuthnResponseEnvelope*)this->authnResponseEnvelope;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLecp_authnResponseEnvelope_set)
{
    LassoLecp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_authnResponseEnvelope = NULL;
    PhpGObjectPtr* cvt_authnResponseEnvelope = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_authnResponseEnvelope) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLecp*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_authnResponseEnvelope, PhpGObjectPtr*, &zval_authnResponseEnvelope, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->authnResponseEnvelope, cvt_authnResponseEnvelope->obj);
}

PHP_FUNCTION(LassoLecp_assertionConsumerServiceURL_get)
{
    char* return_c_value;
    LassoLecp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLecp*)cvt_this->obj;

    return_c_value = (char*)this->assertionConsumerServiceURL;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLecp_assertionConsumerServiceURL_set)
{
    LassoLecp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* assertionConsumerServiceURL_str = NULL;
    int assertionConsumerServiceURL_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &assertionConsumerServiceURL_str, &assertionConsumerServiceURL_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLecp*)cvt_this->obj;

    lasso_assign_string(this->assertionConsumerServiceURL, assertionConsumerServiceURL_str);
}

PHP_FUNCTION(lasso_lecp_build_authn_request_envelope_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_lecp) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
    return_c_value =  lasso_lecp_build_authn_request_envelope_msg(lecp);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_build_authn_request_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_lecp) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
    return_c_value =  lasso_lecp_build_authn_request_msg(lecp);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_build_authn_response_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_lecp) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
    return_c_value =  lasso_lecp_build_authn_response_msg(lecp);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_build_authn_response_envelope_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_lecp) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
    return_c_value =  lasso_lecp_build_authn_response_envelope_msg(lecp);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_init_authn_request)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_lecp, &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_lecp_init_authn_request(lecp, remote_providerID);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_process_authn_request_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    char* authn_request_msg = NULL;
    char* authn_request_msg_str = NULL;
    int authn_request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_lecp, &authn_request_msg_str, &authn_request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
        authn_request_msg = authn_request_msg_str;
    return_c_value =  lasso_lecp_process_authn_request_msg(lecp, authn_request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_process_authn_request_envelope_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_lecp, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_lecp_process_authn_request_envelope_msg(lecp, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_lecp_process_authn_response_envelope_msg)
{
    LassoLecp* lecp = NULL;
    zval* zval_lecp = NULL;
    PhpGObjectPtr* cvt_lecp = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_lecp, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lecp, PhpGObjectPtr *, &zval_lecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lecp = (LassoLecp*)cvt_lecp->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_lecp_process_authn_response_envelope_msg(lecp, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoFederation_remoteProviderId_get)
{
    gchar* return_c_value;
    LassoFederation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoFederation*)cvt_this->obj;

    return_c_value = (gchar*)this->remote_providerID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoFederation_remoteProviderId_set)
{
    LassoFederation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &remote_providerID_str, &remote_providerID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoFederation*)cvt_this->obj;

    lasso_assign_string(this->remote_providerID, remote_providerID_str);
}

PHP_FUNCTION(LassoFederation_localNameIdentifier_get)
{
    LassoNode* return_c_value;
    LassoFederation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoFederation*)cvt_this->obj;

    return_c_value = (LassoNode*)this->local_nameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoFederation_localNameIdentifier_set)
{
    LassoFederation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_local_nameIdentifier = NULL;
    PhpGObjectPtr* cvt_local_nameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_local_nameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoFederation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_local_nameIdentifier, PhpGObjectPtr*, &zval_local_nameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->local_nameIdentifier, cvt_local_nameIdentifier->obj);
}

PHP_FUNCTION(LassoFederation_remoteNameIdentifier_get)
{
    LassoNode* return_c_value;
    LassoFederation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoFederation*)cvt_this->obj;

    return_c_value = (LassoNode*)this->remote_nameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoFederation_remoteNameIdentifier_set)
{
    LassoFederation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_remote_nameIdentifier = NULL;
    PhpGObjectPtr* cvt_remote_nameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_remote_nameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoFederation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_remote_nameIdentifier, PhpGObjectPtr*, &zval_remote_nameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->remote_nameIdentifier, cvt_remote_nameIdentifier->obj);
}

PHP_FUNCTION(lasso_federation_build_local_name_identifier)
{
    LassoFederation* federation = NULL;
    zval* zval_federation = NULL;
    PhpGObjectPtr* cvt_federation = NULL;
    char* nameQualifier = NULL;
    char* nameQualifier_str = NULL;
    int nameQualifier_len = 0;
    char* format = NULL;
    char* format_str = NULL;
    int format_len = 0;
    char* content = NULL;
    char* content_str = NULL;
    int content_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!s!", &zval_federation, &nameQualifier_str, &nameQualifier_len, &format_str, &format_len, &content_str, &content_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_federation, PhpGObjectPtr *, &zval_federation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    federation = (LassoFederation*)cvt_federation->obj;
        nameQualifier = nameQualifier_str;
        format = format_str;
        content = content_str;
    lasso_federation_build_local_name_identifier(federation, nameQualifier, format, content);
}

PHP_FUNCTION(lasso_federation_verify_name_identifier)
{
    LassoFederation* federation = NULL;
    zval* zval_federation = NULL;
    PhpGObjectPtr* cvt_federation = NULL;
    LassoNode* name_identifier = NULL;
    zval* zval_name_identifier = NULL;
    PhpGObjectPtr* cvt_name_identifier = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_federation, &zval_name_identifier) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_federation, PhpGObjectPtr *, &zval_federation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    federation = (LassoFederation*)cvt_federation->obj;
    ZEND_FETCH_RESOURCE(cvt_name_identifier, PhpGObjectPtr *, &zval_name_identifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_identifier = (LassoNode*)cvt_name_identifier->obj;
    return_c_value =  lasso_federation_verify_name_identifier(federation, name_identifier);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoNameRegistration_oldNameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoNameRegistration* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoNameRegistration*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->oldNameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoNameRegistration_oldNameIdentifier_set)
{
    LassoNameRegistration* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_oldNameIdentifier = NULL;
    PhpGObjectPtr* cvt_oldNameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_oldNameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoNameRegistration*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_oldNameIdentifier, PhpGObjectPtr*, &zval_oldNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->oldNameIdentifier, cvt_oldNameIdentifier->obj);
}

PHP_FUNCTION(lasso_name_registration_build_request_msg)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_registration) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
    return_c_value =  lasso_name_registration_build_request_msg(name_registration);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_build_response_msg)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_registration) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
    return_c_value =  lasso_name_registration_build_response_msg(name_registration);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_dump)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    gchar* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_registration) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
    return_c_value =  lasso_name_registration_dump(name_registration);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_init_request)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    char* remote_providerID = NULL;
    char* remote_providerID_str = NULL;
    int remote_providerID_len = 0;
    long http_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!l", &zval_name_registration, &remote_providerID_str, &remote_providerID_len, &http_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
        remote_providerID = remote_providerID_str;
    return_c_value =  lasso_name_registration_init_request(name_registration, remote_providerID, http_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_process_request_msg)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_name_registration, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_name_registration_process_request_msg(name_registration, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_process_response_msg)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_name_registration, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_name_registration_process_response_msg(name_registration, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_registration_validate_request)
{
    LassoNameRegistration* name_registration = NULL;
    zval* zval_name_registration = NULL;
    PhpGObjectPtr* cvt_name_registration = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_registration) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_registration, PhpGObjectPtr *, &zval_name_registration, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_registration = (LassoNameRegistration*)cvt_name_registration->obj;
    return_c_value =  lasso_name_registration_validate_request(name_registration);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoEcp_assertionConsumerURL_get)
{
    gchar* return_c_value;
    LassoEcp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoEcp*)cvt_this->obj;

    return_c_value = (gchar*)this->assertionConsumerURL;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoEcp_assertionConsumerURL_set)
{
    LassoEcp* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* assertionConsumerURL_str = NULL;
    int assertionConsumerURL_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &assertionConsumerURL_str, &assertionConsumerURL_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoEcp*)cvt_this->obj;

    lasso_assign_string(this->assertionConsumerURL, assertionConsumerURL_str);
}

PHP_FUNCTION(lasso_ecp_process_authn_request_msg)
{
    LassoEcp* ecp = NULL;
    zval* zval_ecp = NULL;
    PhpGObjectPtr* cvt_ecp = NULL;
    char* authn_request_msg = NULL;
    char* authn_request_msg_str = NULL;
    int authn_request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_ecp, &authn_request_msg_str, &authn_request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_ecp, PhpGObjectPtr *, &zval_ecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    ecp = (LassoEcp*)cvt_ecp->obj;
        authn_request_msg = authn_request_msg_str;
    return_c_value =  lasso_ecp_process_authn_request_msg(ecp, authn_request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_ecp_process_response_msg)
{
    LassoEcp* ecp = NULL;
    zval* zval_ecp = NULL;
    PhpGObjectPtr* cvt_ecp = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_ecp, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_ecp, PhpGObjectPtr *, &zval_ecp, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    ecp = (LassoEcp*)cvt_ecp->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_ecp_process_response_msg(ecp, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_dump)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_id_management) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
    return_c_value =  lasso_name_id_management_dump(name_id_management);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
    free(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_init_request)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    char* remote_provider_id = NULL;
    char* remote_provider_id_str = NULL;
    int remote_provider_id_len = 0;
    char* new_name_id = NULL;
    char* new_name_id_str = NULL;
    int new_name_id_len = 0;
    long http_method;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!l", &zval_name_id_management, &remote_provider_id_str, &remote_provider_id_len, &new_name_id_str, &new_name_id_len, &http_method) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
        remote_provider_id = remote_provider_id_str;
        new_name_id = new_name_id_str;
    return_c_value =  lasso_name_id_management_init_request(name_id_management, remote_provider_id, new_name_id, http_method);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_build_request_msg)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_id_management) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
    return_c_value =  lasso_name_id_management_build_request_msg(name_id_management);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_process_request_msg)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_name_id_management, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_name_id_management_process_request_msg(name_id_management, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_validate_request)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_id_management) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
    return_c_value =  lasso_name_id_management_validate_request(name_id_management);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_build_response_msg)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_name_id_management) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
    return_c_value =  lasso_name_id_management_build_response_msg(name_id_management);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_name_id_management_process_response_msg)
{
    LassoNameIdManagement* name_id_management = NULL;
    zval* zval_name_id_management = NULL;
    PhpGObjectPtr* cvt_name_id_management = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_name_id_management, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id_management, PhpGObjectPtr *, &zval_name_id_management, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id_management = (LassoNameIdManagement*)cvt_name_id_management->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_name_id_management_process_response_msg(name_id_management, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_init_request)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    char* remote_provider_id = NULL;
    char* remote_provider_id_str = NULL;
    int remote_provider_id_len = 0;
    long http_method;
    long query_request_type;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!ll", &zval_assertion_query, &remote_provider_id_str, &remote_provider_id_len, &http_method, &query_request_type) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
        remote_provider_id = remote_provider_id_str;
    return_c_value =  lasso_assertion_query_init_request(assertion_query, remote_provider_id, http_method, query_request_type);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_validate_request)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_assertion_query) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
    return_c_value =  lasso_assertion_query_validate_request(assertion_query);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_build_request_msg)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_assertion_query) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
    return_c_value =  lasso_assertion_query_build_request_msg(assertion_query);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_process_request_msg)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    char* request_msg = NULL;
    char* request_msg_str = NULL;
    int request_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_assertion_query, &request_msg_str, &request_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
        request_msg = request_msg_str;
    return_c_value =  lasso_assertion_query_process_request_msg(assertion_query, request_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_build_response_msg)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_assertion_query) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
    return_c_value =  lasso_assertion_query_build_response_msg(assertion_query);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_process_response_msg)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    char* response_msg = NULL;
    char* response_msg_str = NULL;
    int response_msg_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_assertion_query, &response_msg_str, &response_msg_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
        response_msg = response_msg_str;
    return_c_value =  lasso_assertion_query_process_response_msg(assertion_query, response_msg);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_add_attribute_request)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    char* format = NULL;
    char* format_str = NULL;
    int format_len = 0;
    char* name = NULL;
    char* name_str = NULL;
    int name_len = 0;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_assertion_query, &format_str, &format_len, &name_str, &name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
        format = format_str;
        name = name_str;
    return_c_value =  lasso_assertion_query_add_attribute_request(assertion_query, format, name);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_assertion_query_get_request_type)
{
    LassoAssertionQuery* assertion_query = NULL;
    zval* zval_assertion_query = NULL;
    PhpGObjectPtr* cvt_assertion_query = NULL;
    LassoAssertionQueryRequestType return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_assertion_query) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion_query, PhpGObjectPtr *, &zval_assertion_query, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion_query = (LassoAssertionQuery*)cvt_assertion_query->obj;
    return_c_value =  lasso_assertion_query_get_request_type(assertion_query);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlAssertion_conditions_get)
{
    LassoSamlConditions* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSamlConditions*)this->Conditions;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_conditions_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Conditions = NULL;
    PhpGObjectPtr* cvt_Conditions = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Conditions) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Conditions, PhpGObjectPtr*, &zval_Conditions, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Conditions, cvt_Conditions->obj);
}

PHP_FUNCTION(LassoSamlAssertion_advice_get)
{
    LassoSamlAdvice* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSamlAdvice*)this->Advice;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_advice_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Advice = NULL;
    PhpGObjectPtr* cvt_Advice = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Advice) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Advice, PhpGObjectPtr*, &zval_Advice, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Advice, cvt_Advice->obj);
}

PHP_FUNCTION(LassoSamlAssertion_subjectStatement_get)
{
    LassoSamlSubjectStatement* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSamlSubjectStatement*)this->SubjectStatement;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_subjectStatement_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SubjectStatement = NULL;
    PhpGObjectPtr* cvt_SubjectStatement = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SubjectStatement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SubjectStatement, PhpGObjectPtr*, &zval_SubjectStatement, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SubjectStatement, cvt_SubjectStatement->obj);
}

PHP_FUNCTION(LassoSamlAssertion_authenticationStatement_get)
{
    LassoSamlAuthenticationStatement* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSamlAuthenticationStatement*)this->AuthenticationStatement;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_authenticationStatement_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthenticationStatement = NULL;
    PhpGObjectPtr* cvt_AuthenticationStatement = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_AuthenticationStatement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_AuthenticationStatement, PhpGObjectPtr*, &zval_AuthenticationStatement, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->AuthenticationStatement, cvt_AuthenticationStatement->obj);
}

PHP_FUNCTION(LassoSamlAssertion_attributeStatement_get)
{
    LassoSamlAttributeStatement* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSamlAttributeStatement*)this->AttributeStatement;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_attributeStatement_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AttributeStatement = NULL;
    PhpGObjectPtr* cvt_AttributeStatement = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_AttributeStatement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_AttributeStatement, PhpGObjectPtr*, &zval_AttributeStatement, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->AttributeStatement, cvt_AttributeStatement->obj);
}

PHP_FUNCTION(LassoSamlAssertion_majorVersion_get)
{
    int return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (int)this->MajorVersion;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlAssertion_majorVersion_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long MajorVersion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &MajorVersion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    this->MajorVersion = MajorVersion;
}

PHP_FUNCTION(LassoSamlAssertion_minorVersion_get)
{
    int return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (int)this->MinorVersion;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlAssertion_minorVersion_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long MinorVersion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &MinorVersion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    this->MinorVersion = MinorVersion;
}

PHP_FUNCTION(LassoSamlAssertion_assertionId_get)
{
    char* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (char*)this->AssertionID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_assertionId_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionID_str = NULL;
    int AssertionID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionID_str, &AssertionID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    lasso_assign_string(this->AssertionID, AssertionID_str);
}

PHP_FUNCTION(LassoSamlAssertion_issuer_get)
{
    char* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (char*)this->Issuer;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_issuer_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Issuer_str = NULL;
    int Issuer_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Issuer_str, &Issuer_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    lasso_assign_string(this->Issuer, Issuer_str);
}

PHP_FUNCTION(LassoSamlAssertion_issueInstant_get)
{
    char* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (char*)this->IssueInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_issueInstant_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IssueInstant_str = NULL;
    int IssueInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IssueInstant_str, &IssueInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    lasso_assign_string(this->IssueInstant, IssueInstant_str);
}

PHP_FUNCTION(LassoSamlAssertion_signType_get)
{
    LassoSignatureType return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSignatureType)this->sign_type;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlAssertion_signType_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long sign_type;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &sign_type) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    this->sign_type = sign_type;
}

PHP_FUNCTION(LassoSamlAssertion_signMethod_get)
{
    LassoSignatureMethod return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (LassoSignatureMethod)this->sign_method;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlAssertion_signMethod_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long sign_method;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &sign_method) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    this->sign_method = sign_method;
}

PHP_FUNCTION(LassoSamlAssertion_privateKeyFile_get)
{
    char* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (char*)this->private_key_file;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_privateKeyFile_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* private_key_file_str = NULL;
    int private_key_file_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &private_key_file_str, &private_key_file_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    lasso_assign_string(this->private_key_file, private_key_file_str);
}

PHP_FUNCTION(LassoSamlAssertion_certificateFile_get)
{
    char* return_c_value;
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    return_c_value = (char*)this->certificate_file;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAssertion_certificateFile_set)
{
    LassoSamlAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* certificate_file_str = NULL;
    int certificate_file_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &certificate_file_str, &certificate_file_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAssertion*)cvt_this->obj;

    lasso_assign_string(this->certificate_file, certificate_file_str);
}

PHP_FUNCTION(LassoLibRequestAuthnContext_authnContextClassRef_get)
{
    GList* return_c_value;
    LassoLibRequestAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRequestAuthnContext*)cvt_this->obj;

    return_c_value = (GList*)this->AuthnContextClassRef;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibRequestAuthnContext_authnContextClassRef_set)
{
    LassoLibRequestAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnContextClassRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthnContextClassRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRequestAuthnContext*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->AuthnContextClassRef, get_list_from_array_of_strings(zval_AuthnContextClassRef));
}

PHP_FUNCTION(LassoLibRequestAuthnContext_authnContextStatementRef_get)
{
    GList* return_c_value;
    LassoLibRequestAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRequestAuthnContext*)cvt_this->obj;

    return_c_value = (GList*)this->AuthnContextStatementRef;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibRequestAuthnContext_authnContextStatementRef_set)
{
    LassoLibRequestAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnContextStatementRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthnContextStatementRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRequestAuthnContext*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->AuthnContextStatementRef, get_list_from_array_of_strings(zval_AuthnContextStatementRef));
}

PHP_FUNCTION(LassoLibRequestAuthnContext_authnContextComparison_get)
{
    char* return_c_value;
    LassoLibRequestAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRequestAuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->AuthnContextComparison;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibRequestAuthnContext_authnContextComparison_set)
{
    LassoLibRequestAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthnContextComparison_str = NULL;
    int AuthnContextComparison_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthnContextComparison_str, &AuthnContextComparison_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRequestAuthnContext*)cvt_this->obj;

    lasso_assign_string(this->AuthnContextComparison, AuthnContextComparison_str);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_extension_get)
{
    GList* return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_extension_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_authnRequest_get)
{
    LassoLibAuthnRequest* return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (LassoLibAuthnRequest*)this->AuthnRequest;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_authnRequest_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnRequest = NULL;
    PhpGObjectPtr* cvt_AuthnRequest = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_AuthnRequest) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_AuthnRequest, PhpGObjectPtr*, &zval_AuthnRequest, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->AuthnRequest, cvt_AuthnRequest->obj);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_providerId_get)
{
    char* return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_providerId_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_providerName_get)
{
    char* return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (char*)this->ProviderName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_providerName_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderName_str = NULL;
    int ProviderName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderName_str, &ProviderName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    lasso_assign_string(this->ProviderName, ProviderName_str);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_assertionConsumerServiceUrl_get)
{
    char* return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (char*)this->AssertionConsumerServiceURL;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_assertionConsumerServiceUrl_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionConsumerServiceURL_str = NULL;
    int AssertionConsumerServiceURL_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionConsumerServiceURL_str, &AssertionConsumerServiceURL_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    lasso_assign_string(this->AssertionConsumerServiceURL, AssertionConsumerServiceURL_str);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_idpList_get)
{
    LassoLibIDPList* return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (LassoLibIDPList*)this->IDPList;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_idpList_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPList = NULL;
    PhpGObjectPtr* cvt_IDPList = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPList) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPList, PhpGObjectPtr*, &zval_IDPList, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPList, cvt_IDPList->obj);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_isPassive_get)
{
    gboolean return_c_value;
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    return_c_value = (gboolean)this->IsPassive;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoLibAuthnRequestEnvelope_isPassive_set)
{
    LassoLibAuthnRequestEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long IsPassive;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &IsPassive) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequestEnvelope*)cvt_this->obj;

    this->IsPassive = IsPassive;
}

PHP_FUNCTION(LassoMiscTextNode_content_get)
{
    char* return_c_value;
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    return_c_value = (char*)this->content;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoMiscTextNode_content_set)
{
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* content_str = NULL;
    int content_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &content_str, &content_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    lasso_assign_string(this->content, content_str);
}

PHP_FUNCTION(LassoMiscTextNode_name_get)
{
    char* return_c_value;
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    return_c_value = (char*)this->name;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoMiscTextNode_name_set)
{
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* name_str = NULL;
    int name_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &name_str, &name_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    lasso_assign_string(this->name, name_str);
}

PHP_FUNCTION(LassoMiscTextNode_nsHref_get)
{
    char* return_c_value;
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    return_c_value = (char*)this->ns_href;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoMiscTextNode_nsHref_set)
{
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ns_href_str = NULL;
    int ns_href_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ns_href_str, &ns_href_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    lasso_assign_string(this->ns_href, ns_href_str);
}

PHP_FUNCTION(LassoMiscTextNode_nsPrefix_get)
{
    char* return_c_value;
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    return_c_value = (char*)this->ns_prefix;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoMiscTextNode_nsPrefix_set)
{
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ns_prefix_str = NULL;
    int ns_prefix_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ns_prefix_str, &ns_prefix_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    lasso_assign_string(this->ns_prefix, ns_prefix_str);
}

PHP_FUNCTION(LassoMiscTextNode_textChild_get)
{
    gboolean return_c_value;
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    return_c_value = (gboolean)this->text_child;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoMiscTextNode_textChild_set)
{
    LassoMiscTextNode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long text_child;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &text_child) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoMiscTextNode*)cvt_this->obj;

    this->text_child = text_child;
}

PHP_FUNCTION(lasso_misc_text_node_set_xml_content)
{
    LassoMiscTextNode* misc_text_node = NULL;
    zval* zval_misc_text_node = NULL;
    PhpGObjectPtr* cvt_misc_text_node = NULL;
    xmlNode* node = NULL;
    char* node_str = NULL;
    int node_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_misc_text_node, &node_str, &node_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_misc_text_node, PhpGObjectPtr *, &zval_misc_text_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    misc_text_node = (LassoMiscTextNode*)cvt_misc_text_node->obj;
        node = get_xml_node_from_string(node_str);
    lasso_misc_text_node_set_xml_content(misc_text_node, node);
    xmlFree(node);
}

PHP_FUNCTION(lasso_misc_text_node_get_xml_content)
{
    LassoMiscTextNode* misc_text_node = NULL;
    zval* zval_misc_text_node = NULL;
    PhpGObjectPtr* cvt_misc_text_node = NULL;
    xmlNode* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_misc_text_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_misc_text_node, PhpGObjectPtr *, &zval_misc_text_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    misc_text_node = (LassoMiscTextNode*)cvt_misc_text_node->obj;
    return_c_value =  lasso_misc_text_node_get_xml_content(misc_text_node);
    {
        char* xmlString = get_string_from_xml_node(return_c_value);
        if (xmlString) {
            RETVAL_STRING(xmlString, 0);
        } else {
            RETVAL_NULL();
        }
    }

}

PHP_FUNCTION(LassoLibAuthnContext_authnContextClassRef_get)
{
    char* return_c_value;
    LassoLibAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->AuthnContextClassRef;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnContext_authnContextClassRef_set)
{
    LassoLibAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthnContextClassRef_str = NULL;
    int AuthnContextClassRef_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthnContextClassRef_str, &AuthnContextClassRef_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnContext*)cvt_this->obj;

    lasso_assign_string(this->AuthnContextClassRef, AuthnContextClassRef_str);
}

PHP_FUNCTION(LassoLibAuthnContext_authnContextStatementRef_get)
{
    char* return_c_value;
    LassoLibAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->AuthnContextStatementRef;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnContext_authnContextStatementRef_set)
{
    LassoLibAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthnContextStatementRef_str = NULL;
    int AuthnContextStatementRef_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthnContextStatementRef_str, &AuthnContextStatementRef_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnContext*)cvt_this->obj;

    lasso_assign_string(this->AuthnContextStatementRef, AuthnContextStatementRef_str);
}

PHP_FUNCTION(LassoSamlpStatus_statusCode_get)
{
    LassoSamlpStatusCode* return_c_value;
    LassoSamlpStatus* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatus*)cvt_this->obj;

    return_c_value = (LassoSamlpStatusCode*)this->StatusCode;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpStatus_statusCode_set)
{
    LassoSamlpStatus* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_StatusCode = NULL;
    PhpGObjectPtr* cvt_StatusCode = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_StatusCode) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatus*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_StatusCode, PhpGObjectPtr*, &zval_StatusCode, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->StatusCode, cvt_StatusCode->obj);
}

PHP_FUNCTION(LassoSamlpStatus_statusMessage_get)
{
    char* return_c_value;
    LassoSamlpStatus* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatus*)cvt_this->obj;

    return_c_value = (char*)this->StatusMessage;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpStatus_statusMessage_set)
{
    LassoSamlpStatus* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* StatusMessage_str = NULL;
    int StatusMessage_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &StatusMessage_str, &StatusMessage_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatus*)cvt_this->obj;

    lasso_assign_string(this->StatusMessage, StatusMessage_str);
}

PHP_FUNCTION(LassoSamlSubjectConfirmation_confirmationMethod_get)
{
    GList* return_c_value;
    LassoSamlSubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectConfirmation*)cvt_this->obj;

    return_c_value = (GList*)this->ConfirmationMethod;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlSubjectConfirmation_confirmationMethod_set)
{
    LassoSamlSubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_ConfirmationMethod;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_ConfirmationMethod) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectConfirmation*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->ConfirmationMethod, get_list_from_array_of_strings(zval_ConfirmationMethod));
}

PHP_FUNCTION(LassoSamlSubjectConfirmation_subjectConfirmationData_get)
{
    char* return_c_value;
    LassoSamlSubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectConfirmation*)cvt_this->obj;

    return_c_value = (char*)this->SubjectConfirmationData;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubjectConfirmation_subjectConfirmationData_set)
{
    LassoSamlSubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SubjectConfirmationData_str = NULL;
    int SubjectConfirmationData_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SubjectConfirmationData_str, &SubjectConfirmationData_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectConfirmation*)cvt_this->obj;

    lasso_assign_string(this->SubjectConfirmationData, SubjectConfirmationData_str);
}

PHP_FUNCTION(LassoSamlSubjectConfirmation_keyInfo_get)
{
    LassoDsKeyInfo* return_c_value;
    LassoSamlSubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectConfirmation*)cvt_this->obj;

    return_c_value = (LassoDsKeyInfo*)this->KeyInfo;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubjectConfirmation_keyInfo_set)
{
    LassoSamlSubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_KeyInfo = NULL;
    PhpGObjectPtr* cvt_KeyInfo = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_KeyInfo) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectConfirmation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_KeyInfo, PhpGObjectPtr*, &zval_KeyInfo, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->KeyInfo, cvt_KeyInfo->obj);
}

PHP_FUNCTION(LassoLibIDPList_idpEntries_get)
{
    LassoLibIDPEntries* return_c_value;
    LassoLibIDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPList*)cvt_this->obj;

    return_c_value = (LassoLibIDPEntries*)this->IDPEntries;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibIDPList_idpEntries_set)
{
    LassoLibIDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPEntries = NULL;
    PhpGObjectPtr* cvt_IDPEntries = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPEntries) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPList*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPEntries, PhpGObjectPtr*, &zval_IDPEntries, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPEntries, cvt_IDPEntries->obj);
}

PHP_FUNCTION(LassoLibIDPList_getComplete_get)
{
    char* return_c_value;
    LassoLibIDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPList*)cvt_this->obj;

    return_c_value = (char*)this->GetComplete;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibIDPList_getComplete_set)
{
    LassoLibIDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* GetComplete_str = NULL;
    int GetComplete_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &GetComplete_str, &GetComplete_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPList*)cvt_this->obj;

    lasso_assign_string(this->GetComplete, GetComplete_str);
}

PHP_FUNCTION(LassoSamlSubjectLocality_ipAddress_get)
{
    char* return_c_value;
    LassoSamlSubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectLocality*)cvt_this->obj;

    return_c_value = (char*)this->IPAddress;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubjectLocality_ipAddress_set)
{
    LassoSamlSubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IPAddress_str = NULL;
    int IPAddress_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IPAddress_str, &IPAddress_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectLocality*)cvt_this->obj;

    lasso_assign_string(this->IPAddress, IPAddress_str);
}

PHP_FUNCTION(LassoSamlSubjectLocality_dnsAddress_get)
{
    char* return_c_value;
    LassoSamlSubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectLocality*)cvt_this->obj;

    return_c_value = (char*)this->DNSAddress;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubjectLocality_dnsAddress_set)
{
    LassoSamlSubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* DNSAddress_str = NULL;
    int DNSAddress_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &DNSAddress_str, &DNSAddress_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectLocality*)cvt_this->obj;

    lasso_assign_string(this->DNSAddress, DNSAddress_str);
}

PHP_FUNCTION(LassoSamlAttributeValue_any_get)
{
    GList* return_c_value;
    LassoSamlAttributeValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeValue*)cvt_this->obj;

    return_c_value = (GList*)this->any;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlAttributeValue_any_set)
{
    LassoSamlAttributeValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_any;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_any) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeValue*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->any, get_list_from_array_of_objects(zval_any));
}

PHP_FUNCTION(LassoSamlAudienceRestrictionCondition_audience_get)
{
    GList* return_c_value;
    LassoSamlAudienceRestrictionCondition* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAudienceRestrictionCondition*)cvt_this->obj;

    return_c_value = (GList*)this->Audience;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlAudienceRestrictionCondition_audience_set)
{
    LassoSamlAudienceRestrictionCondition* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Audience;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Audience) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAudienceRestrictionCondition*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->Audience, get_list_from_array_of_strings(zval_Audience));
}

PHP_FUNCTION(LassoLibScoping_proxyCount_get)
{
    int return_c_value;
    LassoLibScoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibScoping*)cvt_this->obj;

    return_c_value = (int)this->ProxyCount;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoLibScoping_proxyCount_set)
{
    LassoLibScoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long ProxyCount;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &ProxyCount) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibScoping*)cvt_this->obj;

    this->ProxyCount = ProxyCount;
}

PHP_FUNCTION(LassoLibScoping_idpList_get)
{
    LassoLibIDPList* return_c_value;
    LassoLibScoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibScoping*)cvt_this->obj;

    return_c_value = (LassoLibIDPList*)this->IDPList;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibScoping_idpList_set)
{
    LassoLibScoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPList = NULL;
    PhpGObjectPtr* cvt_IDPList = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPList) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibScoping*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPList, PhpGObjectPtr*, &zval_IDPList, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPList, cvt_IDPList->obj);
}

PHP_FUNCTION(LassoLibAuthnResponseEnvelope_extension_get)
{
    GList* return_c_value;
    LassoLibAuthnResponseEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponseEnvelope*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibAuthnResponseEnvelope_extension_set)
{
    LassoLibAuthnResponseEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponseEnvelope*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibAuthnResponseEnvelope_authnResponse_get)
{
    LassoLibAuthnResponse* return_c_value;
    LassoLibAuthnResponseEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponseEnvelope*)cvt_this->obj;

    return_c_value = (LassoLibAuthnResponse*)this->AuthnResponse;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnResponseEnvelope_authnResponse_set)
{
    LassoLibAuthnResponseEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnResponse = NULL;
    PhpGObjectPtr* cvt_AuthnResponse = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_AuthnResponse) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponseEnvelope*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_AuthnResponse, PhpGObjectPtr*, &zval_AuthnResponse, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->AuthnResponse, cvt_AuthnResponse->obj);
}

PHP_FUNCTION(LassoLibAuthnResponseEnvelope_assertionConsumerServiceUrl_get)
{
    char* return_c_value;
    LassoLibAuthnResponseEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponseEnvelope*)cvt_this->obj;

    return_c_value = (char*)this->AssertionConsumerServiceURL;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnResponseEnvelope_assertionConsumerServiceUrl_set)
{
    LassoLibAuthnResponseEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionConsumerServiceURL_str = NULL;
    int AssertionConsumerServiceURL_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionConsumerServiceURL_str, &AssertionConsumerServiceURL_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponseEnvelope*)cvt_this->obj;

    lasso_assign_string(this->AssertionConsumerServiceURL, AssertionConsumerServiceURL_str);
}

PHP_FUNCTION(LassoSamlAttributeDesignator_attributeName_get)
{
    char* return_c_value;
    LassoSamlAttributeDesignator* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeDesignator*)cvt_this->obj;

    return_c_value = (char*)this->AttributeName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAttributeDesignator_attributeName_set)
{
    LassoSamlAttributeDesignator* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AttributeName_str = NULL;
    int AttributeName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AttributeName_str, &AttributeName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeDesignator*)cvt_this->obj;

    lasso_assign_string(this->AttributeName, AttributeName_str);
}

PHP_FUNCTION(LassoSamlAttributeDesignator_attributeNamespace_get)
{
    char* return_c_value;
    LassoSamlAttributeDesignator* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeDesignator*)cvt_this->obj;

    return_c_value = (char*)this->AttributeNamespace;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAttributeDesignator_attributeNamespace_set)
{
    LassoSamlAttributeDesignator* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AttributeNamespace_str = NULL;
    int AttributeNamespace_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AttributeNamespace_str, &AttributeNamespace_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeDesignator*)cvt_this->obj;

    lasso_assign_string(this->AttributeNamespace, AttributeNamespace_str);
}

PHP_FUNCTION(LassoLibIDPEntries_idpEntry_get)
{
    GList* return_c_value;
    LassoLibIDPEntries* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntries*)cvt_this->obj;

    return_c_value = (GList*)this->IDPEntry;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibIDPEntries_idpEntry_set)
{
    LassoLibIDPEntries* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPEntry;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_IDPEntry) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntries*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->IDPEntry, get_list_from_array_of_objects(zval_IDPEntry));
}

PHP_FUNCTION(LassoSamlAdvice_assertionIdReference_get)
{
    GList* return_c_value;
    LassoSamlAdvice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAdvice*)cvt_this->obj;

    return_c_value = (GList*)this->AssertionIDReference;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlAdvice_assertionIdReference_set)
{
    LassoSamlAdvice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AssertionIDReference;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AssertionIDReference) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAdvice*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AssertionIDReference, get_list_from_array_of_objects(zval_AssertionIDReference));
}

PHP_FUNCTION(LassoSamlAdvice_assertion_get)
{
    LassoSamlAssertion* return_c_value;
    LassoSamlAdvice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAdvice*)cvt_this->obj;

    return_c_value = (LassoSamlAssertion*)this->Assertion;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAdvice_assertion_set)
{
    LassoSamlAdvice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Assertion = NULL;
    PhpGObjectPtr* cvt_Assertion = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Assertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAdvice*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Assertion, PhpGObjectPtr*, &zval_Assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Assertion, cvt_Assertion->obj);
}

PHP_FUNCTION(LassoLibAssertion_inResponseTo_get)
{
    char* return_c_value;
    LassoLibAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAssertion*)cvt_this->obj;

    return_c_value = (char*)this->InResponseTo;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAssertion_inResponseTo_set)
{
    LassoLibAssertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* InResponseTo_str = NULL;
    int InResponseTo_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &InResponseTo_str, &InResponseTo_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAssertion*)cvt_this->obj;

    lasso_assign_string(this->InResponseTo, InResponseTo_str);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_responseId_get)
{
    char* return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (char*)this->ResponseID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponseAbstract_responseId_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ResponseID_str = NULL;
    int ResponseID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ResponseID_str, &ResponseID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    lasso_assign_string(this->ResponseID, ResponseID_str);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_inResponseTo_get)
{
    char* return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (char*)this->InResponseTo;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponseAbstract_inResponseTo_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* InResponseTo_str = NULL;
    int InResponseTo_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &InResponseTo_str, &InResponseTo_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    lasso_assign_string(this->InResponseTo, InResponseTo_str);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_majorVersion_get)
{
    int return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (int)this->MajorVersion;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_majorVersion_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long MajorVersion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &MajorVersion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    this->MajorVersion = MajorVersion;
}

PHP_FUNCTION(LassoSamlpResponseAbstract_minorVersion_get)
{
    int return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (int)this->MinorVersion;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_minorVersion_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long MinorVersion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &MinorVersion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    this->MinorVersion = MinorVersion;
}

PHP_FUNCTION(LassoSamlpResponseAbstract_issueInstant_get)
{
    char* return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (char*)this->IssueInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponseAbstract_issueInstant_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IssueInstant_str = NULL;
    int IssueInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IssueInstant_str, &IssueInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    lasso_assign_string(this->IssueInstant, IssueInstant_str);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_recipient_get)
{
    char* return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (char*)this->Recipient;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponseAbstract_recipient_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Recipient_str = NULL;
    int Recipient_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Recipient_str, &Recipient_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    lasso_assign_string(this->Recipient, Recipient_str);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_signType_get)
{
    LassoSignatureType return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (LassoSignatureType)this->sign_type;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_signType_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long sign_type;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &sign_type) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    this->sign_type = sign_type;
}

PHP_FUNCTION(LassoSamlpResponseAbstract_signMethod_get)
{
    LassoSignatureMethod return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (LassoSignatureMethod)this->sign_method;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_signMethod_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long sign_method;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &sign_method) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    this->sign_method = sign_method;
}

PHP_FUNCTION(LassoSamlpResponseAbstract_privateKeyFile_get)
{
    char* return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (char*)this->private_key_file;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponseAbstract_privateKeyFile_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* private_key_file_str = NULL;
    int private_key_file_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &private_key_file_str, &private_key_file_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    lasso_assign_string(this->private_key_file, private_key_file_str);
}

PHP_FUNCTION(LassoSamlpResponseAbstract_certificateFile_get)
{
    char* return_c_value;
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    return_c_value = (char*)this->certificate_file;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponseAbstract_certificateFile_set)
{
    LassoSamlpResponseAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* certificate_file_str = NULL;
    int certificate_file_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &certificate_file_str, &certificate_file_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponseAbstract*)cvt_this->obj;

    lasso_assign_string(this->certificate_file, certificate_file_str);
}

PHP_FUNCTION(lasso_samlp_response_abstract_fill)
{
    LassoSamlpResponseAbstract* response = NULL;
    zval* zval_response = NULL;
    PhpGObjectPtr* cvt_response = NULL;
    char* InResponseTo = NULL;
    char* InResponseTo_str = NULL;
    int InResponseTo_len = 0;
    char* Recipient = NULL;
    char* Recipient_str = NULL;
    int Recipient_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!", &zval_response, &InResponseTo_str, &InResponseTo_len, &Recipient_str, &Recipient_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_response, PhpGObjectPtr *, &zval_response, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    response = (LassoSamlpResponseAbstract*)cvt_response->obj;
        InResponseTo = InResponseTo_str;
        Recipient = Recipient_str;
    lasso_samlp_response_abstract_fill(response, InResponseTo, Recipient);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_extension_get)
{
    GList* return_c_value;
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_extension_set)
{
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_providerId_get)
{
    char* return_c_value;
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_providerId_set)
{
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_status_get)
{
    LassoSamlpStatus* return_c_value;
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    return_c_value = (LassoSamlpStatus*)this->Status;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_status_set)
{
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Status = NULL;
    PhpGObjectPtr* cvt_Status = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Status) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Status, PhpGObjectPtr*, &zval_Status, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Status, cvt_Status->obj);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_nameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->NameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingResponse_nameIdentifier_set)
{
    LassoLibNameIdentifierMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIdentifier = NULL;
    PhpGObjectPtr* cvt_NameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIdentifier, PhpGObjectPtr*, &zval_NameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIdentifier, cvt_NameIdentifier->obj);
}

PHP_FUNCTION(LassoSamlpResponse_status_get)
{
    LassoSamlpStatus* return_c_value;
    LassoSamlpResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponse*)cvt_this->obj;

    return_c_value = (LassoSamlpStatus*)this->Status;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpResponse_status_set)
{
    LassoSamlpResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Status = NULL;
    PhpGObjectPtr* cvt_Status = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Status) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Status, PhpGObjectPtr*, &zval_Status, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Status, cvt_Status->obj);
}

PHP_FUNCTION(LassoSamlpResponse_assertion_get)
{
    GList* return_c_value;
    LassoSamlpResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponse*)cvt_this->obj;

    return_c_value = (GList*)this->Assertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlpResponse_assertion_set)
{
    LassoSamlpResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Assertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Assertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpResponse*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Assertion, get_list_from_array_of_objects(zval_Assertion));
}

PHP_FUNCTION(LassoLibAuthnResponse_extension_get)
{
    GList* return_c_value;
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibAuthnResponse_extension_set)
{
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibAuthnResponse_providerId_get)
{
    char* return_c_value;
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnResponse_providerId_set)
{
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibAuthnResponse_relayState_get)
{
    char* return_c_value;
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    return_c_value = (char*)this->RelayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnResponse_relayState_set)
{
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RelayState_str = NULL;
    int RelayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RelayState_str, &RelayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    lasso_assign_string(this->RelayState, RelayState_str);
}

PHP_FUNCTION(LassoLibAuthnResponse_consent_get)
{
    char* return_c_value;
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    return_c_value = (char*)this->consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnResponse_consent_set)
{
    LassoLibAuthnResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* consent_str = NULL;
    int consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &consent_str, &consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnResponse*)cvt_this->obj;

    lasso_assign_string(this->consent, consent_str);
}

PHP_FUNCTION(LassoLibStatusResponse_extension_get)
{
    GList* return_c_value;
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibStatusResponse_extension_set)
{
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibStatusResponse_providerId_get)
{
    char* return_c_value;
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibStatusResponse_providerId_set)
{
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibStatusResponse_status_get)
{
    LassoSamlpStatus* return_c_value;
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    return_c_value = (LassoSamlpStatus*)this->Status;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibStatusResponse_status_set)
{
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Status = NULL;
    PhpGObjectPtr* cvt_Status = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Status) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Status, PhpGObjectPtr*, &zval_Status, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Status, cvt_Status->obj);
}

PHP_FUNCTION(LassoLibStatusResponse_relayState_get)
{
    char* return_c_value;
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->RelayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibStatusResponse_relayState_set)
{
    LassoLibStatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RelayState_str = NULL;
    int RelayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RelayState_str, &RelayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibStatusResponse*)cvt_this->obj;

    lasso_assign_string(this->RelayState, RelayState_str);
}

PHP_FUNCTION(LassoSamlSubjectStatementAbstract_subject_get)
{
    LassoSamlSubject* return_c_value;
    LassoSamlSubjectStatementAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectStatementAbstract*)cvt_this->obj;

    return_c_value = (LassoSamlSubject*)this->Subject;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubjectStatementAbstract_subject_set)
{
    LassoSamlSubjectStatementAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Subject = NULL;
    PhpGObjectPtr* cvt_Subject = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Subject) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubjectStatementAbstract*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Subject, PhpGObjectPtr*, &zval_Subject, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Subject, cvt_Subject->obj);
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_subjectLocality_get)
{
    LassoSamlSubjectLocality* return_c_value;
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    return_c_value = (LassoSamlSubjectLocality*)this->SubjectLocality;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_subjectLocality_set)
{
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SubjectLocality = NULL;
    PhpGObjectPtr* cvt_SubjectLocality = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SubjectLocality) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SubjectLocality, PhpGObjectPtr*, &zval_SubjectLocality, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SubjectLocality, cvt_SubjectLocality->obj);
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_authorityBinding_get)
{
    GList* return_c_value;
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    return_c_value = (GList*)this->AuthorityBinding;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlAuthenticationStatement_authorityBinding_set)
{
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthorityBinding;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthorityBinding) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AuthorityBinding, get_list_from_array_of_objects(zval_AuthorityBinding));
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_authenticationMethod_get)
{
    char* return_c_value;
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    return_c_value = (char*)this->AuthenticationMethod;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_authenticationMethod_set)
{
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthenticationMethod_str = NULL;
    int AuthenticationMethod_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthenticationMethod_str, &AuthenticationMethod_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    lasso_assign_string(this->AuthenticationMethod, AuthenticationMethod_str);
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_authenticationInstant_get)
{
    char* return_c_value;
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    return_c_value = (char*)this->AuthenticationInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAuthenticationStatement_authenticationInstant_set)
{
    LassoSamlAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthenticationInstant_str = NULL;
    int AuthenticationInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthenticationInstant_str, &AuthenticationInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthenticationStatement*)cvt_this->obj;

    lasso_assign_string(this->AuthenticationInstant, AuthenticationInstant_str);
}

PHP_FUNCTION(LassoSamlAttributeStatement_attribute_get)
{
    GList* return_c_value;
    LassoSamlAttributeStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeStatement*)cvt_this->obj;

    return_c_value = (GList*)this->Attribute;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlAttributeStatement_attribute_set)
{
    LassoSamlAttributeStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Attribute;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Attribute) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttributeStatement*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Attribute, get_list_from_array_of_objects(zval_Attribute));
}

PHP_FUNCTION(LassoSamlNameIdentifier_nameQualifier_get)
{
    char* return_c_value;
    LassoSamlNameIdentifier* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlNameIdentifier*)cvt_this->obj;

    return_c_value = (char*)this->NameQualifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlNameIdentifier_nameQualifier_set)
{
    LassoSamlNameIdentifier* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NameQualifier_str = NULL;
    int NameQualifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NameQualifier_str, &NameQualifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlNameIdentifier*)cvt_this->obj;

    lasso_assign_string(this->NameQualifier, NameQualifier_str);
}

PHP_FUNCTION(LassoSamlNameIdentifier_format_get)
{
    char* return_c_value;
    LassoSamlNameIdentifier* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlNameIdentifier*)cvt_this->obj;

    return_c_value = (char*)this->Format;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlNameIdentifier_format_set)
{
    LassoSamlNameIdentifier* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Format_str = NULL;
    int Format_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Format_str, &Format_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlNameIdentifier*)cvt_this->obj;

    lasso_assign_string(this->Format, Format_str);
}

PHP_FUNCTION(LassoSamlNameIdentifier_content_get)
{
    char* return_c_value;
    LassoSamlNameIdentifier* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlNameIdentifier*)cvt_this->obj;

    return_c_value = (char*)this->content;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlNameIdentifier_content_set)
{
    LassoSamlNameIdentifier* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* content_str = NULL;
    int content_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &content_str, &content_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlNameIdentifier*)cvt_this->obj;

    lasso_assign_string(this->content, content_str);
}

PHP_FUNCTION(lasso_saml_name_identifier_equals)
{
    LassoSamlNameIdentifier* a = NULL;
    zval* zval_a = NULL;
    PhpGObjectPtr* cvt_a = NULL;
    LassoSamlNameIdentifier* b = NULL;
    zval* zval_b = NULL;
    PhpGObjectPtr* cvt_b = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_a, &zval_b) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_a, PhpGObjectPtr *, &zval_a, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    a = (LassoSamlNameIdentifier*)cvt_a->obj;
    ZEND_FETCH_RESOURCE(cvt_b, PhpGObjectPtr *, &zval_b, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    b = (LassoSamlNameIdentifier*)cvt_b->obj;
    return_c_value =  lasso_saml_name_identifier_equals(a, b);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoSamlAuthorityBinding_authorityKind_get)
{
    char* return_c_value;
    LassoSamlAuthorityBinding* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthorityBinding*)cvt_this->obj;

    return_c_value = (char*)this->AuthorityKind;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAuthorityBinding_authorityKind_set)
{
    LassoSamlAuthorityBinding* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthorityKind_str = NULL;
    int AuthorityKind_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthorityKind_str, &AuthorityKind_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthorityBinding*)cvt_this->obj;

    lasso_assign_string(this->AuthorityKind, AuthorityKind_str);
}

PHP_FUNCTION(LassoSamlAuthorityBinding_location_get)
{
    char* return_c_value;
    LassoSamlAuthorityBinding* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthorityBinding*)cvt_this->obj;

    return_c_value = (char*)this->Location;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAuthorityBinding_location_set)
{
    LassoSamlAuthorityBinding* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Location_str = NULL;
    int Location_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Location_str, &Location_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthorityBinding*)cvt_this->obj;

    lasso_assign_string(this->Location, Location_str);
}

PHP_FUNCTION(LassoSamlAuthorityBinding_binding_get)
{
    char* return_c_value;
    LassoSamlAuthorityBinding* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthorityBinding*)cvt_this->obj;

    return_c_value = (char*)this->Binding;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAuthorityBinding_binding_set)
{
    LassoSamlAuthorityBinding* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Binding_str = NULL;
    int Binding_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Binding_str, &Binding_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAuthorityBinding*)cvt_this->obj;

    lasso_assign_string(this->Binding, Binding_str);
}

PHP_FUNCTION(LassoSamlSubject_nameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoSamlSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubject*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->NameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubject_nameIdentifier_set)
{
    LassoSamlSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIdentifier = NULL;
    PhpGObjectPtr* cvt_NameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIdentifier, PhpGObjectPtr*, &zval_NameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIdentifier, cvt_NameIdentifier->obj);
}

PHP_FUNCTION(LassoSamlSubject_subjectConfirmation_get)
{
    LassoSamlSubjectConfirmation* return_c_value;
    LassoSamlSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubject*)cvt_this->obj;

    return_c_value = (LassoSamlSubjectConfirmation*)this->SubjectConfirmation;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubject_subjectConfirmation_set)
{
    LassoSamlSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SubjectConfirmation = NULL;
    PhpGObjectPtr* cvt_SubjectConfirmation = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SubjectConfirmation) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SubjectConfirmation, PhpGObjectPtr*, &zval_SubjectConfirmation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SubjectConfirmation, cvt_SubjectConfirmation->obj);
}

PHP_FUNCTION(LassoSamlSubject_encryptedNameIdentifier_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSamlSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubject*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedNameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlSubject_encryptedNameIdentifier_set)
{
    LassoSamlSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedNameIdentifier = NULL;
    PhpGObjectPtr* cvt_EncryptedNameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedNameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlSubject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedNameIdentifier, PhpGObjectPtr*, &zval_EncryptedNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedNameIdentifier, cvt_EncryptedNameIdentifier->obj);
}

PHP_FUNCTION(LassoLibSubject_idpProvidedNameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibSubject*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->IDPProvidedNameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibSubject_idpProvidedNameIdentifier_set)
{
    LassoLibSubject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPProvidedNameIdentifier = NULL;
    PhpGObjectPtr* cvt_IDPProvidedNameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPProvidedNameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibSubject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPProvidedNameIdentifier, PhpGObjectPtr*, &zval_IDPProvidedNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPProvidedNameIdentifier, cvt_IDPProvidedNameIdentifier->obj);
}

PHP_FUNCTION(LassoLibAuthenticationStatement_authnContext_get)
{
    LassoLibAuthnContext* return_c_value;
    LassoLibAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthenticationStatement*)cvt_this->obj;

    return_c_value = (LassoLibAuthnContext*)this->AuthnContext;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthenticationStatement_authnContext_set)
{
    LassoLibAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnContext = NULL;
    PhpGObjectPtr* cvt_AuthnContext = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_AuthnContext) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthenticationStatement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_AuthnContext, PhpGObjectPtr*, &zval_AuthnContext, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->AuthnContext, cvt_AuthnContext->obj);
}

PHP_FUNCTION(LassoLibAuthenticationStatement_reauthenticateOnOrAfter_get)
{
    char* return_c_value;
    LassoLibAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthenticationStatement*)cvt_this->obj;

    return_c_value = (char*)this->ReauthenticateOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthenticationStatement_reauthenticateOnOrAfter_set)
{
    LassoLibAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ReauthenticateOnOrAfter_str = NULL;
    int ReauthenticateOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ReauthenticateOnOrAfter_str, &ReauthenticateOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthenticationStatement*)cvt_this->obj;

    lasso_assign_string(this->ReauthenticateOnOrAfter, ReauthenticateOnOrAfter_str);
}

PHP_FUNCTION(LassoLibAuthenticationStatement_sessionIndex_get)
{
    char* return_c_value;
    LassoLibAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthenticationStatement*)cvt_this->obj;

    return_c_value = (char*)this->SessionIndex;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthenticationStatement_sessionIndex_set)
{
    LassoLibAuthenticationStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SessionIndex_str = NULL;
    int SessionIndex_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SessionIndex_str, &SessionIndex_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthenticationStatement*)cvt_this->obj;

    lasso_assign_string(this->SessionIndex, SessionIndex_str);
}

PHP_FUNCTION(LassoSamlConditions_condition_get)
{
    GList* return_c_value;
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    return_c_value = (GList*)this->Condition;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlConditions_condition_set)
{
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Condition;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Condition) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Condition, get_list_from_array_of_objects(zval_Condition));
}

PHP_FUNCTION(LassoSamlConditions_audienceRestrictionCondition_get)
{
    GList* return_c_value;
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    return_c_value = (GList*)this->AudienceRestrictionCondition;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlConditions_audienceRestrictionCondition_set)
{
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AudienceRestrictionCondition;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AudienceRestrictionCondition) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AudienceRestrictionCondition, get_list_from_array_of_objects(zval_AudienceRestrictionCondition));
}

PHP_FUNCTION(LassoSamlConditions_notBefore_get)
{
    char* return_c_value;
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    return_c_value = (char*)this->NotBefore;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlConditions_notBefore_set)
{
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotBefore_str = NULL;
    int NotBefore_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotBefore_str, &NotBefore_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    lasso_assign_string(this->NotBefore, NotBefore_str);
}

PHP_FUNCTION(LassoSamlConditions_notOnOrAfter_get)
{
    char* return_c_value;
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    return_c_value = (char*)this->NotOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlConditions_notOnOrAfter_set)
{
    LassoSamlConditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotOnOrAfter_str = NULL;
    int NotOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotOnOrAfter_str, &NotOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlConditions*)cvt_this->obj;

    lasso_assign_string(this->NotOnOrAfter, NotOnOrAfter_str);
}

PHP_FUNCTION(LassoLibIDPEntry_providerId_get)
{
    char* return_c_value;
    LassoLibIDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntry*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibIDPEntry_providerId_set)
{
    LassoLibIDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntry*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibIDPEntry_providerName_get)
{
    char* return_c_value;
    LassoLibIDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntry*)cvt_this->obj;

    return_c_value = (char*)this->ProviderName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibIDPEntry_providerName_set)
{
    LassoLibIDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderName_str = NULL;
    int ProviderName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderName_str, &ProviderName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntry*)cvt_this->obj;

    lasso_assign_string(this->ProviderName, ProviderName_str);
}

PHP_FUNCTION(LassoLibIDPEntry_loc_get)
{
    char* return_c_value;
    LassoLibIDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntry*)cvt_this->obj;

    return_c_value = (char*)this->Loc;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibIDPEntry_loc_set)
{
    LassoLibIDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Loc_str = NULL;
    int Loc_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Loc_str, &Loc_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibIDPEntry*)cvt_this->obj;

    lasso_assign_string(this->Loc, Loc_str);
}

PHP_FUNCTION(LassoSamlAttribute_attributeName_get)
{
    gchar* return_c_value;
    LassoSamlAttribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttribute*)cvt_this->obj;

    return_c_value = (gchar*)this->attributeName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAttribute_attributeName_set)
{
    LassoSamlAttribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* attributeName_str = NULL;
    int attributeName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &attributeName_str, &attributeName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttribute*)cvt_this->obj;

    lasso_assign_string(this->attributeName, attributeName_str);
}

PHP_FUNCTION(LassoSamlAttribute_attributeNameSpace_get)
{
    gchar* return_c_value;
    LassoSamlAttribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttribute*)cvt_this->obj;

    return_c_value = (gchar*)this->attributeNameSpace;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlAttribute_attributeNameSpace_set)
{
    LassoSamlAttribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* attributeNameSpace_str = NULL;
    int attributeNameSpace_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &attributeNameSpace_str, &attributeNameSpace_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttribute*)cvt_this->obj;

    lasso_assign_string(this->attributeNameSpace, attributeNameSpace_str);
}

PHP_FUNCTION(LassoSamlAttribute_attributeValue_get)
{
    GList* return_c_value;
    LassoSamlAttribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttribute*)cvt_this->obj;

    return_c_value = (GList*)this->AttributeValue;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlAttribute_attributeValue_set)
{
    LassoSamlAttribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AttributeValue;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AttributeValue) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlAttribute*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AttributeValue, get_list_from_array_of_objects(zval_AttributeValue));
}

PHP_FUNCTION(LassoSamlpStatusCode_statusCode_get)
{
    LassoSamlpStatusCode* return_c_value;
    LassoSamlpStatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatusCode*)cvt_this->obj;

    return_c_value = (LassoSamlpStatusCode*)this->StatusCode;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpStatusCode_statusCode_set)
{
    LassoSamlpStatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_StatusCode = NULL;
    PhpGObjectPtr* cvt_StatusCode = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_StatusCode) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatusCode*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_StatusCode, PhpGObjectPtr*, &zval_StatusCode, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->StatusCode, cvt_StatusCode->obj);
}

PHP_FUNCTION(LassoSamlpStatusCode_value_get)
{
    char* return_c_value;
    LassoSamlpStatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatusCode*)cvt_this->obj;

    return_c_value = (char*)this->Value;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpStatusCode_value_set)
{
    LassoSamlpStatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Value_str = NULL;
    int Value_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Value_str, &Value_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpStatusCode*)cvt_this->obj;

    lasso_assign_string(this->Value, Value_str);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_respondWith_get)
{
    GList* return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (GList*)this->RespondWith;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlpRequestAbstract_respondWith_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_RespondWith;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_RespondWith) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->RespondWith, get_list_from_array_of_strings(zval_RespondWith));
}

PHP_FUNCTION(LassoSamlpRequestAbstract_requestId_get)
{
    char* return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->RequestID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpRequestAbstract_requestId_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RequestID_str = NULL;
    int RequestID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RequestID_str, &RequestID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->RequestID, RequestID_str);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_majorVersion_get)
{
    int return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (int)this->MajorVersion;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_majorVersion_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long MajorVersion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &MajorVersion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    this->MajorVersion = MajorVersion;
}

PHP_FUNCTION(LassoSamlpRequestAbstract_minorVersion_get)
{
    int return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (int)this->MinorVersion;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_minorVersion_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long MinorVersion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &MinorVersion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    this->MinorVersion = MinorVersion;
}

PHP_FUNCTION(LassoSamlpRequestAbstract_issueInstant_get)
{
    char* return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->IssueInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpRequestAbstract_issueInstant_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IssueInstant_str = NULL;
    int IssueInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IssueInstant_str, &IssueInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->IssueInstant, IssueInstant_str);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_signType_get)
{
    LassoSignatureType return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (LassoSignatureType)this->sign_type;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_signType_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long sign_type;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &sign_type) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    this->sign_type = sign_type;
}

PHP_FUNCTION(LassoSamlpRequestAbstract_signMethod_get)
{
    LassoSignatureMethod return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (LassoSignatureMethod)this->sign_method;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_signMethod_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long sign_method;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &sign_method) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    this->sign_method = sign_method;
}

PHP_FUNCTION(LassoSamlpRequestAbstract_privateKeyFile_get)
{
    char* return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->private_key_file;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpRequestAbstract_privateKeyFile_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* private_key_file_str = NULL;
    int private_key_file_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &private_key_file_str, &private_key_file_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->private_key_file, private_key_file_str);
}

PHP_FUNCTION(LassoSamlpRequestAbstract_certificateFile_get)
{
    char* return_c_value;
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->certificate_file;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpRequestAbstract_certificateFile_set)
{
    LassoSamlpRequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* certificate_file_str = NULL;
    int certificate_file_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &certificate_file_str, &certificate_file_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->certificate_file, certificate_file_str);
}

PHP_FUNCTION(LassoSamlpRequest_assertionArtifact_get)
{
    char* return_c_value;
    LassoSamlpRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequest*)cvt_this->obj;

    return_c_value = (char*)this->AssertionArtifact;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlpRequest_assertionArtifact_set)
{
    LassoSamlpRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionArtifact_str = NULL;
    int AssertionArtifact_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionArtifact_str, &AssertionArtifact_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlpRequest*)cvt_this->obj;

    lasso_assign_string(this->AssertionArtifact, AssertionArtifact_str);
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_extension_get)
{
    GList* return_c_value;
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibFederationTerminationNotification_extension_set)
{
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_providerId_get)
{
    char* return_c_value;
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_providerId_set)
{
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_nameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->NameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_nameIdentifier_set)
{
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIdentifier = NULL;
    PhpGObjectPtr* cvt_NameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIdentifier, PhpGObjectPtr*, &zval_NameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIdentifier, cvt_NameIdentifier->obj);
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_consent_get)
{
    char* return_c_value;
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    return_c_value = (char*)this->consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_consent_set)
{
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* consent_str = NULL;
    int consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &consent_str, &consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    lasso_assign_string(this->consent, consent_str);
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_relayState_get)
{
    char* return_c_value;
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    return_c_value = (char*)this->RelayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibFederationTerminationNotification_relayState_set)
{
    LassoLibFederationTerminationNotification* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RelayState_str = NULL;
    int RelayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RelayState_str, &RelayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibFederationTerminationNotification*)cvt_this->obj;

    lasso_assign_string(this->RelayState, RelayState_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_extension_get)
{
    GList* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibAuthnRequest_extension_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibAuthnRequest_providerId_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_providerId_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_affiliationId_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->AffiliationID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_affiliationId_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AffiliationID_str = NULL;
    int AffiliationID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AffiliationID_str, &AffiliationID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->AffiliationID, AffiliationID_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_nameIdPolicy_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->NameIDPolicy;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_nameIdPolicy_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NameIDPolicy_str = NULL;
    int NameIDPolicy_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NameIDPolicy_str, &NameIDPolicy_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->NameIDPolicy, NameIDPolicy_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_forceAuthn_get)
{
    gboolean return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (gboolean)this->ForceAuthn;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoLibAuthnRequest_forceAuthn_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long ForceAuthn;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &ForceAuthn) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    this->ForceAuthn = ForceAuthn;
}

PHP_FUNCTION(LassoLibAuthnRequest_isPassive_get)
{
    gboolean return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (gboolean)this->IsPassive;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoLibAuthnRequest_isPassive_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long IsPassive;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &IsPassive) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    this->IsPassive = IsPassive;
}

PHP_FUNCTION(LassoLibAuthnRequest_protocolProfile_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProtocolProfile;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_protocolProfile_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProtocolProfile_str = NULL;
    int ProtocolProfile_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProtocolProfile_str, &ProtocolProfile_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->ProtocolProfile, ProtocolProfile_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_assertionConsumerServiceId_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->AssertionConsumerServiceID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_assertionConsumerServiceId_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionConsumerServiceID_str = NULL;
    int AssertionConsumerServiceID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionConsumerServiceID_str, &AssertionConsumerServiceID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->AssertionConsumerServiceID, AssertionConsumerServiceID_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_requestAuthnContext_get)
{
    LassoLibRequestAuthnContext* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (LassoLibRequestAuthnContext*)this->RequestAuthnContext;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_requestAuthnContext_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_RequestAuthnContext = NULL;
    PhpGObjectPtr* cvt_RequestAuthnContext = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_RequestAuthnContext) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_RequestAuthnContext, PhpGObjectPtr*, &zval_RequestAuthnContext, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->RequestAuthnContext, cvt_RequestAuthnContext->obj);
}

PHP_FUNCTION(LassoLibAuthnRequest_relayState_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->RelayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_relayState_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RelayState_str = NULL;
    int RelayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RelayState_str, &RelayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->RelayState, RelayState_str);
}

PHP_FUNCTION(LassoLibAuthnRequest_scoping_get)
{
    LassoLibScoping* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (LassoLibScoping*)this->Scoping;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_scoping_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Scoping = NULL;
    PhpGObjectPtr* cvt_Scoping = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Scoping) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Scoping, PhpGObjectPtr*, &zval_Scoping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Scoping, cvt_Scoping->obj);
}

PHP_FUNCTION(LassoLibAuthnRequest_consent_get)
{
    char* return_c_value;
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibAuthnRequest_consent_set)
{
    LassoLibAuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* consent_str = NULL;
    int consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &consent_str, &consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibAuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->consent, consent_str);
}

PHP_FUNCTION(LassoLibLogoutRequest_extension_get)
{
    GList* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibLogoutRequest_extension_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibLogoutRequest_providerId_get)
{
    char* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibLogoutRequest_providerId_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibLogoutRequest_nameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->NameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibLogoutRequest_nameIdentifier_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIdentifier = NULL;
    PhpGObjectPtr* cvt_NameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIdentifier, PhpGObjectPtr*, &zval_NameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIdentifier, cvt_NameIdentifier->obj);
}

PHP_FUNCTION(LassoLibLogoutRequest_sessionIndex_get)
{
    char* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->SessionIndex;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibLogoutRequest_sessionIndex_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SessionIndex_str = NULL;
    int SessionIndex_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SessionIndex_str, &SessionIndex_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->SessionIndex, SessionIndex_str);
}

PHP_FUNCTION(LassoLibLogoutRequest_relayState_get)
{
    char* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->RelayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibLogoutRequest_relayState_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RelayState_str = NULL;
    int RelayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RelayState_str, &RelayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->RelayState, RelayState_str);
}

PHP_FUNCTION(LassoLibLogoutRequest_consent_get)
{
    char* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibLogoutRequest_consent_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* consent_str = NULL;
    int consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &consent_str, &consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->consent, consent_str);
}

PHP_FUNCTION(LassoLibLogoutRequest_notOnOrAfter_get)
{
    char* return_c_value;
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->NotOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibLogoutRequest_notOnOrAfter_set)
{
    LassoLibLogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotOnOrAfter_str = NULL;
    int NotOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotOnOrAfter_str, &NotOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibLogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->NotOnOrAfter, NotOnOrAfter_str);
}

PHP_FUNCTION(lasso_lib_logout_request_set_session_indexes)
{
    LassoLibLogoutRequest* lib_logout_request = NULL;
    zval* zval_lib_logout_request = NULL;
    PhpGObjectPtr* cvt_lib_logout_request = NULL;
    zval* zval_session_indexes = NULL;
    GList* session_indexes = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra!", &zval_lib_logout_request, &zval_session_indexes) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lib_logout_request, PhpGObjectPtr *, &zval_lib_logout_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lib_logout_request = (LassoLibLogoutRequest*)cvt_lib_logout_request->obj;
    session_indexes = get_list_from_array_of_strings(zval_session_indexes);
    lasso_lib_logout_request_set_session_indexes(lib_logout_request, session_indexes);
    if (session_indexes) {
        free_glist(&session_indexes,(GFunc)free);
    }
}

PHP_FUNCTION(lasso_lib_logout_request_get_session_indexes)
{
    LassoLibLogoutRequest* lib_logout_request = NULL;
    zval* zval_lib_logout_request = NULL;
    PhpGObjectPtr* cvt_lib_logout_request = NULL;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_lib_logout_request) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_lib_logout_request, PhpGObjectPtr *, &zval_lib_logout_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lib_logout_request = (LassoLibLogoutRequest*)cvt_lib_logout_request->obj;
    return_c_value =  lasso_lib_logout_request_get_session_indexes(lib_logout_request);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

    lasso_release_list_of_strings(return_c_value);
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_extension_get)
{
    GList* return_c_value;
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_extension_set)
{
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_providerId_get)
{
    char* return_c_value;
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_providerId_set)
{
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_idpProvidedNameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->IDPProvidedNameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_idpProvidedNameIdentifier_set)
{
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPProvidedNameIdentifier = NULL;
    PhpGObjectPtr* cvt_IDPProvidedNameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPProvidedNameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPProvidedNameIdentifier, PhpGObjectPtr*, &zval_IDPProvidedNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPProvidedNameIdentifier, cvt_IDPProvidedNameIdentifier->obj);
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_spProvidedNameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->SPProvidedNameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_spProvidedNameIdentifier_set)
{
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SPProvidedNameIdentifier = NULL;
    PhpGObjectPtr* cvt_SPProvidedNameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SPProvidedNameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SPProvidedNameIdentifier, PhpGObjectPtr*, &zval_SPProvidedNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SPProvidedNameIdentifier, cvt_SPProvidedNameIdentifier->obj);
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->OldProvidedNameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_set)
{
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_OldProvidedNameIdentifier = NULL;
    PhpGObjectPtr* cvt_OldProvidedNameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_OldProvidedNameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_OldProvidedNameIdentifier, PhpGObjectPtr*, &zval_OldProvidedNameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->OldProvidedNameIdentifier, cvt_OldProvidedNameIdentifier->obj);
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_relayState_get)
{
    char* return_c_value;
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    return_c_value = (char*)this->RelayState;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibRegisterNameIdentifierRequest_relayState_set)
{
    LassoLibRegisterNameIdentifierRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RelayState_str = NULL;
    int RelayState_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RelayState_str, &RelayState_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibRegisterNameIdentifierRequest*)cvt_this->obj;

    lasso_assign_string(this->RelayState, RelayState_str);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_extension_get)
{
    GList* return_c_value;
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    return_c_value = (GList*)this->Extension;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_extension_set)
{
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extension;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Extension) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->Extension, get_list_from_array_of_xmlnodes(zval_Extension))
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_providerId_get)
{
    char* return_c_value;
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_providerId_set)
{
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_nameIdentifier_get)
{
    LassoSamlNameIdentifier* return_c_value;
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    return_c_value = (LassoSamlNameIdentifier*)this->NameIdentifier;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_nameIdentifier_set)
{
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIdentifier = NULL;
    PhpGObjectPtr* cvt_NameIdentifier = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIdentifier) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIdentifier, PhpGObjectPtr*, &zval_NameIdentifier, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIdentifier, cvt_NameIdentifier->obj);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_targetNamespace_get)
{
    char* return_c_value;
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    return_c_value = (char*)this->TargetNamespace;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_targetNamespace_set)
{
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* TargetNamespace_str = NULL;
    int TargetNamespace_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &TargetNamespace_str, &TargetNamespace_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    lasso_assign_string(this->TargetNamespace, TargetNamespace_str);
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_consent_get)
{
    char* return_c_value;
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    return_c_value = (char*)this->consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoLibNameIdentifierMappingRequest_consent_set)
{
    LassoLibNameIdentifierMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* consent_str = NULL;
    int consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &consent_str, &consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoLibNameIdentifierMappingRequest*)cvt_this->obj;

    lasso_assign_string(this->consent, consent_str);
}

PHP_FUNCTION(LassoSaml2BaseIDAbstract_nameQualifier_get)
{
    char* return_c_value;
    LassoSaml2BaseIDAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2BaseIDAbstract*)cvt_this->obj;

    return_c_value = (char*)this->NameQualifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2BaseIDAbstract_nameQualifier_set)
{
    LassoSaml2BaseIDAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NameQualifier_str = NULL;
    int NameQualifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NameQualifier_str, &NameQualifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2BaseIDAbstract*)cvt_this->obj;

    lasso_assign_string(this->NameQualifier, NameQualifier_str);
}

PHP_FUNCTION(LassoSaml2BaseIDAbstract_spNameQualifier_get)
{
    char* return_c_value;
    LassoSaml2BaseIDAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2BaseIDAbstract*)cvt_this->obj;

    return_c_value = (char*)this->SPNameQualifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2BaseIDAbstract_spNameQualifier_set)
{
    LassoSaml2BaseIDAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SPNameQualifier_str = NULL;
    int SPNameQualifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SPNameQualifier_str, &SPNameQualifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2BaseIDAbstract*)cvt_this->obj;

    lasso_assign_string(this->SPNameQualifier, SPNameQualifier_str);
}

PHP_FUNCTION(LassoSaml2AttributeValue_any_get)
{
    GList* return_c_value;
    LassoSaml2AttributeValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AttributeValue*)cvt_this->obj;

    return_c_value = (GList*)this->any;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2AttributeValue_any_set)
{
    LassoSaml2AttributeValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_any;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_any) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AttributeValue*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->any, get_list_from_array_of_objects(zval_any));
}

PHP_FUNCTION(LassoSamlp2NameIDPolicy_format_get)
{
    char* return_c_value;
    LassoSamlp2NameIDPolicy* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDPolicy*)cvt_this->obj;

    return_c_value = (char*)this->Format;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDPolicy_format_set)
{
    LassoSamlp2NameIDPolicy* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Format_str = NULL;
    int Format_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Format_str, &Format_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDPolicy*)cvt_this->obj;

    lasso_assign_string(this->Format, Format_str);
}

PHP_FUNCTION(LassoSamlp2NameIDPolicy_spNameQualifier_get)
{
    char* return_c_value;
    LassoSamlp2NameIDPolicy* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDPolicy*)cvt_this->obj;

    return_c_value = (char*)this->SPNameQualifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDPolicy_spNameQualifier_set)
{
    LassoSamlp2NameIDPolicy* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SPNameQualifier_str = NULL;
    int SPNameQualifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SPNameQualifier_str, &SPNameQualifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDPolicy*)cvt_this->obj;

    lasso_assign_string(this->SPNameQualifier, SPNameQualifier_str);
}

PHP_FUNCTION(LassoSamlp2NameIDPolicy_allowCreate_get)
{
    gboolean return_c_value;
    LassoSamlp2NameIDPolicy* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDPolicy*)cvt_this->obj;

    return_c_value = (gboolean)this->AllowCreate;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoSamlp2NameIDPolicy_allowCreate_set)
{
    LassoSamlp2NameIDPolicy* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long AllowCreate;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &AllowCreate) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDPolicy*)cvt_this->obj;

    this->AllowCreate = AllowCreate;
}

PHP_FUNCTION(LassoSamlp2StatusCode_statusCode_get)
{
    LassoSamlp2StatusCode* return_c_value;
    LassoSamlp2StatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusCode*)cvt_this->obj;

    return_c_value = (LassoSamlp2StatusCode*)this->StatusCode;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusCode_statusCode_set)
{
    LassoSamlp2StatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_StatusCode = NULL;
    PhpGObjectPtr* cvt_StatusCode = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_StatusCode) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusCode*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_StatusCode, PhpGObjectPtr*, &zval_StatusCode, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->StatusCode, cvt_StatusCode->obj);
}

PHP_FUNCTION(LassoSamlp2StatusCode_value_get)
{
    char* return_c_value;
    LassoSamlp2StatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusCode*)cvt_this->obj;

    return_c_value = (char*)this->Value;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusCode_value_set)
{
    LassoSamlp2StatusCode* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Value_str = NULL;
    int Value_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Value_str, &Value_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusCode*)cvt_this->obj;

    lasso_assign_string(this->Value, Value_str);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_notBefore_get)
{
    char* return_c_value;
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    return_c_value = (char*)this->NotBefore;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_notBefore_set)
{
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotBefore_str = NULL;
    int NotBefore_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotBefore_str, &NotBefore_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    lasso_assign_string(this->NotBefore, NotBefore_str);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_notOnOrAfter_get)
{
    char* return_c_value;
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    return_c_value = (char*)this->NotOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_notOnOrAfter_set)
{
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotOnOrAfter_str = NULL;
    int NotOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotOnOrAfter_str, &NotOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    lasso_assign_string(this->NotOnOrAfter, NotOnOrAfter_str);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_recipient_get)
{
    char* return_c_value;
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    return_c_value = (char*)this->Recipient;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_recipient_set)
{
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Recipient_str = NULL;
    int Recipient_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Recipient_str, &Recipient_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    lasso_assign_string(this->Recipient, Recipient_str);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_inResponseTo_get)
{
    char* return_c_value;
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    return_c_value = (char*)this->InResponseTo;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_inResponseTo_set)
{
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* InResponseTo_str = NULL;
    int InResponseTo_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &InResponseTo_str, &InResponseTo_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    lasso_assign_string(this->InResponseTo, InResponseTo_str);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_address_get)
{
    char* return_c_value;
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    return_c_value = (char*)this->Address;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmationData_address_set)
{
    LassoSaml2SubjectConfirmationData* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Address_str = NULL;
    int Address_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Address_str, &Address_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmationData*)cvt_this->obj;

    lasso_assign_string(this->Address, Address_str);
}

PHP_FUNCTION(LassoSaml2Subject_baseId_get)
{
    LassoSaml2BaseIDAbstract* return_c_value;
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    return_c_value = (LassoSaml2BaseIDAbstract*)this->BaseID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Subject_baseId_set)
{
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_BaseID = NULL;
    PhpGObjectPtr* cvt_BaseID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_BaseID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_BaseID, PhpGObjectPtr*, &zval_BaseID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->BaseID, cvt_BaseID->obj);
}

PHP_FUNCTION(LassoSaml2Subject_nameId_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->NameID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Subject_nameId_set)
{
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameID = NULL;
    PhpGObjectPtr* cvt_NameID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameID, PhpGObjectPtr*, &zval_NameID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameID, cvt_NameID->obj);
}

PHP_FUNCTION(LassoSaml2Subject_encryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Subject_encryptedId_set)
{
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedID = NULL;
    PhpGObjectPtr* cvt_EncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedID, PhpGObjectPtr*, &zval_EncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedID, cvt_EncryptedID->obj);
}

PHP_FUNCTION(LassoSaml2Subject_subjectConfirmation_get)
{
    LassoSaml2SubjectConfirmation* return_c_value;
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    return_c_value = (LassoSaml2SubjectConfirmation*)this->SubjectConfirmation;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Subject_subjectConfirmation_set)
{
    LassoSaml2Subject* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SubjectConfirmation = NULL;
    PhpGObjectPtr* cvt_SubjectConfirmation = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SubjectConfirmation) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Subject*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SubjectConfirmation, PhpGObjectPtr*, &zval_SubjectConfirmation, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SubjectConfirmation, cvt_SubjectConfirmation->obj);
}

PHP_FUNCTION(LassoSaml2Conditions_condition_get)
{
    GList* return_c_value;
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    return_c_value = (GList*)this->Condition;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Conditions_condition_set)
{
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Condition;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Condition) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Condition, get_list_from_array_of_objects(zval_Condition));
}

PHP_FUNCTION(LassoSaml2Conditions_audienceRestriction_get)
{
    GList* return_c_value;
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    return_c_value = (GList*)this->AudienceRestriction;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Conditions_audienceRestriction_set)
{
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AudienceRestriction;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AudienceRestriction) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AudienceRestriction, get_list_from_array_of_objects(zval_AudienceRestriction));
}

PHP_FUNCTION(LassoSaml2Conditions_oneTimeUse_get)
{
    GList* return_c_value;
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    return_c_value = (GList*)this->OneTimeUse;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Conditions_oneTimeUse_set)
{
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_OneTimeUse;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_OneTimeUse) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->OneTimeUse, get_list_from_array_of_objects(zval_OneTimeUse));
}

PHP_FUNCTION(LassoSaml2Conditions_proxyRestriction_get)
{
    GList* return_c_value;
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    return_c_value = (GList*)this->ProxyRestriction;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Conditions_proxyRestriction_set)
{
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_ProxyRestriction;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_ProxyRestriction) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->ProxyRestriction, get_list_from_array_of_objects(zval_ProxyRestriction));
}

PHP_FUNCTION(LassoSaml2Conditions_notBefore_get)
{
    char* return_c_value;
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    return_c_value = (char*)this->NotBefore;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Conditions_notBefore_set)
{
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotBefore_str = NULL;
    int NotBefore_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotBefore_str, &NotBefore_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    lasso_assign_string(this->NotBefore, NotBefore_str);
}

PHP_FUNCTION(LassoSaml2Conditions_notOnOrAfter_get)
{
    char* return_c_value;
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    return_c_value = (char*)this->NotOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Conditions_notOnOrAfter_set)
{
    LassoSaml2Conditions* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotOnOrAfter_str = NULL;
    int NotOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotOnOrAfter_str, &NotOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Conditions*)cvt_this->obj;

    lasso_assign_string(this->NotOnOrAfter, NotOnOrAfter_str);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_issuer_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->Issuer;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_issuer_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Issuer = NULL;
    PhpGObjectPtr* cvt_Issuer = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Issuer) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Issuer, PhpGObjectPtr*, &zval_Issuer, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Issuer, cvt_Issuer->obj);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_extensions_get)
{
    LassoSamlp2Extensions* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (LassoSamlp2Extensions*)this->Extensions;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_extensions_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extensions = NULL;
    PhpGObjectPtr* cvt_Extensions = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Extensions) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Extensions, PhpGObjectPtr*, &zval_Extensions, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Extensions, cvt_Extensions->obj);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_status_get)
{
    LassoSamlp2Status* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (LassoSamlp2Status*)this->Status;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_status_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Status = NULL;
    PhpGObjectPtr* cvt_Status = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Status) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Status, PhpGObjectPtr*, &zval_Status, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Status, cvt_Status->obj);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_id_get)
{
    char* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->ID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_id_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ID_str = NULL;
    int ID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ID_str, &ID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    lasso_assign_string(this->ID, ID_str);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_inResponseTo_get)
{
    char* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->InResponseTo;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_inResponseTo_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* InResponseTo_str = NULL;
    int InResponseTo_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &InResponseTo_str, &InResponseTo_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    lasso_assign_string(this->InResponseTo, InResponseTo_str);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_version_get)
{
    char* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->Version;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_version_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Version_str = NULL;
    int Version_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Version_str, &Version_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    lasso_assign_string(this->Version, Version_str);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_issueInstant_get)
{
    char* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->IssueInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_issueInstant_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IssueInstant_str = NULL;
    int IssueInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IssueInstant_str, &IssueInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    lasso_assign_string(this->IssueInstant, IssueInstant_str);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_destination_get)
{
    char* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->Destination;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_destination_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Destination_str = NULL;
    int Destination_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Destination_str, &Destination_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    lasso_assign_string(this->Destination, Destination_str);
}

PHP_FUNCTION(LassoSamlp2StatusResponse_consent_get)
{
    char* return_c_value;
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    return_c_value = (char*)this->Consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2StatusResponse_consent_set)
{
    LassoSamlp2StatusResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Consent_str = NULL;
    int Consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Consent_str, &Consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2StatusResponse*)cvt_this->obj;

    lasso_assign_string(this->Consent, Consent_str);
}

PHP_FUNCTION(LassoSaml2ProxyRestriction_audience_get)
{
    char* return_c_value;
    LassoSaml2ProxyRestriction* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2ProxyRestriction*)cvt_this->obj;

    return_c_value = (char*)this->Audience;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2ProxyRestriction_audience_set)
{
    LassoSaml2ProxyRestriction* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Audience_str = NULL;
    int Audience_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Audience_str, &Audience_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2ProxyRestriction*)cvt_this->obj;

    lasso_assign_string(this->Audience, Audience_str);
}

PHP_FUNCTION(LassoSaml2ProxyRestriction_count_get)
{
    char* return_c_value;
    LassoSaml2ProxyRestriction* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2ProxyRestriction*)cvt_this->obj;

    return_c_value = (char*)this->Count;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2ProxyRestriction_count_set)
{
    LassoSaml2ProxyRestriction* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Count_str = NULL;
    int Count_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Count_str, &Count_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2ProxyRestriction*)cvt_this->obj;

    lasso_assign_string(this->Count, Count_str);
}

PHP_FUNCTION(LassoSaml2Advice_assertionIdRef_get)
{
    GList* return_c_value;
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    return_c_value = (GList*)this->AssertionIDRef;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Advice_assertionIdRef_set)
{
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AssertionIDRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AssertionIDRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AssertionIDRef, get_list_from_array_of_objects(zval_AssertionIDRef));
}

PHP_FUNCTION(LassoSaml2Advice_assertionUriRef_get)
{
    GList* return_c_value;
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    return_c_value = (GList*)this->AssertionURIRef;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Advice_assertionUriRef_set)
{
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AssertionURIRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AssertionURIRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AssertionURIRef, get_list_from_array_of_objects(zval_AssertionURIRef));
}

PHP_FUNCTION(LassoSaml2Advice_assertion_get)
{
    GList* return_c_value;
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    return_c_value = (GList*)this->Assertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Advice_assertion_set)
{
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Assertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Assertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Assertion, get_list_from_array_of_objects(zval_Assertion));
}

PHP_FUNCTION(LassoSaml2Advice_encryptedAssertion_get)
{
    GList* return_c_value;
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    return_c_value = (GList*)this->EncryptedAssertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Advice_encryptedAssertion_set)
{
    LassoSaml2Advice* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedAssertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_EncryptedAssertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Advice*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->EncryptedAssertion, get_list_from_array_of_objects(zval_EncryptedAssertion));
}

PHP_FUNCTION(LassoSamlp2ArtifactResponse_any_get)
{
    LassoNode* return_c_value;
    LassoSamlp2ArtifactResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ArtifactResponse*)cvt_this->obj;

    return_c_value = (LassoNode*)this->any;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ArtifactResponse_any_set)
{
    LassoSamlp2ArtifactResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_any = NULL;
    PhpGObjectPtr* cvt_any = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_any) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ArtifactResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_any, PhpGObjectPtr*, &zval_any, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->any, cvt_any->obj);
}

PHP_FUNCTION(LassoSaml2Attribute_attributeValue_get)
{
    GList* return_c_value;
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    return_c_value = (GList*)this->AttributeValue;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Attribute_attributeValue_set)
{
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AttributeValue;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AttributeValue) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AttributeValue, get_list_from_array_of_objects(zval_AttributeValue));
}

PHP_FUNCTION(LassoSaml2Attribute_name_get)
{
    char* return_c_value;
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    return_c_value = (char*)this->Name;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Attribute_name_set)
{
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Name_str = NULL;
    int Name_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Name_str, &Name_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    lasso_assign_string(this->Name, Name_str);
}

PHP_FUNCTION(LassoSaml2Attribute_nameFormat_get)
{
    char* return_c_value;
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    return_c_value = (char*)this->NameFormat;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Attribute_nameFormat_set)
{
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NameFormat_str = NULL;
    int NameFormat_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NameFormat_str, &NameFormat_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    lasso_assign_string(this->NameFormat, NameFormat_str);
}

PHP_FUNCTION(LassoSaml2Attribute_friendlyName_get)
{
    char* return_c_value;
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    return_c_value = (char*)this->FriendlyName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Attribute_friendlyName_set)
{
    LassoSaml2Attribute* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* FriendlyName_str = NULL;
    int FriendlyName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &FriendlyName_str, &FriendlyName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Attribute*)cvt_this->obj;

    lasso_assign_string(this->FriendlyName, FriendlyName_str);
}

PHP_FUNCTION(LassoSamlp2IDPList_idpEntry_get)
{
    LassoSamlp2IDPEntry* return_c_value;
    LassoSamlp2IDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPList*)cvt_this->obj;

    return_c_value = (LassoSamlp2IDPEntry*)this->IDPEntry;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2IDPList_idpEntry_set)
{
    LassoSamlp2IDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPEntry = NULL;
    PhpGObjectPtr* cvt_IDPEntry = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPEntry) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPList*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPEntry, PhpGObjectPtr*, &zval_IDPEntry, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPEntry, cvt_IDPEntry->obj);
}

PHP_FUNCTION(LassoSamlp2IDPList_getComplete_get)
{
    char* return_c_value;
    LassoSamlp2IDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPList*)cvt_this->obj;

    return_c_value = (char*)this->GetComplete;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2IDPList_getComplete_set)
{
    LassoSamlp2IDPList* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* GetComplete_str = NULL;
    int GetComplete_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &GetComplete_str, &GetComplete_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPList*)cvt_this->obj;

    lasso_assign_string(this->GetComplete, GetComplete_str);
}

PHP_FUNCTION(LassoSamlp2Status_statusCode_get)
{
    LassoSamlp2StatusCode* return_c_value;
    LassoSamlp2Status* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Status*)cvt_this->obj;

    return_c_value = (LassoSamlp2StatusCode*)this->StatusCode;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2Status_statusCode_set)
{
    LassoSamlp2Status* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_StatusCode = NULL;
    PhpGObjectPtr* cvt_StatusCode = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_StatusCode) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Status*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_StatusCode, PhpGObjectPtr*, &zval_StatusCode, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->StatusCode, cvt_StatusCode->obj);
}

PHP_FUNCTION(LassoSamlp2Status_statusMessage_get)
{
    char* return_c_value;
    LassoSamlp2Status* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Status*)cvt_this->obj;

    return_c_value = (char*)this->StatusMessage;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2Status_statusMessage_set)
{
    LassoSamlp2Status* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* StatusMessage_str = NULL;
    int StatusMessage_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &StatusMessage_str, &StatusMessage_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Status*)cvt_this->obj;

    lasso_assign_string(this->StatusMessage, StatusMessage_str);
}

PHP_FUNCTION(LassoSamlp2Status_statusDetail_get)
{
    LassoSamlp2StatusDetail* return_c_value;
    LassoSamlp2Status* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Status*)cvt_this->obj;

    return_c_value = (LassoSamlp2StatusDetail*)this->StatusDetail;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2Status_statusDetail_set)
{
    LassoSamlp2Status* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_StatusDetail = NULL;
    PhpGObjectPtr* cvt_StatusDetail = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_StatusDetail) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Status*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_StatusDetail, PhpGObjectPtr*, &zval_StatusDetail, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->StatusDetail, cvt_StatusDetail->obj);
}

PHP_FUNCTION(LassoSaml2EncryptedElement_encryptedData_get)
{
    xmlNode* return_c_value;
    LassoSaml2EncryptedElement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2EncryptedElement*)cvt_this->obj;

    return_c_value = (xmlNode*)this->EncryptedData;
    {
        char* xmlString = get_string_from_xml_node(return_c_value);
        if (xmlString) {
            RETVAL_STRING(xmlString, 0);
        } else {
            RETVAL_NULL();
        }
    }

}

PHP_FUNCTION(LassoSaml2EncryptedElement_encryptedData_set)
{
    LassoSaml2EncryptedElement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* EncryptedData_str = NULL;
    int EncryptedData_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &EncryptedData_str, &EncryptedData_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2EncryptedElement*)cvt_this->obj;

    lasso_assign_new_xml_node(this->EncryptedData, get_xml_node_from_string(EncryptedData_str));
}

PHP_FUNCTION(LassoSaml2EncryptedElement_encryptedKey_get)
{
    GList* return_c_value;
    LassoSaml2EncryptedElement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2EncryptedElement*)cvt_this->obj;

    return_c_value = (GList*)this->EncryptedKey;
    set_array_from_list_of_xmlnodes((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2EncryptedElement_encryptedKey_set)
{
    LassoSaml2EncryptedElement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedKey;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_EncryptedKey) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2EncryptedElement*)cvt_this->obj;

    lasso_assign_new_list_of_xml_node(this->EncryptedKey, get_list_from_array_of_xmlnodes(zval_EncryptedKey))
}

PHP_FUNCTION(LassoSaml2EncryptedElement_originalData_get)
{
    LassoNode* return_c_value;
    LassoSaml2EncryptedElement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2EncryptedElement*)cvt_this->obj;

    return_c_value = (LassoNode*)this->original_data;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2EncryptedElement_originalData_set)
{
    LassoSaml2EncryptedElement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_original_data = NULL;
    PhpGObjectPtr* cvt_original_data = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_original_data) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2EncryptedElement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_original_data, PhpGObjectPtr*, &zval_original_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->original_data, cvt_original_data->obj);
}

PHP_FUNCTION(lasso_saml2_encrypted_element_server_decrypt)
{
    LassoSaml2EncryptedElement* encrypted_element = NULL;
    zval* zval_encrypted_element = NULL;
    PhpGObjectPtr* cvt_encrypted_element = NULL;
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
   zval *php_out_decrypted_node = NULL;
   LassoNode* decrypted_node;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rrz!", &zval_encrypted_element, &zval_server, &php_out_decrypted_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_encrypted_element, PhpGObjectPtr *, &zval_encrypted_element, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    encrypted_element = (LassoSaml2EncryptedElement*)cvt_encrypted_element->obj;
    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  lasso_saml2_encrypted_element_server_decrypt(encrypted_element, server, &decrypted_node);
    zval_dtor(php_out_decrypted_node);
    if (! decrypted_node) {
       ZVAL_NULL(php_out_decrypted_node);
    } else {
    if (G_IS_OBJECT(decrypted_node)) {
        PhpGObjectPtr *obj = PhpGObjectPtr_New(G_OBJECT(decrypted_node));
        ZEND_REGISTER_RESOURCE(php_out_decrypted_node, obj, le_lasso_server);
    } else {
        ZVAL_NULL(php_out_decrypted_node);
    }
    if (decrypted_node) {
        g_object_unref(decrypted_node); // If constructor ref is off by one'
    }
    }
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_baseId_get)
{
    LassoSaml2BaseIDAbstract* return_c_value;
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    return_c_value = (LassoSaml2BaseIDAbstract*)this->BaseID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_baseId_set)
{
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_BaseID = NULL;
    PhpGObjectPtr* cvt_BaseID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_BaseID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_BaseID, PhpGObjectPtr*, &zval_BaseID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->BaseID, cvt_BaseID->obj);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_nameId_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->NameID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_nameId_set)
{
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameID = NULL;
    PhpGObjectPtr* cvt_NameID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameID, PhpGObjectPtr*, &zval_NameID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameID, cvt_NameID->obj);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_encryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_encryptedId_set)
{
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedID = NULL;
    PhpGObjectPtr* cvt_EncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedID, PhpGObjectPtr*, &zval_EncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedID, cvt_EncryptedID->obj);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_subjectConfirmationData_get)
{
    LassoSaml2SubjectConfirmationData* return_c_value;
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    return_c_value = (LassoSaml2SubjectConfirmationData*)this->SubjectConfirmationData;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_subjectConfirmationData_set)
{
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SubjectConfirmationData = NULL;
    PhpGObjectPtr* cvt_SubjectConfirmationData = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SubjectConfirmationData) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SubjectConfirmationData, PhpGObjectPtr*, &zval_SubjectConfirmationData, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SubjectConfirmationData, cvt_SubjectConfirmationData->obj);
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_method_get)
{
    char* return_c_value;
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    return_c_value = (char*)this->Method;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectConfirmation_method_set)
{
    LassoSaml2SubjectConfirmation* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Method_str = NULL;
    int Method_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Method_str, &Method_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectConfirmation*)cvt_this->obj;

    lasso_assign_string(this->Method, Method_str);
}

PHP_FUNCTION(LassoSamlp2IDPEntry_providerId_get)
{
    char* return_c_value;
    LassoSamlp2IDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPEntry*)cvt_this->obj;

    return_c_value = (char*)this->ProviderID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2IDPEntry_providerId_set)
{
    LassoSamlp2IDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderID_str = NULL;
    int ProviderID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderID_str, &ProviderID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPEntry*)cvt_this->obj;

    lasso_assign_string(this->ProviderID, ProviderID_str);
}

PHP_FUNCTION(LassoSamlp2IDPEntry_name_get)
{
    char* return_c_value;
    LassoSamlp2IDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPEntry*)cvt_this->obj;

    return_c_value = (char*)this->Name;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2IDPEntry_name_set)
{
    LassoSamlp2IDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Name_str = NULL;
    int Name_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Name_str, &Name_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPEntry*)cvt_this->obj;

    lasso_assign_string(this->Name, Name_str);
}

PHP_FUNCTION(LassoSamlp2IDPEntry_loc_get)
{
    char* return_c_value;
    LassoSamlp2IDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPEntry*)cvt_this->obj;

    return_c_value = (char*)this->Loc;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2IDPEntry_loc_set)
{
    LassoSamlp2IDPEntry* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Loc_str = NULL;
    int Loc_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Loc_str, &Loc_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2IDPEntry*)cvt_this->obj;

    lasso_assign_string(this->Loc, Loc_str);
}

PHP_FUNCTION(LassoSaml2AudienceRestriction_audience_get)
{
    char* return_c_value;
    LassoSaml2AudienceRestriction* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AudienceRestriction*)cvt_this->obj;

    return_c_value = (char*)this->Audience;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AudienceRestriction_audience_set)
{
    LassoSaml2AudienceRestriction* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Audience_str = NULL;
    int Audience_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Audience_str, &Audience_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AudienceRestriction*)cvt_this->obj;

    lasso_assign_string(this->Audience, Audience_str);
}

PHP_FUNCTION(LassoSamlp2RequestedAuthnContext_authnContextClassRef_get)
{
    GList* return_c_value;
    LassoSamlp2RequestedAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestedAuthnContext*)cvt_this->obj;

    return_c_value = (GList*)this->AuthnContextClassRef;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlp2RequestedAuthnContext_authnContextClassRef_set)
{
    LassoSamlp2RequestedAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnContextClassRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthnContextClassRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestedAuthnContext*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->AuthnContextClassRef, get_list_from_array_of_strings(zval_AuthnContextClassRef));
}

PHP_FUNCTION(LassoSamlp2RequestedAuthnContext_authnContextDeclRef_get)
{
    GList* return_c_value;
    LassoSamlp2RequestedAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestedAuthnContext*)cvt_this->obj;

    return_c_value = (GList*)this->AuthnContextDeclRef;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlp2RequestedAuthnContext_authnContextDeclRef_set)
{
    LassoSamlp2RequestedAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnContextDeclRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthnContextDeclRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestedAuthnContext*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->AuthnContextDeclRef, get_list_from_array_of_strings(zval_AuthnContextDeclRef));
}

PHP_FUNCTION(LassoSamlp2RequestedAuthnContext_comparison_get)
{
    char* return_c_value;
    LassoSamlp2RequestedAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestedAuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->Comparison;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestedAuthnContext_comparison_set)
{
    LassoSamlp2RequestedAuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Comparison_str = NULL;
    int Comparison_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Comparison_str, &Comparison_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestedAuthnContext*)cvt_this->obj;

    lasso_assign_string(this->Comparison, Comparison_str);
}

PHP_FUNCTION(LassoSaml2AttributeStatement_attribute_get)
{
    GList* return_c_value;
    LassoSaml2AttributeStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AttributeStatement*)cvt_this->obj;

    return_c_value = (GList*)this->Attribute;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2AttributeStatement_attribute_set)
{
    LassoSaml2AttributeStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Attribute;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Attribute) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AttributeStatement*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Attribute, get_list_from_array_of_objects(zval_Attribute));
}

PHP_FUNCTION(LassoSaml2AttributeStatement_encryptedAttribute_get)
{
    GList* return_c_value;
    LassoSaml2AttributeStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AttributeStatement*)cvt_this->obj;

    return_c_value = (GList*)this->EncryptedAttribute;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2AttributeStatement_encryptedAttribute_set)
{
    LassoSaml2AttributeStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedAttribute;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_EncryptedAttribute) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AttributeStatement*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->EncryptedAttribute, get_list_from_array_of_objects(zval_EncryptedAttribute));
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_action_get)
{
    LassoSaml2Action* return_c_value;
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    return_c_value = (LassoSaml2Action*)this->Action;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_action_set)
{
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Action = NULL;
    PhpGObjectPtr* cvt_Action = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Action) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Action, PhpGObjectPtr*, &zval_Action, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Action, cvt_Action->obj);
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_evidence_get)
{
    LassoSaml2Evidence* return_c_value;
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    return_c_value = (LassoSaml2Evidence*)this->Evidence;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_evidence_set)
{
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Evidence = NULL;
    PhpGObjectPtr* cvt_Evidence = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Evidence) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Evidence, PhpGObjectPtr*, &zval_Evidence, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Evidence, cvt_Evidence->obj);
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_resource_get)
{
    char* return_c_value;
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    return_c_value = (char*)this->Resource;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_resource_set)
{
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Resource_str = NULL;
    int Resource_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Resource_str, &Resource_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    lasso_assign_string(this->Resource, Resource_str);
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_decision_get)
{
    char* return_c_value;
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    return_c_value = (char*)this->Decision;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthzDecisionStatement_decision_set)
{
    LassoSaml2AuthzDecisionStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Decision_str = NULL;
    int Decision_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Decision_str, &Decision_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthzDecisionStatement*)cvt_this->obj;

    lasso_assign_string(this->Decision, Decision_str);
}

PHP_FUNCTION(LassoSaml2Evidence_assertionIdRef_get)
{
    GList* return_c_value;
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    return_c_value = (GList*)this->AssertionIDRef;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Evidence_assertionIdRef_set)
{
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AssertionIDRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AssertionIDRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AssertionIDRef, get_list_from_array_of_objects(zval_AssertionIDRef));
}

PHP_FUNCTION(LassoSaml2Evidence_assertionUriRef_get)
{
    GList* return_c_value;
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    return_c_value = (GList*)this->AssertionURIRef;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Evidence_assertionUriRef_set)
{
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AssertionURIRef;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AssertionURIRef) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AssertionURIRef, get_list_from_array_of_objects(zval_AssertionURIRef));
}

PHP_FUNCTION(LassoSaml2Evidence_assertion_get)
{
    GList* return_c_value;
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    return_c_value = (GList*)this->Assertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Evidence_assertion_set)
{
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Assertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Assertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Assertion, get_list_from_array_of_objects(zval_Assertion));
}

PHP_FUNCTION(LassoSaml2Evidence_encryptedAssertion_get)
{
    GList* return_c_value;
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    return_c_value = (GList*)this->EncryptedAssertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Evidence_encryptedAssertion_set)
{
    LassoSaml2Evidence* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedAssertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_EncryptedAssertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Evidence*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->EncryptedAssertion, get_list_from_array_of_objects(zval_EncryptedAssertion));
}

PHP_FUNCTION(lasso_saml2_key_info_confirmation_data_type_get_key_info)
{
    LassoSaml2KeyInfoConfirmationDataType* kicdt = NULL;
    zval* zval_kicdt = NULL;
    PhpGObjectPtr* cvt_kicdt = NULL;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_kicdt) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_kicdt, PhpGObjectPtr *, &zval_kicdt, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    kicdt = (LassoSaml2KeyInfoConfirmationDataType*)cvt_kicdt->obj;
    return_c_value =  lasso_saml2_key_info_confirmation_data_type_get_key_info(kicdt);
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(lasso_saml2_key_info_confirmation_data_type_set_key_info)
{
    LassoSaml2KeyInfoConfirmationDataType* kicdt = NULL;
    zval* zval_kicdt = NULL;
    PhpGObjectPtr* cvt_kicdt = NULL;
    zval* zval_key_infos = NULL;
    GList* key_infos = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra!", &zval_kicdt, &zval_key_infos) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_kicdt, PhpGObjectPtr *, &zval_kicdt, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    kicdt = (LassoSaml2KeyInfoConfirmationDataType*)cvt_kicdt->obj;
    key_infos = get_list_from_array_of_objects(zval_key_infos);
    lasso_saml2_key_info_confirmation_data_type_set_key_info(kicdt, key_infos);
}

PHP_FUNCTION(LassoSamlp2Scoping_idpList_get)
{
    LassoSamlp2IDPList* return_c_value;
    LassoSamlp2Scoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Scoping*)cvt_this->obj;

    return_c_value = (LassoSamlp2IDPList*)this->IDPList;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2Scoping_idpList_set)
{
    LassoSamlp2Scoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_IDPList = NULL;
    PhpGObjectPtr* cvt_IDPList = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_IDPList) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Scoping*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_IDPList, PhpGObjectPtr*, &zval_IDPList, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->IDPList, cvt_IDPList->obj);
}

PHP_FUNCTION(LassoSamlp2Scoping_requesterId_get)
{
    char* return_c_value;
    LassoSamlp2Scoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Scoping*)cvt_this->obj;

    return_c_value = (char*)this->RequesterID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2Scoping_requesterId_set)
{
    LassoSamlp2Scoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* RequesterID_str = NULL;
    int RequesterID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &RequesterID_str, &RequesterID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Scoping*)cvt_this->obj;

    lasso_assign_string(this->RequesterID, RequesterID_str);
}

PHP_FUNCTION(LassoSamlp2Scoping_proxyCount_get)
{
    char* return_c_value;
    LassoSamlp2Scoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Scoping*)cvt_this->obj;

    return_c_value = (char*)this->ProxyCount;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2Scoping_proxyCount_set)
{
    LassoSamlp2Scoping* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProxyCount_str = NULL;
    int ProxyCount_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProxyCount_str, &ProxyCount_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Scoping*)cvt_this->obj;

    lasso_assign_string(this->ProxyCount, ProxyCount_str);
}

PHP_FUNCTION(LassoSaml2AuthnContext_authnContextClassRef_get)
{
    char* return_c_value;
    LassoSaml2AuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->AuthnContextClassRef;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnContext_authnContextClassRef_set)
{
    LassoSaml2AuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthnContextClassRef_str = NULL;
    int AuthnContextClassRef_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthnContextClassRef_str, &AuthnContextClassRef_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnContext*)cvt_this->obj;

    lasso_assign_string(this->AuthnContextClassRef, AuthnContextClassRef_str);
}

PHP_FUNCTION(LassoSaml2AuthnContext_authnContextDeclRef_get)
{
    char* return_c_value;
    LassoSaml2AuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->AuthnContextDeclRef;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnContext_authnContextDeclRef_set)
{
    LassoSaml2AuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthnContextDeclRef_str = NULL;
    int AuthnContextDeclRef_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthnContextDeclRef_str, &AuthnContextDeclRef_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnContext*)cvt_this->obj;

    lasso_assign_string(this->AuthnContextDeclRef, AuthnContextDeclRef_str);
}

PHP_FUNCTION(LassoSaml2AuthnContext_authenticatingAuthority_get)
{
    char* return_c_value;
    LassoSaml2AuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnContext*)cvt_this->obj;

    return_c_value = (char*)this->AuthenticatingAuthority;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnContext_authenticatingAuthority_set)
{
    LassoSaml2AuthnContext* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthenticatingAuthority_str = NULL;
    int AuthenticatingAuthority_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthenticatingAuthority_str, &AuthenticatingAuthority_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnContext*)cvt_this->obj;

    lasso_assign_string(this->AuthenticatingAuthority, AuthenticatingAuthority_str);
}

PHP_FUNCTION(LassoSaml2Assertion_issuer_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->Issuer;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_issuer_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Issuer = NULL;
    PhpGObjectPtr* cvt_Issuer = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Issuer) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Issuer, PhpGObjectPtr*, &zval_Issuer, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Issuer, cvt_Issuer->obj);
}

PHP_FUNCTION(LassoSaml2Assertion_subject_get)
{
    LassoSaml2Subject* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (LassoSaml2Subject*)this->Subject;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_subject_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Subject = NULL;
    PhpGObjectPtr* cvt_Subject = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Subject) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Subject, PhpGObjectPtr*, &zval_Subject, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Subject, cvt_Subject->obj);
}

PHP_FUNCTION(LassoSaml2Assertion_conditions_get)
{
    LassoSaml2Conditions* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (LassoSaml2Conditions*)this->Conditions;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_conditions_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Conditions = NULL;
    PhpGObjectPtr* cvt_Conditions = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Conditions) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Conditions, PhpGObjectPtr*, &zval_Conditions, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Conditions, cvt_Conditions->obj);
}

PHP_FUNCTION(LassoSaml2Assertion_advice_get)
{
    LassoSaml2Advice* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (LassoSaml2Advice*)this->Advice;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_advice_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Advice = NULL;
    PhpGObjectPtr* cvt_Advice = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Advice) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Advice, PhpGObjectPtr*, &zval_Advice, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Advice, cvt_Advice->obj);
}

PHP_FUNCTION(LassoSaml2Assertion_statement_get)
{
    GList* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (GList*)this->Statement;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Assertion_statement_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Statement;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Statement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Statement, get_list_from_array_of_objects(zval_Statement));
}

PHP_FUNCTION(LassoSaml2Assertion_authnStatement_get)
{
    GList* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (GList*)this->AuthnStatement;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Assertion_authnStatement_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnStatement;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthnStatement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AuthnStatement, get_list_from_array_of_objects(zval_AuthnStatement));
}

PHP_FUNCTION(LassoSaml2Assertion_authzDecisionStatement_get)
{
    GList* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (GList*)this->AuthzDecisionStatement;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Assertion_authzDecisionStatement_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthzDecisionStatement;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AuthzDecisionStatement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AuthzDecisionStatement, get_list_from_array_of_objects(zval_AuthzDecisionStatement));
}

PHP_FUNCTION(LassoSaml2Assertion_attributeStatement_get)
{
    GList* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (GList*)this->AttributeStatement;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSaml2Assertion_attributeStatement_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AttributeStatement;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_AttributeStatement) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->AttributeStatement, get_list_from_array_of_objects(zval_AttributeStatement));
}

PHP_FUNCTION(LassoSaml2Assertion_version_get)
{
    char* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (char*)this->Version;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_version_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Version_str = NULL;
    int Version_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Version_str, &Version_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_string(this->Version, Version_str);
}

PHP_FUNCTION(LassoSaml2Assertion_id_get)
{
    char* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (char*)this->ID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_id_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ID_str = NULL;
    int ID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ID_str, &ID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_string(this->ID, ID_str);
}

PHP_FUNCTION(LassoSaml2Assertion_issueInstant_get)
{
    char* return_c_value;
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    return_c_value = (char*)this->IssueInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Assertion_issueInstant_set)
{
    LassoSaml2Assertion* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IssueInstant_str = NULL;
    int IssueInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IssueInstant_str, &IssueInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Assertion*)cvt_this->obj;

    lasso_assign_string(this->IssueInstant, IssueInstant_str);
}

PHP_FUNCTION(lasso_saml2_assertion_has_audience_restriction)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_saml2_assertion) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    return_c_value =  lasso_saml2_assertion_has_audience_restriction(saml2_assertion);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_is_audience_restricted)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_saml2_assertion, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
        providerID = providerID_str;
    return_c_value =  lasso_saml2_assertion_is_audience_restricted(saml2_assertion, providerID);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_set_subject_name_id)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_saml2_assertion, &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    lasso_saml2_assertion_set_subject_name_id(saml2_assertion, node);
}

PHP_FUNCTION(lasso_saml2_assertion_set_subject_confirmation_name_id)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    LassoNode* node = NULL;
    zval* zval_node = NULL;
    PhpGObjectPtr* cvt_node = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_saml2_assertion, &zval_node) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    ZEND_FETCH_RESOURCE(cvt_node, PhpGObjectPtr *, &zval_node, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    node = (LassoNode*)cvt_node->obj;
    lasso_saml2_assertion_set_subject_confirmation_name_id(saml2_assertion, node);
}

PHP_FUNCTION(lasso_saml2_assertion_set_subject_confirmation_data)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    long tolerance;
    long length;
    char* Recipient = NULL;
    char* Recipient_str = NULL;
    int Recipient_len = 0;
    char* InResponseTo = NULL;
    char* InResponseTo_str = NULL;
    int InResponseTo_len = 0;
    char* Address = NULL;
    char* Address_str = NULL;
    int Address_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rlls!s!s!", &zval_saml2_assertion, &tolerance, &length, &Recipient_str, &Recipient_len, &InResponseTo_str, &InResponseTo_len, &Address_str, &Address_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
        Recipient = Recipient_str;
        InResponseTo = InResponseTo_str;
        Address = Address_str;
    lasso_saml2_assertion_set_subject_confirmation_data(saml2_assertion, tolerance, length, Recipient, InResponseTo, Address);
}

PHP_FUNCTION(lasso_saml2_assertion_set_basic_conditions)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    long tolerance;
    long length;
    long one_time_use;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rlll", &zval_saml2_assertion, &tolerance, &length, &one_time_use) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    lasso_saml2_assertion_set_basic_conditions(saml2_assertion, tolerance, length, one_time_use);
}

PHP_FUNCTION(lasso_saml2_assertion_add_audience_restriction)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    char* providerID = NULL;
    char* providerID_str = NULL;
    int providerID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_saml2_assertion, &providerID_str, &providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
        providerID = providerID_str;
    lasso_saml2_assertion_add_audience_restriction(saml2_assertion, providerID);
}

PHP_FUNCTION(lasso_saml2_assertion_add_proxy_limit)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    long proxy_count;
    zval* zval_proxy_audiences = NULL;
    GList* proxy_audiences = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rla!", &zval_saml2_assertion, &proxy_count, &zval_proxy_audiences) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    proxy_audiences = get_list_from_array_of_strings(zval_proxy_audiences);
    lasso_saml2_assertion_add_proxy_limit(saml2_assertion, proxy_count, proxy_audiences);
    if (proxy_audiences) {
        free_glist(&proxy_audiences,(GFunc)free);
    }
}

PHP_FUNCTION(lasso_saml2_assertion_validate_conditions)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    char* relaying_party_providerID = NULL;
    char* relaying_party_providerID_str = NULL;
    int relaying_party_providerID_len = 0;
    LassoSaml2AssertionValidationState return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_saml2_assertion, &relaying_party_providerID_str, &relaying_party_providerID_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
        relaying_party_providerID = relaying_party_providerID_str;
    return_c_value =  lasso_saml2_assertion_validate_conditions(saml2_assertion, relaying_party_providerID);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_get_issuer_provider)
{
    const LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    const LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    LassoProvider* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_saml2_assertion, &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (const LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (const LassoServer*)cvt_server->obj;
    return_c_value =  lasso_saml2_assertion_get_issuer_provider(saml2_assertion, server);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_add_attribute_with_node)
{
    LassoSaml2Assertion* assertion = NULL;
    zval* zval_assertion = NULL;
    PhpGObjectPtr* cvt_assertion = NULL;
    char* name = NULL;
    char* name_str = NULL;
    int name_len = 0;
    char* nameformat = NULL;
    char* nameformat_str = NULL;
    int nameformat_len = 0;
    LassoNode* content = NULL;
    zval* zval_content = NULL;
    PhpGObjectPtr* cvt_content = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!s!r", &zval_assertion, &name_str, &name_len, &nameformat_str, &nameformat_len, &zval_content) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion, PhpGObjectPtr *, &zval_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion = (LassoSaml2Assertion*)cvt_assertion->obj;
        name = name_str;
        nameformat = nameformat_str;
    ZEND_FETCH_RESOURCE(cvt_content, PhpGObjectPtr *, &zval_content, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    content = (LassoNode*)cvt_content->obj;
    return_c_value =  lasso_saml2_assertion_add_attribute_with_node(assertion, name, nameformat, content);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_get_subject_confirmation_data)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    long create;
    LassoSaml2SubjectConfirmationData* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_saml2_assertion, &create) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    return_c_value =  lasso_saml2_assertion_get_subject_confirmation_data(saml2_assertion, create);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
    lasso_release_gobject(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_get_in_response_to)
{
    LassoSaml2Assertion* assertion = NULL;
    zval* zval_assertion = NULL;
    PhpGObjectPtr* cvt_assertion = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_assertion) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion, PhpGObjectPtr *, &zval_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion = (LassoSaml2Assertion*)cvt_assertion->obj;
    return_c_value =  lasso_saml2_assertion_get_in_response_to(assertion);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_saml2_assertion_decrypt_subject)
{
    LassoSaml2Assertion* assertion = NULL;
    zval* zval_assertion = NULL;
    PhpGObjectPtr* cvt_assertion = NULL;
    LassoServer* server = NULL;
    zval* zval_server = NULL;
    PhpGObjectPtr* cvt_server = NULL;
    lasso_error_t return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_assertion, &zval_server) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_assertion, PhpGObjectPtr *, &zval_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    assertion = (LassoSaml2Assertion*)cvt_assertion->obj;
    ZEND_FETCH_RESOURCE(cvt_server, PhpGObjectPtr *, &zval_server, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    server = (LassoServer*)cvt_server->obj;
    return_c_value =  lasso_saml2_assertion_decrypt_subject(assertion, server);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_validate_time_checks)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    long tolerance;
    long now;
    LassoSaml2AssertionValidationState return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rll", &zval_saml2_assertion, &tolerance, &now) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    return_c_value =  lasso_saml2_assertion_validate_time_checks(saml2_assertion, tolerance, now);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_validate_audience)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    char* audience = NULL;
    char* audience_str = NULL;
    int audience_len = 0;
    LassoSaml2AssertionValidationState return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_saml2_assertion, &audience_str, &audience_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
        audience = audience_str;
    return_c_value =  lasso_saml2_assertion_validate_audience(saml2_assertion, audience);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_has_one_time_use)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_saml2_assertion) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    return_c_value =  lasso_saml2_assertion_has_one_time_use(saml2_assertion);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_allows_proxying)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    LassoSaml2AssertionValidationState return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_saml2_assertion) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    return_c_value =  lasso_saml2_assertion_allows_proxying(saml2_assertion);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_allows_proxying_to)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    char* audience = NULL;
    char* audience_str = NULL;
    int audience_len = 0;
    LassoSaml2AssertionValidationState return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_saml2_assertion, &audience_str, &audience_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
        audience = audience_str;
    return_c_value =  lasso_saml2_assertion_allows_proxying_to(saml2_assertion, audience);
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(lasso_saml2_assertion_set_one_time_use)
{
    LassoSaml2Assertion* saml2_assertion = NULL;
    zval* zval_saml2_assertion = NULL;
    PhpGObjectPtr* cvt_saml2_assertion = NULL;
    long one_time_use;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_saml2_assertion, &one_time_use) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_saml2_assertion, PhpGObjectPtr *, &zval_saml2_assertion, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    saml2_assertion = (LassoSaml2Assertion*)cvt_saml2_assertion->obj;
    lasso_saml2_assertion_set_one_time_use(saml2_assertion, one_time_use);
}

PHP_FUNCTION(LassoSaml2NameID_content_get)
{
    char* return_c_value;
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    return_c_value = (char*)this->content;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2NameID_content_set)
{
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* content_str = NULL;
    int content_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &content_str, &content_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    lasso_assign_string(this->content, content_str);
}

PHP_FUNCTION(LassoSaml2NameID_format_get)
{
    char* return_c_value;
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    return_c_value = (char*)this->Format;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2NameID_format_set)
{
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Format_str = NULL;
    int Format_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Format_str, &Format_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    lasso_assign_string(this->Format, Format_str);
}

PHP_FUNCTION(LassoSaml2NameID_spProvidedId_get)
{
    char* return_c_value;
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    return_c_value = (char*)this->SPProvidedID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2NameID_spProvidedId_set)
{
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SPProvidedID_str = NULL;
    int SPProvidedID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SPProvidedID_str, &SPProvidedID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    lasso_assign_string(this->SPProvidedID, SPProvidedID_str);
}

PHP_FUNCTION(LassoSaml2NameID_nameQualifier_get)
{
    char* return_c_value;
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    return_c_value = (char*)this->NameQualifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2NameID_nameQualifier_set)
{
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NameQualifier_str = NULL;
    int NameQualifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NameQualifier_str, &NameQualifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    lasso_assign_string(this->NameQualifier, NameQualifier_str);
}

PHP_FUNCTION(LassoSaml2NameID_spNameQualifier_get)
{
    char* return_c_value;
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    return_c_value = (char*)this->SPNameQualifier;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2NameID_spNameQualifier_set)
{
    LassoSaml2NameID* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SPNameQualifier_str = NULL;
    int SPNameQualifier_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SPNameQualifier_str, &SPNameQualifier_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2NameID*)cvt_this->obj;

    lasso_assign_string(this->SPNameQualifier, SPNameQualifier_str);
}

PHP_FUNCTION(lasso_saml2_name_id_equals)
{
    LassoSaml2NameID* name_id = NULL;
    zval* zval_name_id = NULL;
    PhpGObjectPtr* cvt_name_id = NULL;
    LassoSaml2NameID* other_name_id = NULL;
    zval* zval_other_name_id = NULL;
    PhpGObjectPtr* cvt_other_name_id = NULL;
    gboolean return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_name_id, &zval_other_name_id) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_name_id, PhpGObjectPtr *, &zval_name_id, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    name_id = (LassoSaml2NameID*)cvt_name_id->obj;
    ZEND_FETCH_RESOURCE(cvt_other_name_id, PhpGObjectPtr *, &zval_other_name_id, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    other_name_id = (LassoSaml2NameID*)cvt_other_name_id->obj;
    return_c_value =  lasso_saml2_name_id_equals(name_id, other_name_id);
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoSamlp2NameIDMappingResponse_nameId_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSamlp2NameIDMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingResponse*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->NameID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDMappingResponse_nameId_set)
{
    LassoSamlp2NameIDMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameID = NULL;
    PhpGObjectPtr* cvt_NameID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameID, PhpGObjectPtr*, &zval_NameID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameID, cvt_NameID->obj);
}

PHP_FUNCTION(LassoSamlp2NameIDMappingResponse_encryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSamlp2NameIDMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingResponse*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDMappingResponse_encryptedId_set)
{
    LassoSamlp2NameIDMappingResponse* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedID = NULL;
    PhpGObjectPtr* cvt_EncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingResponse*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedID, PhpGObjectPtr*, &zval_EncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedID, cvt_EncryptedID->obj);
}

PHP_FUNCTION(LassoSaml2Action_content_get)
{
    char* return_c_value;
    LassoSaml2Action* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Action*)cvt_this->obj;

    return_c_value = (char*)this->content;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Action_content_set)
{
    LassoSaml2Action* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* content_str = NULL;
    int content_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &content_str, &content_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Action*)cvt_this->obj;

    lasso_assign_string(this->content, content_str);
}

PHP_FUNCTION(LassoSaml2Action_namespace_get)
{
    char* return_c_value;
    LassoSaml2Action* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Action*)cvt_this->obj;

    return_c_value = (char*)this->Namespace;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2Action_namespace_set)
{
    LassoSaml2Action* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Namespace_str = NULL;
    int Namespace_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Namespace_str, &Namespace_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2Action*)cvt_this->obj;

    lasso_assign_string(this->Namespace, Namespace_str);
}

PHP_FUNCTION(LassoSamlp2Response_assertion_get)
{
    GList* return_c_value;
    LassoSamlp2Response* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Response*)cvt_this->obj;

    return_c_value = (GList*)this->Assertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlp2Response_assertion_set)
{
    LassoSamlp2Response* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Assertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Assertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Response*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Assertion, get_list_from_array_of_objects(zval_Assertion));
}

PHP_FUNCTION(LassoSamlp2Response_encryptedAssertion_get)
{
    GList* return_c_value;
    LassoSamlp2Response* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Response*)cvt_this->obj;

    return_c_value = (GList*)this->EncryptedAssertion;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlp2Response_encryptedAssertion_set)
{
    LassoSamlp2Response* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedAssertion;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_EncryptedAssertion) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2Response*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->EncryptedAssertion, get_list_from_array_of_objects(zval_EncryptedAssertion));
}

PHP_FUNCTION(LassoSaml2SubjectLocality_address_get)
{
    char* return_c_value;
    LassoSaml2SubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectLocality*)cvt_this->obj;

    return_c_value = (char*)this->Address;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectLocality_address_set)
{
    LassoSaml2SubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Address_str = NULL;
    int Address_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Address_str, &Address_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectLocality*)cvt_this->obj;

    lasso_assign_string(this->Address, Address_str);
}

PHP_FUNCTION(LassoSaml2SubjectLocality_dnsName_get)
{
    char* return_c_value;
    LassoSaml2SubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectLocality*)cvt_this->obj;

    return_c_value = (char*)this->DNSName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2SubjectLocality_dnsName_set)
{
    LassoSaml2SubjectLocality* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* DNSName_str = NULL;
    int DNSName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &DNSName_str, &DNSName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2SubjectLocality*)cvt_this->obj;

    lasso_assign_string(this->DNSName, DNSName_str);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_issuer_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->Issuer;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_issuer_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Issuer = NULL;
    PhpGObjectPtr* cvt_Issuer = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Issuer) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Issuer, PhpGObjectPtr*, &zval_Issuer, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Issuer, cvt_Issuer->obj);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_extensions_get)
{
    LassoSamlp2Extensions* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (LassoSamlp2Extensions*)this->Extensions;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_extensions_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Extensions = NULL;
    PhpGObjectPtr* cvt_Extensions = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Extensions) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Extensions, PhpGObjectPtr*, &zval_Extensions, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Extensions, cvt_Extensions->obj);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_id_get)
{
    char* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->ID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_id_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ID_str = NULL;
    int ID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ID_str, &ID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->ID, ID_str);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_version_get)
{
    char* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->Version;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_version_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Version_str = NULL;
    int Version_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Version_str, &Version_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->Version, Version_str);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_issueInstant_get)
{
    char* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->IssueInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_issueInstant_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* IssueInstant_str = NULL;
    int IssueInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &IssueInstant_str, &IssueInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->IssueInstant, IssueInstant_str);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_destination_get)
{
    char* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->Destination;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_destination_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Destination_str = NULL;
    int Destination_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Destination_str, &Destination_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->Destination, Destination_str);
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_consent_get)
{
    char* return_c_value;
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    return_c_value = (char*)this->Consent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2RequestAbstract_consent_set)
{
    LassoSamlp2RequestAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Consent_str = NULL;
    int Consent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Consent_str, &Consent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2RequestAbstract*)cvt_this->obj;

    lasso_assign_string(this->Consent, Consent_str);
}

PHP_FUNCTION(LassoSamlp2AssertionIDRequest_assertionIdRef_get)
{
    char* return_c_value;
    LassoSamlp2AssertionIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AssertionIDRequest*)cvt_this->obj;

    return_c_value = (char*)this->AssertionIDRef;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AssertionIDRequest_assertionIdRef_set)
{
    LassoSamlp2AssertionIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionIDRef_str = NULL;
    int AssertionIDRef_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionIDRef_str, &AssertionIDRef_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AssertionIDRequest*)cvt_this->obj;

    lasso_assign_string(this->AssertionIDRef, AssertionIDRef_str);
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_baseId_get)
{
    LassoSaml2BaseIDAbstract* return_c_value;
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2BaseIDAbstract*)this->BaseID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_baseId_set)
{
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_BaseID = NULL;
    PhpGObjectPtr* cvt_BaseID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_BaseID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_BaseID, PhpGObjectPtr*, &zval_BaseID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->BaseID, cvt_BaseID->obj);
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_nameId_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->NameID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_nameId_set)
{
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameID = NULL;
    PhpGObjectPtr* cvt_NameID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameID, PhpGObjectPtr*, &zval_NameID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameID, cvt_NameID->obj);
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_encryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_encryptedId_set)
{
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedID = NULL;
    PhpGObjectPtr* cvt_EncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedID, PhpGObjectPtr*, &zval_EncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedID, cvt_EncryptedID->obj);
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_nameIdPolicy_get)
{
    LassoSamlp2NameIDPolicy* return_c_value;
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    return_c_value = (LassoSamlp2NameIDPolicy*)this->NameIDPolicy;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2NameIDMappingRequest_nameIdPolicy_set)
{
    LassoSamlp2NameIDMappingRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIDPolicy = NULL;
    PhpGObjectPtr* cvt_NameIDPolicy = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIDPolicy) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2NameIDMappingRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIDPolicy, PhpGObjectPtr*, &zval_NameIDPolicy, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIDPolicy, cvt_NameIDPolicy->obj);
}

PHP_FUNCTION(LassoSamlp2ArtifactResolve_artifact_get)
{
    char* return_c_value;
    LassoSamlp2ArtifactResolve* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ArtifactResolve*)cvt_this->obj;

    return_c_value = (char*)this->Artifact;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ArtifactResolve_artifact_set)
{
    LassoSamlp2ArtifactResolve* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Artifact_str = NULL;
    int Artifact_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Artifact_str, &Artifact_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ArtifactResolve*)cvt_this->obj;

    lasso_assign_string(this->Artifact, Artifact_str);
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_nameId_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->NameID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_nameId_set)
{
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameID = NULL;
    PhpGObjectPtr* cvt_NameID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameID, PhpGObjectPtr*, &zval_NameID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameID, cvt_NameID->obj);
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_encryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_encryptedId_set)
{
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedID = NULL;
    PhpGObjectPtr* cvt_EncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedID, PhpGObjectPtr*, &zval_EncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedID, cvt_EncryptedID->obj);
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_newId_get)
{
    char* return_c_value;
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    return_c_value = (char*)this->NewID;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_newId_set)
{
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NewID_str = NULL;
    int NewID_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NewID_str, &NewID_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    lasso_assign_string(this->NewID, NewID_str);
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_newEncryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->NewEncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_newEncryptedId_set)
{
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NewEncryptedID = NULL;
    PhpGObjectPtr* cvt_NewEncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NewEncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NewEncryptedID, PhpGObjectPtr*, &zval_NewEncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NewEncryptedID, cvt_NewEncryptedID->obj);
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_terminate_get)
{
    LassoSamlp2Terminate* return_c_value;
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    return_c_value = (LassoSamlp2Terminate*)this->Terminate;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2ManageNameIDRequest_terminate_set)
{
    LassoSamlp2ManageNameIDRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Terminate = NULL;
    PhpGObjectPtr* cvt_Terminate = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Terminate) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2ManageNameIDRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Terminate, PhpGObjectPtr*, &zval_Terminate, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Terminate, cvt_Terminate->obj);
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_baseId_get)
{
    LassoSaml2BaseIDAbstract* return_c_value;
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2BaseIDAbstract*)this->BaseID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_baseId_set)
{
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_BaseID = NULL;
    PhpGObjectPtr* cvt_BaseID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_BaseID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_BaseID, PhpGObjectPtr*, &zval_BaseID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->BaseID, cvt_BaseID->obj);
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_nameId_get)
{
    LassoSaml2NameID* return_c_value;
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2NameID*)this->NameID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_nameId_set)
{
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameID = NULL;
    PhpGObjectPtr* cvt_NameID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameID, PhpGObjectPtr*, &zval_NameID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameID, cvt_NameID->obj);
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_encryptedId_get)
{
    LassoSaml2EncryptedElement* return_c_value;
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2EncryptedElement*)this->EncryptedID;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_encryptedId_set)
{
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_EncryptedID = NULL;
    PhpGObjectPtr* cvt_EncryptedID = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_EncryptedID) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_EncryptedID, PhpGObjectPtr*, &zval_EncryptedID, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->EncryptedID, cvt_EncryptedID->obj);
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_sessionIndex_get)
{
    char* return_c_value;
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->SessionIndex;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_sessionIndex_set)
{
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SessionIndex_str = NULL;
    int SessionIndex_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SessionIndex_str, &SessionIndex_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->SessionIndex, SessionIndex_str);
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_reason_get)
{
    char* return_c_value;
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->Reason;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_reason_set)
{
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Reason_str = NULL;
    int Reason_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Reason_str, &Reason_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->Reason, Reason_str);
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_notOnOrAfter_get)
{
    char* return_c_value;
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    return_c_value = (char*)this->NotOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2LogoutRequest_notOnOrAfter_set)
{
    LassoSamlp2LogoutRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* NotOnOrAfter_str = NULL;
    int NotOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &NotOnOrAfter_str, &NotOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2LogoutRequest*)cvt_this->obj;

    lasso_assign_string(this->NotOnOrAfter, NotOnOrAfter_str);
}

PHP_FUNCTION(lasso_samlp2_logout_request_get_session_indexes)
{
    LassoSamlp2LogoutRequest* logout_request = NULL;
    zval* zval_logout_request = NULL;
    PhpGObjectPtr* cvt_logout_request = NULL;
    GList* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_logout_request) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout_request, PhpGObjectPtr *, &zval_logout_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout_request = (LassoSamlp2LogoutRequest*)cvt_logout_request->obj;
    return_c_value =  lasso_samlp2_logout_request_get_session_indexes(logout_request);
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

    lasso_release_list_of_strings(return_c_value);
}

PHP_FUNCTION(lasso_samlp2_logout_request_set_session_indexes)
{
    LassoSamlp2LogoutRequest* logout_request = NULL;
    zval* zval_logout_request = NULL;
    PhpGObjectPtr* cvt_logout_request = NULL;
    zval* zval_session_index = NULL;
    GList* session_index = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra!", &zval_logout_request, &zval_session_index) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_logout_request, PhpGObjectPtr *, &zval_logout_request, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    logout_request = (LassoSamlp2LogoutRequest*)cvt_logout_request->obj;
    session_index = get_list_from_array_of_strings(zval_session_index);
    lasso_samlp2_logout_request_set_session_indexes(logout_request, session_index);
    if (session_index) {
        free_glist(&session_index,(GFunc)free);
    }
}

PHP_FUNCTION(LassoSamlp2SubjectQueryAbstract_subject_get)
{
    LassoSaml2Subject* return_c_value;
    LassoSamlp2SubjectQueryAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2SubjectQueryAbstract*)cvt_this->obj;

    return_c_value = (LassoSaml2Subject*)this->Subject;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2SubjectQueryAbstract_subject_set)
{
    LassoSamlp2SubjectQueryAbstract* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Subject = NULL;
    PhpGObjectPtr* cvt_Subject = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Subject) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2SubjectQueryAbstract*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Subject, PhpGObjectPtr*, &zval_Subject, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Subject, cvt_Subject->obj);
}

PHP_FUNCTION(LassoSamlp2AttributeQuery_attribute_get)
{
    GList* return_c_value;
    LassoSamlp2AttributeQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AttributeQuery*)cvt_this->obj;

    return_c_value = (GList*)this->Attribute;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSamlp2AttributeQuery_attribute_set)
{
    LassoSamlp2AttributeQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Attribute;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Attribute) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AttributeQuery*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Attribute, get_list_from_array_of_objects(zval_Attribute));
}

PHP_FUNCTION(LassoSamlp2AuthzDecisionQuery_action_get)
{
    LassoSaml2Action* return_c_value;
    LassoSamlp2AuthzDecisionQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthzDecisionQuery*)cvt_this->obj;

    return_c_value = (LassoSaml2Action*)this->Action;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthzDecisionQuery_action_set)
{
    LassoSamlp2AuthzDecisionQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Action = NULL;
    PhpGObjectPtr* cvt_Action = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Action) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthzDecisionQuery*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Action, PhpGObjectPtr*, &zval_Action, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Action, cvt_Action->obj);
}

PHP_FUNCTION(LassoSamlp2AuthzDecisionQuery_evidence_get)
{
    LassoSaml2Evidence* return_c_value;
    LassoSamlp2AuthzDecisionQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthzDecisionQuery*)cvt_this->obj;

    return_c_value = (LassoSaml2Evidence*)this->Evidence;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthzDecisionQuery_evidence_set)
{
    LassoSamlp2AuthzDecisionQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Evidence = NULL;
    PhpGObjectPtr* cvt_Evidence = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Evidence) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthzDecisionQuery*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Evidence, PhpGObjectPtr*, &zval_Evidence, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Evidence, cvt_Evidence->obj);
}

PHP_FUNCTION(LassoSamlp2AuthzDecisionQuery_resource_get)
{
    char* return_c_value;
    LassoSamlp2AuthzDecisionQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthzDecisionQuery*)cvt_this->obj;

    return_c_value = (char*)this->Resource;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthzDecisionQuery_resource_set)
{
    LassoSamlp2AuthzDecisionQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Resource_str = NULL;
    int Resource_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Resource_str, &Resource_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthzDecisionQuery*)cvt_this->obj;

    lasso_assign_string(this->Resource, Resource_str);
}

PHP_FUNCTION(LassoSaml2AuthnStatement_subjectLocality_get)
{
    LassoSaml2SubjectLocality* return_c_value;
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    return_c_value = (LassoSaml2SubjectLocality*)this->SubjectLocality;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnStatement_subjectLocality_set)
{
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_SubjectLocality = NULL;
    PhpGObjectPtr* cvt_SubjectLocality = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_SubjectLocality) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_SubjectLocality, PhpGObjectPtr*, &zval_SubjectLocality, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->SubjectLocality, cvt_SubjectLocality->obj);
}

PHP_FUNCTION(LassoSaml2AuthnStatement_authnContext_get)
{
    LassoSaml2AuthnContext* return_c_value;
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    return_c_value = (LassoSaml2AuthnContext*)this->AuthnContext;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnStatement_authnContext_set)
{
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_AuthnContext = NULL;
    PhpGObjectPtr* cvt_AuthnContext = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_AuthnContext) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_AuthnContext, PhpGObjectPtr*, &zval_AuthnContext, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->AuthnContext, cvt_AuthnContext->obj);
}

PHP_FUNCTION(LassoSaml2AuthnStatement_authnInstant_get)
{
    char* return_c_value;
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    return_c_value = (char*)this->AuthnInstant;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnStatement_authnInstant_set)
{
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AuthnInstant_str = NULL;
    int AuthnInstant_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AuthnInstant_str, &AuthnInstant_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    lasso_assign_string(this->AuthnInstant, AuthnInstant_str);
}

PHP_FUNCTION(LassoSaml2AuthnStatement_sessionIndex_get)
{
    char* return_c_value;
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    return_c_value = (char*)this->SessionIndex;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnStatement_sessionIndex_set)
{
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SessionIndex_str = NULL;
    int SessionIndex_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SessionIndex_str, &SessionIndex_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    lasso_assign_string(this->SessionIndex, SessionIndex_str);
}

PHP_FUNCTION(LassoSaml2AuthnStatement_sessionNotOnOrAfter_get)
{
    char* return_c_value;
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    return_c_value = (char*)this->SessionNotOnOrAfter;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSaml2AuthnStatement_sessionNotOnOrAfter_set)
{
    LassoSaml2AuthnStatement* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SessionNotOnOrAfter_str = NULL;
    int SessionNotOnOrAfter_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SessionNotOnOrAfter_str, &SessionNotOnOrAfter_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSaml2AuthnStatement*)cvt_this->obj;

    lasso_assign_string(this->SessionNotOnOrAfter, SessionNotOnOrAfter_str);
}

PHP_FUNCTION(LassoSamlp2AuthnQuery_requestedAuthnContext_get)
{
    LassoSamlp2RequestedAuthnContext* return_c_value;
    LassoSamlp2AuthnQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnQuery*)cvt_this->obj;

    return_c_value = (LassoSamlp2RequestedAuthnContext*)this->RequestedAuthnContext;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnQuery_requestedAuthnContext_set)
{
    LassoSamlp2AuthnQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_RequestedAuthnContext = NULL;
    PhpGObjectPtr* cvt_RequestedAuthnContext = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_RequestedAuthnContext) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnQuery*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_RequestedAuthnContext, PhpGObjectPtr*, &zval_RequestedAuthnContext, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->RequestedAuthnContext, cvt_RequestedAuthnContext->obj);
}

PHP_FUNCTION(LassoSamlp2AuthnQuery_sessionIndex_get)
{
    char* return_c_value;
    LassoSamlp2AuthnQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnQuery*)cvt_this->obj;

    return_c_value = (char*)this->SessionIndex;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnQuery_sessionIndex_set)
{
    LassoSamlp2AuthnQuery* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* SessionIndex_str = NULL;
    int SessionIndex_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &SessionIndex_str, &SessionIndex_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnQuery*)cvt_this->obj;

    lasso_assign_string(this->SessionIndex, SessionIndex_str);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_subject_get)
{
    LassoSaml2Subject* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2Subject*)this->Subject;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_subject_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Subject = NULL;
    PhpGObjectPtr* cvt_Subject = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Subject) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Subject, PhpGObjectPtr*, &zval_Subject, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Subject, cvt_Subject->obj);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_nameIdPolicy_get)
{
    LassoSamlp2NameIDPolicy* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (LassoSamlp2NameIDPolicy*)this->NameIDPolicy;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_nameIdPolicy_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_NameIDPolicy = NULL;
    PhpGObjectPtr* cvt_NameIDPolicy = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_NameIDPolicy) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_NameIDPolicy, PhpGObjectPtr*, &zval_NameIDPolicy, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->NameIDPolicy, cvt_NameIDPolicy->obj);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_conditions_get)
{
    LassoSaml2Conditions* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (LassoSaml2Conditions*)this->Conditions;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_conditions_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Conditions = NULL;
    PhpGObjectPtr* cvt_Conditions = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Conditions) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Conditions, PhpGObjectPtr*, &zval_Conditions, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Conditions, cvt_Conditions->obj);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_requestedAuthnContext_get)
{
    LassoSamlp2RequestedAuthnContext* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (LassoSamlp2RequestedAuthnContext*)this->RequestedAuthnContext;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_requestedAuthnContext_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_RequestedAuthnContext = NULL;
    PhpGObjectPtr* cvt_RequestedAuthnContext = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_RequestedAuthnContext) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_RequestedAuthnContext, PhpGObjectPtr*, &zval_RequestedAuthnContext, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->RequestedAuthnContext, cvt_RequestedAuthnContext->obj);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_scoping_get)
{
    LassoSamlp2Scoping* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (LassoSamlp2Scoping*)this->Scoping;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_scoping_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Scoping = NULL;
    PhpGObjectPtr* cvt_Scoping = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Scoping) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Scoping, PhpGObjectPtr*, &zval_Scoping, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Scoping, cvt_Scoping->obj);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_forceAuthn_get)
{
    gboolean return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (gboolean)this->ForceAuthn;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_forceAuthn_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long ForceAuthn;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &ForceAuthn) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    this->ForceAuthn = ForceAuthn;
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_isPassive_get)
{
    gboolean return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (gboolean)this->IsPassive;
    RETVAL_BOOL(return_c_value);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_isPassive_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long IsPassive;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &IsPassive) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    this->IsPassive = IsPassive;
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_protocolBinding_get)
{
    char* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProtocolBinding;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_protocolBinding_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProtocolBinding_str = NULL;
    int ProtocolBinding_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProtocolBinding_str, &ProtocolBinding_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->ProtocolBinding, ProtocolBinding_str);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_get)
{
    int return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (int)this->AssertionConsumerServiceIndex;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long AssertionConsumerServiceIndex;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &AssertionConsumerServiceIndex) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    this->AssertionConsumerServiceIndex = AssertionConsumerServiceIndex;
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_assertionConsumerServiceUrl_get)
{
    char* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->AssertionConsumerServiceURL;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_assertionConsumerServiceUrl_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* AssertionConsumerServiceURL_str = NULL;
    int AssertionConsumerServiceURL_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &AssertionConsumerServiceURL_str, &AssertionConsumerServiceURL_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->AssertionConsumerServiceURL, AssertionConsumerServiceURL_str);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_get)
{
    int return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (int)this->AttributeConsumingServiceIndex;
    RETVAL_LONG(return_c_value);
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    long AttributeConsumingServiceIndex;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rl", &zval_this, &AttributeConsumingServiceIndex) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    this->AttributeConsumingServiceIndex = AttributeConsumingServiceIndex;
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_providerName_get)
{
    char* return_c_value;
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    return_c_value = (char*)this->ProviderName;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSamlp2AuthnRequest_providerName_set)
{
    LassoSamlp2AuthnRequest* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* ProviderName_str = NULL;
    int ProviderName_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &ProviderName_str, &ProviderName_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSamlp2AuthnRequest*)cvt_this->obj;

    lasso_assign_string(this->ProviderName, ProviderName_str);
}

PHP_FUNCTION(LassoSoapBody_any_get)
{
    GList* return_c_value;
    LassoSoapBody* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapBody*)cvt_this->obj;

    return_c_value = (GList*)this->any;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSoapBody_any_set)
{
    LassoSoapBody* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_any;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_any) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapBody*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->any, get_list_from_array_of_objects(zval_any));
}

PHP_FUNCTION(LassoSoapBody_id_get)
{
    gchar* return_c_value;
    LassoSoapBody* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapBody*)cvt_this->obj;

    return_c_value = (gchar*)this->Id;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSoapBody_id_set)
{
    LassoSoapBody* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Id_str = NULL;
    int Id_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Id_str, &Id_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapBody*)cvt_this->obj;

    lasso_assign_string(this->Id, Id_str);
}

PHP_FUNCTION(LassoSoapFault_faultcode_get)
{
    gchar* return_c_value;
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    return_c_value = (gchar*)this->faultcode;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSoapFault_faultcode_set)
{
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* faultcode_str = NULL;
    int faultcode_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &faultcode_str, &faultcode_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    lasso_assign_string(this->faultcode, faultcode_str);
}

PHP_FUNCTION(LassoSoapFault_faultstring_get)
{
    gchar* return_c_value;
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    return_c_value = (gchar*)this->faultstring;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSoapFault_faultstring_set)
{
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* faultstring_str = NULL;
    int faultstring_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &faultstring_str, &faultstring_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    lasso_assign_string(this->faultstring, faultstring_str);
}

PHP_FUNCTION(LassoSoapFault_faultactor_get)
{
    GList* return_c_value;
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    return_c_value = (GList*)this->faultactor;
    set_array_from_list_of_strings((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSoapFault_faultactor_set)
{
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_faultactor;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_faultactor) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    lasso_assign_new_list_of_strings(this->faultactor, get_list_from_array_of_strings(zval_faultactor));
}

PHP_FUNCTION(LassoSoapFault_detail_get)
{
    LassoSoapDetail* return_c_value;
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    return_c_value = (LassoSoapDetail*)this->Detail;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSoapFault_detail_set)
{
    LassoSoapFault* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Detail = NULL;
    PhpGObjectPtr* cvt_Detail = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Detail) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapFault*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Detail, PhpGObjectPtr*, &zval_Detail, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Detail, cvt_Detail->obj);
}

PHP_FUNCTION(LassoSoapHeader_other_get)
{
    GList* return_c_value;
    LassoSoapHeader* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapHeader*)cvt_this->obj;

    return_c_value = (GList*)this->Other;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSoapHeader_other_set)
{
    LassoSoapHeader* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Other;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_Other) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapHeader*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->Other, get_list_from_array_of_objects(zval_Other));
}

PHP_FUNCTION(LassoSoapDetail_any_get)
{
    GList* return_c_value;
    LassoSoapDetail* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapDetail*)cvt_this->obj;

    return_c_value = (GList*)this->any;
    set_array_from_list_of_objects((GList*)return_c_value, &return_value);

}

PHP_FUNCTION(LassoSoapDetail_any_set)
{
    LassoSoapDetail* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_any;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ra", &zval_this, &zval_any) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapDetail*)cvt_this->obj;

    lasso_assign_new_list_of_gobjects(this->any, get_list_from_array_of_objects(zval_any));
}

PHP_FUNCTION(LassoSoapEnvelope_header_get)
{
    LassoSoapHeader* return_c_value;
    LassoSoapEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapEnvelope*)cvt_this->obj;

    return_c_value = (LassoSoapHeader*)this->Header;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSoapEnvelope_header_set)
{
    LassoSoapEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Header = NULL;
    PhpGObjectPtr* cvt_Header = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Header) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapEnvelope*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Header, PhpGObjectPtr*, &zval_Header, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Header, cvt_Header->obj);
}

PHP_FUNCTION(LassoSoapEnvelope_body_get)
{
    LassoSoapBody* return_c_value;
    LassoSoapEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapEnvelope*)cvt_this->obj;

    return_c_value = (LassoSoapBody*)this->Body;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoSoapEnvelope_body_set)
{
    LassoSoapEnvelope* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_Body = NULL;
    PhpGObjectPtr* cvt_Body = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_Body) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoSoapEnvelope*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_Body, PhpGObjectPtr*, &zval_Body, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->Body, cvt_Body->obj);
}

PHP_FUNCTION(lasso_ds_x509_data_get_certificate)
{
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_x509_data) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
    return_c_value =  lasso_ds_x509_data_get_certificate(x509_data);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_ds_x509_data_set_certificate)
{
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;
    char* certificate = NULL;
    char* certificate_str = NULL;
    int certificate_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_x509_data, &certificate_str, &certificate_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
        certificate = certificate_str;
    lasso_ds_x509_data_set_certificate(x509_data, certificate);
}

PHP_FUNCTION(lasso_ds_x509_data_get_subject_name)
{
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_x509_data) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
    return_c_value =  lasso_ds_x509_data_get_subject_name(x509_data);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_ds_x509_data_set_subject_name)
{
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;
    char* subject_name = NULL;
    char* subject_name_str = NULL;
    int subject_name_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_x509_data, &subject_name_str, &subject_name_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
        subject_name = subject_name_str;
    lasso_ds_x509_data_set_subject_name(x509_data, subject_name);
}

PHP_FUNCTION(lasso_ds_x509_data_get_crl)
{
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;
    const char* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_x509_data) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
    return_c_value =  lasso_ds_x509_data_get_crl(x509_data);
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_ds_x509_data_set_crl)
{
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;
    char* crl = NULL;
    char* crl_str = NULL;
    int crl_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs!", &zval_x509_data, &crl_str, &crl_len) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
        crl = crl_str;
    lasso_ds_x509_data_set_crl(x509_data, crl);
}

PHP_FUNCTION(LassoDsKeyValue_rsaKeyValue_get)
{
    LassoDsRsaKeyValue* return_c_value;
    LassoDsKeyValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsKeyValue*)cvt_this->obj;

    return_c_value = (LassoDsRsaKeyValue*)this->RSAKeyValue;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoDsKeyValue_rsaKeyValue_set)
{
    LassoDsKeyValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_RSAKeyValue = NULL;
    PhpGObjectPtr* cvt_RSAKeyValue = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_RSAKeyValue) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsKeyValue*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_RSAKeyValue, PhpGObjectPtr*, &zval_RSAKeyValue, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->RSAKeyValue, cvt_RSAKeyValue->obj);
}

PHP_FUNCTION(lasso_ds_key_value_get_x509_data)
{
    LassoDsKeyValue* key_value = NULL;
    zval* zval_key_value = NULL;
    PhpGObjectPtr* cvt_key_value = NULL;
    LassoDsX509Data* return_c_value;
    G_GNUC_UNUSED PhpGObjectPtr *self;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_key_value) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_key_value, PhpGObjectPtr *, &zval_key_value, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key_value = (LassoDsKeyValue*)cvt_key_value->obj;
    return_c_value =  lasso_ds_key_value_get_x509_data(key_value);
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(lasso_ds_key_value_set_x509_data)
{
    LassoDsKeyValue* key_value = NULL;
    zval* zval_key_value = NULL;
    PhpGObjectPtr* cvt_key_value = NULL;
    LassoDsX509Data* x509_data = NULL;
    zval* zval_x509_data = NULL;
    PhpGObjectPtr* cvt_x509_data = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_key_value, &zval_x509_data) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_key_value, PhpGObjectPtr *, &zval_key_value, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    key_value = (LassoDsKeyValue*)cvt_key_value->obj;
    ZEND_FETCH_RESOURCE(cvt_x509_data, PhpGObjectPtr *, &zval_x509_data, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    x509_data = (LassoDsX509Data*)cvt_x509_data->obj;
    lasso_ds_key_value_set_x509_data(key_value, x509_data);
}

PHP_FUNCTION(LassoDsKeyInfo_keyValue_get)
{
    LassoDsKeyValue* return_c_value;
    LassoDsKeyInfo* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsKeyInfo*)cvt_this->obj;

    return_c_value = (LassoDsKeyValue*)this->KeyValue;
    if (return_c_value) {
        PhpGObjectPtr *self;
        self = PhpGObjectPtr_New(G_OBJECT(return_c_value));
        ZEND_REGISTER_RESOURCE(return_value, self, le_lasso_server);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoDsKeyInfo_keyValue_set)
{
    LassoDsKeyInfo* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    zval* zval_KeyValue = NULL;
    PhpGObjectPtr* cvt_KeyValue = NULL;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rr", &zval_this, &zval_KeyValue) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsKeyInfo*)cvt_this->obj;

    ZEND_FETCH_RESOURCE(cvt_KeyValue, PhpGObjectPtr*, &zval_KeyValue, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    lasso_assign_gobject(this->KeyValue, cvt_KeyValue->obj);
}

PHP_FUNCTION(LassoDsRsaKeyValue_modulus_get)
{
    char* return_c_value;
    LassoDsRsaKeyValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsRsaKeyValue*)cvt_this->obj;

    return_c_value = (char*)this->Modulus;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoDsRsaKeyValue_modulus_set)
{
    LassoDsRsaKeyValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Modulus_str = NULL;
    int Modulus_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Modulus_str, &Modulus_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsRsaKeyValue*)cvt_this->obj;

    lasso_assign_string(this->Modulus, Modulus_str);
}

PHP_FUNCTION(LassoDsRsaKeyValue_exponent_get)
{
    char* return_c_value;
    LassoDsRsaKeyValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "r", &zval_this) == FAILURE) {
        RETURN_FALSE;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsRsaKeyValue*)cvt_this->obj;

    return_c_value = (char*)this->Exponent;
    if (return_c_value) {
        RETVAL_STRING((char*)return_c_value, 1);
    } else {
        RETVAL_NULL();
    }
}

PHP_FUNCTION(LassoDsRsaKeyValue_exponent_set)
{
    LassoDsRsaKeyValue* this;
    zval* zval_this;
    PhpGObjectPtr *cvt_this;
    char* Exponent_str = NULL;
    int Exponent_len = 0;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "rs", &zval_this, &Exponent_str, &Exponent_len) == FAILURE) {
        return;
    }

    ZEND_FETCH_RESOURCE(cvt_this, PhpGObjectPtr *, &zval_this, -1, PHP_LASSO_SERVER_RES_NAME, le_lasso_server);
    this = (LassoDsRsaKeyValue*)cvt_this->obj;

    lasso_assign_string(this->Exponent, Exponent_str);
}

static zend_function_entry lasso_functions[] = {
    PHP_FE(lasso_get_object_typename, NULL)
    PHP_FE(lasso_init, NULL)
    PHP_FE(lasso_shutdown, NULL)
    PHP_FE(strError, NULL)
    PHP_FE(lasso_check_version, NULL)
    PHP_FE(lasso_set_flag, NULL)
    PHP_FE(lasso_key_new_for_signature_from_base64_string, NULL)
    PHP_FE(lasso_key_new_for_signature_from_file, NULL)
    PHP_FE(lasso_identity_new, NULL)
    PHP_FE(lasso_identity_new_from_dump, NULL)
    PHP_FE(lasso_provider_new, NULL)
    PHP_FE(lasso_provider_new_from_buffer, NULL)
    PHP_FE(lasso_provider_new_from_dump, NULL)
    PHP_FE(lasso_defederation_new, NULL)
    PHP_FE(lasso_get_request_type_from_soap_msg, NULL)
    PHP_FE(isLibertyQuery, NULL)
    PHP_FE(lasso_server_new, NULL)
    PHP_FE(lasso_server_new_from_buffers, NULL)
    PHP_FE(lasso_server_new_from_dump, NULL)
    PHP_FE(lasso_logout_new, NULL)
    PHP_FE(lasso_logout_new_from_dump, NULL)
    PHP_FE(lasso_name_identifier_mapping_new, NULL)
    PHP_FE(lasso_session_new, NULL)
    PHP_FE(lasso_session_new_from_dump, NULL)
    PHP_FE(lasso_lecp_new, NULL)
    PHP_FE(lasso_login_new, NULL)
    PHP_FE(lasso_login_new_from_dump, NULL)
    PHP_FE(lasso_federation_new, NULL)
    PHP_FE(lasso_name_registration_new, NULL)
    PHP_FE(lasso_name_registration_new_from_dump, NULL)
    PHP_FE(isSamlQuery, NULL)
    PHP_FE(lasso_saml2_name_id_build_persistent, NULL)
    PHP_FE(lasso_saml2_encrypted_element_build_encrypted_persistent_name_id, NULL)
    PHP_FE(lasso_saml2_name_id_new_with_persistent_format, NULL)
    PHP_FE(lasso_ecp_new, NULL)
    PHP_FE(lasso_name_id_management_new, NULL)
    PHP_FE(lasso_name_id_management_new_from_dump, NULL)
    PHP_FE(lasso_assertion_query_new, NULL)
    PHP_FE(lasso_saml_assertion_new, NULL)
    PHP_FE(lasso_lib_request_authn_context_new, NULL)
    PHP_FE(lasso_lib_authn_request_envelope_new, NULL)
    PHP_FE(lasso_lib_authn_request_envelope_new_full, NULL)
    PHP_FE(lasso_samlp_request_new, NULL)
    PHP_FE(lasso_lib_authn_response_new, NULL)
    PHP_FE(lasso_misc_text_node_new, NULL)
    PHP_FE(lasso_misc_text_node_new_with_string, NULL)
    PHP_FE(lasso_misc_text_node_new_with_xml_node, NULL)
    PHP_FE(lasso_build_unique_id, NULL)
    PHP_FE(lasso_lib_logout_response_new, NULL)
    PHP_FE(lasso_lib_logout_response_new_full, NULL)
    PHP_FE(lasso_lib_authn_context_new, NULL)
    PHP_FE(lasso_samlp_status_new, NULL)
    PHP_FE(lasso_node_new, NULL)
    PHP_FE(lasso_node_new_from_dump, NULL)
    PHP_FE(lasso_node_new_from_soap, NULL)
    PHP_FE(lasso_node_new_from_xmlNode, NULL)
    PHP_FE(lasso_register_dst_service, NULL)
    PHP_FE(lasso_get_prefix_for_dst_service_href, NULL)
    PHP_FE(lasso_register_idwsf2_dst_service, NULL)
    PHP_FE(lasso_get_prefix_for_idwsf2_dst_service_href, NULL)
    PHP_FE(lasso_saml_audience_restriction_condition_new, NULL)
    PHP_FE(lasso_saml_audience_restriction_condition_new_full, NULL)
    PHP_FE(lasso_saml_subject_confirmation_new, NULL)
    PHP_FE(lasso_saml_authentication_statement_new, NULL)
    PHP_FE(lasso_lib_idp_list_new, NULL)
    PHP_FE(lasso_lib_register_name_identifier_response_new, NULL)
    PHP_FE(lasso_lib_register_name_identifier_response_new_full, NULL)
    PHP_FE(lasso_saml_attribute_statement_new, NULL)
    PHP_FE(lasso_saml_subject_locality_new, NULL)
    PHP_FE(lasso_lib_federation_termination_notification_new, NULL)
    PHP_FE(lasso_lib_federation_termination_notification_new_full, NULL)
    PHP_FE(lasso_saml_attribute_value_new, NULL)
    PHP_FE(lasso_lib_scoping_new, NULL)
    PHP_FE(lasso_lib_name_identifier_mapping_response_new, NULL)
    PHP_FE(lasso_lib_name_identifier_mapping_response_new_full, NULL)
    PHP_FE(lasso_samlp_response_new, NULL)
    PHP_FE(lasso_saml_subject_statement_new, NULL)
    PHP_FE(lasso_lib_authn_request_new, NULL)
    PHP_FE(lasso_lib_authn_response_envelope_new, NULL)
    PHP_FE(lasso_saml_attribute_designator_new, NULL)
    PHP_FE(lasso_lib_idp_entries_new, NULL)
    PHP_FE(lasso_lib_subject_new, NULL)
    PHP_FE(lasso_saml_advice_new, NULL)
    PHP_FE(lasso_lib_assertion_new, NULL)
    PHP_FE(lasso_lib_assertion_new_full, NULL)
    PHP_FE(lasso_lib_status_response_new, NULL)
    PHP_FE(lasso_saml_name_identifier_new, NULL)
    PHP_FE(lasso_saml_name_identifier_new_from_xmlNode, NULL)
    PHP_FE(lasso_saml_authority_binding_new, NULL)
    PHP_FE(lasso_saml_subject_new, NULL)
    PHP_FE(lasso_lib_authentication_statement_new, NULL)
    PHP_FE(lasso_lib_authentication_statement_new_full, NULL)
    PHP_FE(lasso_saml_conditions_new, NULL)
    PHP_FE(lasso_lib_logout_request_new, NULL)
    PHP_FE(lasso_lib_logout_request_new_full, NULL)
    PHP_FE(lasso_lib_idp_entry_new, NULL)
    PHP_FE(lasso_lib_register_name_identifier_request_new, NULL)
    PHP_FE(lasso_lib_register_name_identifier_request_new_full, NULL)
    PHP_FE(lasso_saml_attribute_new, NULL)
    PHP_FE(lasso_samlp_status_code_new, NULL)
    PHP_FE(lasso_lib_name_identifier_mapping_request_new, NULL)
    PHP_FE(lasso_lib_name_identifier_mapping_request_new_full, NULL)
    PHP_FE(lasso_saml2_base_idabstract_new, NULL)
    PHP_FE(lasso_samlp2_attribute_query_new, NULL)
    PHP_FE(lasso_samlp2_assertion_id_request_new, NULL)
    PHP_FE(lasso_saml2_condition_abstract_new, NULL)
    PHP_FE(lasso_saml2_attribute_value_new, NULL)
    PHP_FE(lasso_samlp2_name_id_policy_new, NULL)
    PHP_FE(lasso_samlp2_status_code_new, NULL)
    PHP_FE(lasso_samlp2_manage_name_id_response_new, NULL)
    PHP_FE(lasso_samlp2_name_id_mapping_request_new, NULL)
    PHP_FE(lasso_saml2_one_time_use_new, NULL)
    PHP_FE(lasso_saml2_key_info_confirmation_data_new, NULL)
    PHP_FE(lasso_saml2_subject_confirmation_data_new, NULL)
    PHP_FE(lasso_saml2_subject_new, NULL)
    PHP_FE(lasso_saml2_conditions_new, NULL)
    PHP_FE(lasso_samlp2_status_response_new, NULL)
    PHP_FE(lasso_saml2_statement_abstract_new, NULL)
    PHP_FE(lasso_samlp2_artifact_resolve_new, NULL)
    PHP_FE(lasso_saml2_proxy_restriction_new, NULL)
    PHP_FE(lasso_samlp2_manage_name_id_request_new, NULL)
    PHP_FE(lasso_saml2_advice_new, NULL)
    PHP_FE(lasso_samlp2_artifact_response_new, NULL)
    PHP_FE(lasso_saml2_attribute_new, NULL)
    PHP_FE(lasso_samlp2_logout_response_new, NULL)
    PHP_FE(lasso_samlp2_idp_list_new, NULL)
    PHP_FE(lasso_samlp2_status_new, NULL)
    PHP_FE(lasso_saml2_encrypted_element_new, NULL)
    PHP_FE(lasso_saml2_subject_confirmation_new, NULL)
    PHP_FE(lasso_samlp2_idp_entry_new, NULL)
    PHP_FE(lasso_saml2_audience_restriction_new, NULL)
    PHP_FE(lasso_samlp2_requested_authn_context_new, NULL)
    PHP_FE(lasso_samlp2_extensions_new, NULL)
    PHP_FE(lasso_saml2_attribute_statement_new, NULL)
    PHP_FE(lasso_saml2_authz_decision_statement_new, NULL)
    PHP_FE(lasso_saml2_evidence_new, NULL)
    PHP_FE(lasso_saml2_key_info_confirmation_data_type_new, NULL)
    PHP_FE(lasso_samlp2_scoping_new, NULL)
    PHP_FE(lasso_saml2_authn_context_new, NULL)
    PHP_FE(lasso_samlp2_status_detail_new, NULL)
    PHP_FE(lasso_samlp2_authz_decision_query_new, NULL)
    PHP_FE(lasso_saml2_assertion_new, NULL)
    PHP_FE(lasso_samlp2_logout_request_new, NULL)
    PHP_FE(lasso_saml2_name_id_new, NULL)
    PHP_FE(lasso_saml2_name_id_new_with_string, NULL)
    PHP_FE(lasso_samlp2_name_id_mapping_response_new, NULL)
    PHP_FE(lasso_saml2_action_new, NULL)
    PHP_FE(lasso_saml2_action_new_with_string, NULL)
    PHP_FE(lasso_samlp2_response_new, NULL)
    PHP_FE(lasso_saml2_subject_locality_new, NULL)
    PHP_FE(lasso_samlp2_request_abstract_new, NULL)
    PHP_FE(lasso_samlp2_subject_query_abstract_new, NULL)
    PHP_FE(lasso_samlp2_terminate_new, NULL)
    PHP_FE(lasso_saml2_authn_statement_new, NULL)
    PHP_FE(lasso_samlp2_authn_query_new, NULL)
    PHP_FE(lasso_samlp2_authn_request_new, NULL)
    PHP_FE(lasso_soap_body_new, NULL)
    PHP_FE(lasso_soap_body_new_from_message, NULL)
    PHP_FE(lasso_soap_fault_new, NULL)
    PHP_FE(lasso_soap_fault_new_from_message, NULL)
    PHP_FE(lasso_soap_fault_new_full, NULL)
    PHP_FE(lasso_soap_header_new, NULL)
    PHP_FE(lasso_soap_header_new_from_message, NULL)
    PHP_FE(lasso_soap_detail_new, NULL)
    PHP_FE(lasso_soap_detail_new_from_message, NULL)
    PHP_FE(lasso_soap_envelope_new, NULL)
    PHP_FE(lasso_soap_envelope_new_from_message, NULL)
    PHP_FE(lasso_ds_x509_data_new, NULL)
    PHP_FE(lasso_ds_key_value_new, NULL)
    PHP_FE(lasso_ds_key_info_new, NULL)
    PHP_FE(lasso_ds_rsa_key_value_new, NULL)
    PHP_FE(lasso_node_cleanup_original_xmlnodes, NULL)
    PHP_FE(lasso_node_dump, NULL)
    PHP_FE(lasso_node_export_to_base64, NULL)
    PHP_FE(lasso_node_export_to_query, NULL)
    PHP_FE(lasso_node_export_to_query_with_password, NULL)
    PHP_FE(lasso_node_export_to_soap, NULL)
    PHP_FE(lasso_node_export_to_xml, NULL)
    PHP_FE(lasso_node_export_to_paos_request, NULL)
    PHP_FE(lasso_node_export_to_ecp_soap_response, NULL)
    PHP_FE(lasso_node_get_xmlNode, NULL)
    PHP_FE(lasso_node_get_original_xmlnode, NULL)
    PHP_FE(lasso_node_set_original_xmlnode, NULL)
    PHP_FE(lasso_node_set_custom_namespace, NULL)
    PHP_FE(lasso_node_set_custom_nodename, NULL)
    PHP_FE(lasso_node_get_name, NULL)
    PHP_FE(lasso_node_get_namespace, NULL)
    PHP_FE(lasso_node_init_from_message, NULL)
    PHP_FE(lasso_node_init_from_query, NULL)
    PHP_FE(lasso_node_init_from_xml, NULL)
    PHP_FE(lasso_node_debug, NULL)
    PHP_FE(lasso_key_query_verify, NULL)
    PHP_FE(lasso_key_query_sign, NULL)
    PHP_FE(lasso_key_saml2_xml_verify, NULL)
    PHP_FE(lasso_key_saml2_xml_sign, NULL)
    PHP_FE(LassoIdentity_federations_get, NULL)
    PHP_FE(LassoIdentity_federations_set, NULL)
    PHP_FE(LassoIdentity_isDirty_get, NULL)
    PHP_FE(LassoIdentity_isDirty_set, NULL)
    PHP_FE(lasso_identity_get_federation, NULL)
    PHP_FE(lasso_identity_dump, NULL)
    PHP_FE(LassoProvider_providerId_get, NULL)
    PHP_FE(LassoProvider_providerId_set, NULL)
    PHP_FE(LassoProvider_role_get, NULL)
    PHP_FE(LassoProvider_role_set, NULL)
    PHP_FE(LassoProvider_metadataFilename_get, NULL)
    PHP_FE(LassoProvider_metadataFilename_set, NULL)
    PHP_FE(LassoProvider_publicKey_get, NULL)
    PHP_FE(LassoProvider_publicKey_set, NULL)
    PHP_FE(LassoProvider_caCertChain_get, NULL)
    PHP_FE(LassoProvider_caCertChain_set, NULL)
    PHP_FE(lasso_provider_get_assertion_consumer_service_url, NULL)
    PHP_FE(lasso_provider_get_metadata_one, NULL)
    PHP_FE(lasso_provider_get_metadata_list, NULL)
    PHP_FE(lasso_provider_get_first_http_method, NULL)
    PHP_FE(lasso_provider_accept_http_method, NULL)
    PHP_FE(lasso_provider_has_protocol_profile, NULL)
    PHP_FE(lasso_provider_get_base64_succinct_id, NULL)
    PHP_FE(lasso_provider_get_organization, NULL)
    PHP_FE(lasso_provider_get_protocol_conformance, NULL)
    PHP_FE(lasso_provider_set_encryption_mode, NULL)
    PHP_FE(lasso_provider_get_encryption_mode, NULL)
    PHP_FE(lasso_provider_set_encryption_sym_key_type, NULL)
    PHP_FE(lasso_provider_get_default_name_id_format, NULL)
    PHP_FE(lasso_provider_get_sp_name_qualifier, NULL)
    PHP_FE(lasso_provider_verify_single_node_signature, NULL)
    PHP_FE(lasso_provider_get_idp_supported_attributes, NULL)
    PHP_FE(lasso_provider_get_valid_until, NULL)
    PHP_FE(lasso_provider_get_cache_duration, NULL)
    PHP_FE(lasso_provider_get_metadata_one_for_role, NULL)
    PHP_FE(lasso_provider_get_metadata_list_for_role, NULL)
    PHP_FE(lasso_provider_get_metadata_keys_for_role, NULL)
    PHP_FE(lasso_provider_get_roles, NULL)
    PHP_FE(lasso_provider_match_conformance, NULL)
    PHP_FE(lasso_provider_set_server_signing_key, NULL)
    PHP_FE(lasso_provider_add_key, NULL)
    PHP_FE(lasso_provider_verify_signature, NULL)
    PHP_FE(lasso_provider_saml2_node_encrypt, NULL)
    PHP_FE(LassoProfile_server_get, NULL)
    PHP_FE(LassoProfile_server_set, NULL)
    PHP_FE(LassoProfile_request_get, NULL)
    PHP_FE(LassoProfile_request_set, NULL)
    PHP_FE(LassoProfile_response_get, NULL)
    PHP_FE(LassoProfile_response_set, NULL)
    PHP_FE(LassoProfile_nameIdentifier_get, NULL)
    PHP_FE(LassoProfile_nameIdentifier_set, NULL)
    PHP_FE(LassoProfile_remoteProviderId_get, NULL)
    PHP_FE(LassoProfile_remoteProviderId_set, NULL)
    PHP_FE(LassoProfile_msgUrl_get, NULL)
    PHP_FE(LassoProfile_msgUrl_set, NULL)
    PHP_FE(LassoProfile_msgBody_get, NULL)
    PHP_FE(LassoProfile_msgBody_set, NULL)
    PHP_FE(LassoProfile_msgRelayState_get, NULL)
    PHP_FE(LassoProfile_msgRelayState_set, NULL)
    PHP_FE(lasso_profile_get_identity, NULL)
    PHP_FE(lasso_profile_get_session, NULL)
    PHP_FE(lasso_profile_has_dirty_identity, NULL)
    PHP_FE(lasso_profile_has_dirty_session, NULL)
    PHP_FE(lasso_profile_set_identity_from_dump, NULL)
    PHP_FE(lasso_profile_set_session_from_dump, NULL)
    PHP_FE(lasso_profile_get_federation_nameIdentifier, NULL)
    PHP_FE(lasso_profile_get_artifact, NULL)
    PHP_FE(lasso_profile_get_artifact_message, NULL)
    PHP_FE(lasso_profile_set_artifact_message, NULL)
    PHP_FE(lasso_profile_set_signature_hint, NULL)
    PHP_FE(lasso_profile_get_signature_hint, NULL)
    PHP_FE(lasso_profile_set_soap_fault_response, NULL)
    PHP_FE(lasso_profile_set_signature_verify_hint, NULL)
    PHP_FE(lasso_profile_get_signature_verify_hint, NULL)
    PHP_FE(lasso_profile_sso_role_with, NULL)
    PHP_FE(lasso_profile_get_signature_status, NULL)
    PHP_FE(lasso_defederation_build_notification_msg, NULL)
    PHP_FE(lasso_defederation_init_notification, NULL)
    PHP_FE(lasso_defederation_process_notification_msg, NULL)
    PHP_FE(lasso_defederation_validate_notification, NULL)
    PHP_FE(LassoServer_providers_get, NULL)
    PHP_FE(LassoServer_providers_set, NULL)
    PHP_FE(LassoServer_privateKey_get, NULL)
    PHP_FE(LassoServer_privateKey_set, NULL)
    PHP_FE(LassoServer_privateKeyPassword_get, NULL)
    PHP_FE(LassoServer_privateKeyPassword_set, NULL)
    PHP_FE(LassoServer_certificate_get, NULL)
    PHP_FE(LassoServer_certificate_set, NULL)
    PHP_FE(LassoServer_signatureMethod_get, NULL)
    PHP_FE(LassoServer_signatureMethod_set, NULL)
    PHP_FE(lasso_server_add_provider, NULL)
    PHP_FE(lasso_server_add_provider_from_buffer, NULL)
    PHP_FE(lasso_server_dump, NULL)
    PHP_FE(lasso_server_get_provider, NULL)
    PHP_FE(lasso_server_set_encryption_private_key, NULL)
    PHP_FE(lasso_server_load_affiliation, NULL)
    PHP_FE(lasso_server_set_encryption_private_key_with_password, NULL)
    PHP_FE(lasso_server_load_metadata, NULL)
    PHP_FE(lasso_server_add_provider2, NULL)
    PHP_FE(lasso_server_saml2_assertion_setup_signature, NULL)
    PHP_FE(lasso_logout_build_request_msg, NULL)
    PHP_FE(lasso_logout_build_response_msg, NULL)
    PHP_FE(lasso_logout_dump, NULL)
    PHP_FE(lasso_logout_get_next_providerID, NULL)
    PHP_FE(lasso_logout_init_request, NULL)
    PHP_FE(lasso_logout_process_request_msg, NULL)
    PHP_FE(lasso_logout_process_response_msg, NULL)
    PHP_FE(lasso_logout_reset_providerID_index, NULL)
    PHP_FE(lasso_logout_validate_request, NULL)
    PHP_FE(LassoNameIdentifierMapping_targetNameIdentifier_get, NULL)
    PHP_FE(LassoNameIdentifierMapping_targetNameIdentifier_set, NULL)
    PHP_FE(lasso_name_identifier_mapping_build_request_msg, NULL)
    PHP_FE(lasso_name_identifier_mapping_build_response_msg, NULL)
    PHP_FE(lasso_name_identifier_mapping_init_request, NULL)
    PHP_FE(lasso_name_identifier_mapping_process_request_msg, NULL)
    PHP_FE(lasso_name_identifier_mapping_process_response_msg, NULL)
    PHP_FE(lasso_name_identifier_mapping_validate_request, NULL)
    PHP_FE(LassoSession_assertions_get, NULL)
    PHP_FE(LassoSession_assertions_set, NULL)
    PHP_FE(LassoSession_isDirty_get, NULL)
    PHP_FE(LassoSession_isDirty_set, NULL)
    PHP_FE(lasso_session_dump, NULL)
    PHP_FE(lasso_session_get_assertions, NULL)
    PHP_FE(lasso_session_get_provider_index, NULL)
    PHP_FE(lasso_session_is_empty, NULL)
    PHP_FE(lasso_session_remove_assertion, NULL)
    PHP_FE(lasso_session_get_assertion, NULL)
    PHP_FE(lasso_session_add_assertion, NULL)
    PHP_FE(lasso_session_get_name_ids, NULL)
    PHP_FE(lasso_session_get_session_indexes, NULL)
    PHP_FE(lasso_session_get_assertion_ids, NULL)
    PHP_FE(LassoLogin_protocolProfile_get, NULL)
    PHP_FE(LassoLogin_protocolProfile_set, NULL)
    PHP_FE(LassoLogin_assertionArtifact_get, NULL)
    PHP_FE(LassoLogin_assertionArtifact_set, NULL)
    PHP_FE(lasso_login_accept_sso, NULL)
    PHP_FE(lasso_login_build_artifact_msg, NULL)
    PHP_FE(lasso_login_build_assertion, NULL)
    PHP_FE(lasso_login_build_authn_request_msg, NULL)
    PHP_FE(lasso_login_build_authn_response_msg, NULL)
    PHP_FE(lasso_login_build_request_msg, NULL)
    PHP_FE(lasso_login_build_response_msg, NULL)
    PHP_FE(lasso_login_dump, NULL)
    PHP_FE(lasso_login_init_authn_request, NULL)
    PHP_FE(lasso_login_init_request, NULL)
    PHP_FE(lasso_login_init_idp_initiated_authn_request, NULL)
    PHP_FE(lasso_login_must_ask_for_consent, NULL)
    PHP_FE(lasso_login_must_authenticate, NULL)
    PHP_FE(lasso_login_process_authn_request_msg, NULL)
    PHP_FE(lasso_login_process_authn_response_msg, NULL)
    PHP_FE(lasso_login_process_request_msg, NULL)
    PHP_FE(lasso_login_process_response_msg, NULL)
    PHP_FE(lasso_login_validate_request_msg, NULL)
    PHP_FE(lasso_login_process_paos_response_msg, NULL)
    PHP_FE(lasso_login_get_assertion, NULL)
    PHP_FE(LassoLecp_authnRequestEnvelope_get, NULL)
    PHP_FE(LassoLecp_authnRequestEnvelope_set, NULL)
    PHP_FE(LassoLecp_authnResponseEnvelope_get, NULL)
    PHP_FE(LassoLecp_authnResponseEnvelope_set, NULL)
    PHP_FE(LassoLecp_assertionConsumerServiceURL_get, NULL)
    PHP_FE(LassoLecp_assertionConsumerServiceURL_set, NULL)
    PHP_FE(lasso_lecp_build_authn_request_envelope_msg, NULL)
    PHP_FE(lasso_lecp_build_authn_request_msg, NULL)
    PHP_FE(lasso_lecp_build_authn_response_msg, NULL)
    PHP_FE(lasso_lecp_build_authn_response_envelope_msg, NULL)
    PHP_FE(lasso_lecp_init_authn_request, NULL)
    PHP_FE(lasso_lecp_process_authn_request_msg, NULL)
    PHP_FE(lasso_lecp_process_authn_request_envelope_msg, NULL)
    PHP_FE(lasso_lecp_process_authn_response_envelope_msg, NULL)
    PHP_FE(LassoFederation_remoteProviderId_get, NULL)
    PHP_FE(LassoFederation_remoteProviderId_set, NULL)
    PHP_FE(LassoFederation_localNameIdentifier_get, NULL)
    PHP_FE(LassoFederation_localNameIdentifier_set, NULL)
    PHP_FE(LassoFederation_remoteNameIdentifier_get, NULL)
    PHP_FE(LassoFederation_remoteNameIdentifier_set, NULL)
    PHP_FE(lasso_federation_build_local_name_identifier, NULL)
    PHP_FE(lasso_federation_verify_name_identifier, NULL)
    PHP_FE(LassoNameRegistration_oldNameIdentifier_get, NULL)
    PHP_FE(LassoNameRegistration_oldNameIdentifier_set, NULL)
    PHP_FE(lasso_name_registration_build_request_msg, NULL)
    PHP_FE(lasso_name_registration_build_response_msg, NULL)
    PHP_FE(lasso_name_registration_dump, NULL)
    PHP_FE(lasso_name_registration_init_request, NULL)
    PHP_FE(lasso_name_registration_process_request_msg, NULL)
    PHP_FE(lasso_name_registration_process_response_msg, NULL)
    PHP_FE(lasso_name_registration_validate_request, NULL)
    PHP_FE(LassoEcp_assertionConsumerURL_get, NULL)
    PHP_FE(LassoEcp_assertionConsumerURL_set, NULL)
    PHP_FE(lasso_ecp_process_authn_request_msg, NULL)
    PHP_FE(lasso_ecp_process_response_msg, NULL)
    PHP_FE(lasso_name_id_management_dump, NULL)
    PHP_FE(lasso_name_id_management_init_request, NULL)
    PHP_FE(lasso_name_id_management_build_request_msg, NULL)
    PHP_FE(lasso_name_id_management_process_request_msg, NULL)
    PHP_FE(lasso_name_id_management_validate_request, NULL)
    PHP_FE(lasso_name_id_management_build_response_msg, NULL)
    PHP_FE(lasso_name_id_management_process_response_msg, NULL)
    PHP_FE(lasso_assertion_query_init_request, NULL)
    PHP_FE(lasso_assertion_query_validate_request, NULL)
    PHP_FE(lasso_assertion_query_build_request_msg, NULL)
    PHP_FE(lasso_assertion_query_process_request_msg, NULL)
    PHP_FE(lasso_assertion_query_build_response_msg, NULL)
    PHP_FE(lasso_assertion_query_process_response_msg, NULL)
    PHP_FE(lasso_assertion_query_add_attribute_request, NULL)
    PHP_FE(lasso_assertion_query_get_request_type, NULL)
    PHP_FE(LassoSamlAssertion_conditions_get, NULL)
    PHP_FE(LassoSamlAssertion_conditions_set, NULL)
    PHP_FE(LassoSamlAssertion_advice_get, NULL)
    PHP_FE(LassoSamlAssertion_advice_set, NULL)
    PHP_FE(LassoSamlAssertion_subjectStatement_get, NULL)
    PHP_FE(LassoSamlAssertion_subjectStatement_set, NULL)
    PHP_FE(LassoSamlAssertion_authenticationStatement_get, NULL)
    PHP_FE(LassoSamlAssertion_authenticationStatement_set, NULL)
    PHP_FE(LassoSamlAssertion_attributeStatement_get, NULL)
    PHP_FE(LassoSamlAssertion_attributeStatement_set, NULL)
    PHP_FE(LassoSamlAssertion_majorVersion_get, NULL)
    PHP_FE(LassoSamlAssertion_majorVersion_set, NULL)
    PHP_FE(LassoSamlAssertion_minorVersion_get, NULL)
    PHP_FE(LassoSamlAssertion_minorVersion_set, NULL)
    PHP_FE(LassoSamlAssertion_assertionId_get, NULL)
    PHP_FE(LassoSamlAssertion_assertionId_set, NULL)
    PHP_FE(LassoSamlAssertion_issuer_get, NULL)
    PHP_FE(LassoSamlAssertion_issuer_set, NULL)
    PHP_FE(LassoSamlAssertion_issueInstant_get, NULL)
    PHP_FE(LassoSamlAssertion_issueInstant_set, NULL)
    PHP_FE(LassoSamlAssertion_signType_get, NULL)
    PHP_FE(LassoSamlAssertion_signType_set, NULL)
    PHP_FE(LassoSamlAssertion_signMethod_get, NULL)
    PHP_FE(LassoSamlAssertion_signMethod_set, NULL)
    PHP_FE(LassoSamlAssertion_privateKeyFile_get, NULL)
    PHP_FE(LassoSamlAssertion_privateKeyFile_set, NULL)
    PHP_FE(LassoSamlAssertion_certificateFile_get, NULL)
    PHP_FE(LassoSamlAssertion_certificateFile_set, NULL)
    PHP_FE(LassoLibRequestAuthnContext_authnContextClassRef_get, NULL)
    PHP_FE(LassoLibRequestAuthnContext_authnContextClassRef_set, NULL)
    PHP_FE(LassoLibRequestAuthnContext_authnContextStatementRef_get, NULL)
    PHP_FE(LassoLibRequestAuthnContext_authnContextStatementRef_set, NULL)
    PHP_FE(LassoLibRequestAuthnContext_authnContextComparison_get, NULL)
    PHP_FE(LassoLibRequestAuthnContext_authnContextComparison_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_extension_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_extension_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_authnRequest_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_authnRequest_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_providerId_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_providerId_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_providerName_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_providerName_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_assertionConsumerServiceUrl_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_assertionConsumerServiceUrl_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_idpList_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_idpList_set, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_isPassive_get, NULL)
    PHP_FE(LassoLibAuthnRequestEnvelope_isPassive_set, NULL)
    PHP_FE(LassoMiscTextNode_content_get, NULL)
    PHP_FE(LassoMiscTextNode_content_set, NULL)
    PHP_FE(LassoMiscTextNode_name_get, NULL)
    PHP_FE(LassoMiscTextNode_name_set, NULL)
    PHP_FE(LassoMiscTextNode_nsHref_get, NULL)
    PHP_FE(LassoMiscTextNode_nsHref_set, NULL)
    PHP_FE(LassoMiscTextNode_nsPrefix_get, NULL)
    PHP_FE(LassoMiscTextNode_nsPrefix_set, NULL)
    PHP_FE(LassoMiscTextNode_textChild_get, NULL)
    PHP_FE(LassoMiscTextNode_textChild_set, NULL)
    PHP_FE(lasso_misc_text_node_set_xml_content, NULL)
    PHP_FE(lasso_misc_text_node_get_xml_content, NULL)
    PHP_FE(LassoLibAuthnContext_authnContextClassRef_get, NULL)
    PHP_FE(LassoLibAuthnContext_authnContextClassRef_set, NULL)
    PHP_FE(LassoLibAuthnContext_authnContextStatementRef_get, NULL)
    PHP_FE(LassoLibAuthnContext_authnContextStatementRef_set, NULL)
    PHP_FE(LassoSamlpStatus_statusCode_get, NULL)
    PHP_FE(LassoSamlpStatus_statusCode_set, NULL)
    PHP_FE(LassoSamlpStatus_statusMessage_get, NULL)
    PHP_FE(LassoSamlpStatus_statusMessage_set, NULL)
    PHP_FE(LassoSamlSubjectConfirmation_confirmationMethod_get, NULL)
    PHP_FE(LassoSamlSubjectConfirmation_confirmationMethod_set, NULL)
    PHP_FE(LassoSamlSubjectConfirmation_subjectConfirmationData_get, NULL)
    PHP_FE(LassoSamlSubjectConfirmation_subjectConfirmationData_set, NULL)
    PHP_FE(LassoSamlSubjectConfirmation_keyInfo_get, NULL)
    PHP_FE(LassoSamlSubjectConfirmation_keyInfo_set, NULL)
    PHP_FE(LassoLibIDPList_idpEntries_get, NULL)
    PHP_FE(LassoLibIDPList_idpEntries_set, NULL)
    PHP_FE(LassoLibIDPList_getComplete_get, NULL)
    PHP_FE(LassoLibIDPList_getComplete_set, NULL)
    PHP_FE(LassoSamlSubjectLocality_ipAddress_get, NULL)
    PHP_FE(LassoSamlSubjectLocality_ipAddress_set, NULL)
    PHP_FE(LassoSamlSubjectLocality_dnsAddress_get, NULL)
    PHP_FE(LassoSamlSubjectLocality_dnsAddress_set, NULL)
    PHP_FE(LassoSamlAttributeValue_any_get, NULL)
    PHP_FE(LassoSamlAttributeValue_any_set, NULL)
    PHP_FE(LassoSamlAudienceRestrictionCondition_audience_get, NULL)
    PHP_FE(LassoSamlAudienceRestrictionCondition_audience_set, NULL)
    PHP_FE(LassoLibScoping_proxyCount_get, NULL)
    PHP_FE(LassoLibScoping_proxyCount_set, NULL)
    PHP_FE(LassoLibScoping_idpList_get, NULL)
    PHP_FE(LassoLibScoping_idpList_set, NULL)
    PHP_FE(LassoLibAuthnResponseEnvelope_extension_get, NULL)
    PHP_FE(LassoLibAuthnResponseEnvelope_extension_set, NULL)
    PHP_FE(LassoLibAuthnResponseEnvelope_authnResponse_get, NULL)
    PHP_FE(LassoLibAuthnResponseEnvelope_authnResponse_set, NULL)
    PHP_FE(LassoLibAuthnResponseEnvelope_assertionConsumerServiceUrl_get, NULL)
    PHP_FE(LassoLibAuthnResponseEnvelope_assertionConsumerServiceUrl_set, NULL)
    PHP_FE(LassoSamlAttributeDesignator_attributeName_get, NULL)
    PHP_FE(LassoSamlAttributeDesignator_attributeName_set, NULL)
    PHP_FE(LassoSamlAttributeDesignator_attributeNamespace_get, NULL)
    PHP_FE(LassoSamlAttributeDesignator_attributeNamespace_set, NULL)
    PHP_FE(LassoLibIDPEntries_idpEntry_get, NULL)
    PHP_FE(LassoLibIDPEntries_idpEntry_set, NULL)
    PHP_FE(LassoSamlAdvice_assertionIdReference_get, NULL)
    PHP_FE(LassoSamlAdvice_assertionIdReference_set, NULL)
    PHP_FE(LassoSamlAdvice_assertion_get, NULL)
    PHP_FE(LassoSamlAdvice_assertion_set, NULL)
    PHP_FE(LassoLibAssertion_inResponseTo_get, NULL)
    PHP_FE(LassoLibAssertion_inResponseTo_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_responseId_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_responseId_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_inResponseTo_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_inResponseTo_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_majorVersion_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_majorVersion_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_minorVersion_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_minorVersion_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_issueInstant_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_issueInstant_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_recipient_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_recipient_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_signType_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_signType_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_signMethod_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_signMethod_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_privateKeyFile_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_privateKeyFile_set, NULL)
    PHP_FE(LassoSamlpResponseAbstract_certificateFile_get, NULL)
    PHP_FE(LassoSamlpResponseAbstract_certificateFile_set, NULL)
    PHP_FE(lasso_samlp_response_abstract_fill, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_extension_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_extension_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_providerId_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_providerId_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_status_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_status_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_nameIdentifier_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingResponse_nameIdentifier_set, NULL)
    PHP_FE(LassoSamlpResponse_status_get, NULL)
    PHP_FE(LassoSamlpResponse_status_set, NULL)
    PHP_FE(LassoSamlpResponse_assertion_get, NULL)
    PHP_FE(LassoSamlpResponse_assertion_set, NULL)
    PHP_FE(LassoLibAuthnResponse_extension_get, NULL)
    PHP_FE(LassoLibAuthnResponse_extension_set, NULL)
    PHP_FE(LassoLibAuthnResponse_providerId_get, NULL)
    PHP_FE(LassoLibAuthnResponse_providerId_set, NULL)
    PHP_FE(LassoLibAuthnResponse_relayState_get, NULL)
    PHP_FE(LassoLibAuthnResponse_relayState_set, NULL)
    PHP_FE(LassoLibAuthnResponse_consent_get, NULL)
    PHP_FE(LassoLibAuthnResponse_consent_set, NULL)
    PHP_FE(LassoLibStatusResponse_extension_get, NULL)
    PHP_FE(LassoLibStatusResponse_extension_set, NULL)
    PHP_FE(LassoLibStatusResponse_providerId_get, NULL)
    PHP_FE(LassoLibStatusResponse_providerId_set, NULL)
    PHP_FE(LassoLibStatusResponse_status_get, NULL)
    PHP_FE(LassoLibStatusResponse_status_set, NULL)
    PHP_FE(LassoLibStatusResponse_relayState_get, NULL)
    PHP_FE(LassoLibStatusResponse_relayState_set, NULL)
    PHP_FE(LassoSamlSubjectStatementAbstract_subject_get, NULL)
    PHP_FE(LassoSamlSubjectStatementAbstract_subject_set, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_subjectLocality_get, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_subjectLocality_set, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_authorityBinding_get, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_authorityBinding_set, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_authenticationMethod_get, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_authenticationMethod_set, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_authenticationInstant_get, NULL)
    PHP_FE(LassoSamlAuthenticationStatement_authenticationInstant_set, NULL)
    PHP_FE(LassoSamlAttributeStatement_attribute_get, NULL)
    PHP_FE(LassoSamlAttributeStatement_attribute_set, NULL)
    PHP_FE(LassoSamlNameIdentifier_nameQualifier_get, NULL)
    PHP_FE(LassoSamlNameIdentifier_nameQualifier_set, NULL)
    PHP_FE(LassoSamlNameIdentifier_format_get, NULL)
    PHP_FE(LassoSamlNameIdentifier_format_set, NULL)
    PHP_FE(LassoSamlNameIdentifier_content_get, NULL)
    PHP_FE(LassoSamlNameIdentifier_content_set, NULL)
    PHP_FE(lasso_saml_name_identifier_equals, NULL)
    PHP_FE(LassoSamlAuthorityBinding_authorityKind_get, NULL)
    PHP_FE(LassoSamlAuthorityBinding_authorityKind_set, NULL)
    PHP_FE(LassoSamlAuthorityBinding_location_get, NULL)
    PHP_FE(LassoSamlAuthorityBinding_location_set, NULL)
    PHP_FE(LassoSamlAuthorityBinding_binding_get, NULL)
    PHP_FE(LassoSamlAuthorityBinding_binding_set, NULL)
    PHP_FE(LassoSamlSubject_nameIdentifier_get, NULL)
    PHP_FE(LassoSamlSubject_nameIdentifier_set, NULL)
    PHP_FE(LassoSamlSubject_subjectConfirmation_get, NULL)
    PHP_FE(LassoSamlSubject_subjectConfirmation_set, NULL)
    PHP_FE(LassoSamlSubject_encryptedNameIdentifier_get, NULL)
    PHP_FE(LassoSamlSubject_encryptedNameIdentifier_set, NULL)
    PHP_FE(LassoLibSubject_idpProvidedNameIdentifier_get, NULL)
    PHP_FE(LassoLibSubject_idpProvidedNameIdentifier_set, NULL)
    PHP_FE(LassoLibAuthenticationStatement_authnContext_get, NULL)
    PHP_FE(LassoLibAuthenticationStatement_authnContext_set, NULL)
    PHP_FE(LassoLibAuthenticationStatement_reauthenticateOnOrAfter_get, NULL)
    PHP_FE(LassoLibAuthenticationStatement_reauthenticateOnOrAfter_set, NULL)
    PHP_FE(LassoLibAuthenticationStatement_sessionIndex_get, NULL)
    PHP_FE(LassoLibAuthenticationStatement_sessionIndex_set, NULL)
    PHP_FE(LassoSamlConditions_condition_get, NULL)
    PHP_FE(LassoSamlConditions_condition_set, NULL)
    PHP_FE(LassoSamlConditions_audienceRestrictionCondition_get, NULL)
    PHP_FE(LassoSamlConditions_audienceRestrictionCondition_set, NULL)
    PHP_FE(LassoSamlConditions_notBefore_get, NULL)
    PHP_FE(LassoSamlConditions_notBefore_set, NULL)
    PHP_FE(LassoSamlConditions_notOnOrAfter_get, NULL)
    PHP_FE(LassoSamlConditions_notOnOrAfter_set, NULL)
    PHP_FE(LassoLibIDPEntry_providerId_get, NULL)
    PHP_FE(LassoLibIDPEntry_providerId_set, NULL)
    PHP_FE(LassoLibIDPEntry_providerName_get, NULL)
    PHP_FE(LassoLibIDPEntry_providerName_set, NULL)
    PHP_FE(LassoLibIDPEntry_loc_get, NULL)
    PHP_FE(LassoLibIDPEntry_loc_set, NULL)
    PHP_FE(LassoSamlAttribute_attributeName_get, NULL)
    PHP_FE(LassoSamlAttribute_attributeName_set, NULL)
    PHP_FE(LassoSamlAttribute_attributeNameSpace_get, NULL)
    PHP_FE(LassoSamlAttribute_attributeNameSpace_set, NULL)
    PHP_FE(LassoSamlAttribute_attributeValue_get, NULL)
    PHP_FE(LassoSamlAttribute_attributeValue_set, NULL)
    PHP_FE(LassoSamlpStatusCode_statusCode_get, NULL)
    PHP_FE(LassoSamlpStatusCode_statusCode_set, NULL)
    PHP_FE(LassoSamlpStatusCode_value_get, NULL)
    PHP_FE(LassoSamlpStatusCode_value_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_respondWith_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_respondWith_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_requestId_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_requestId_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_majorVersion_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_majorVersion_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_minorVersion_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_minorVersion_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_issueInstant_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_issueInstant_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_signType_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_signType_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_signMethod_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_signMethod_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_privateKeyFile_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_privateKeyFile_set, NULL)
    PHP_FE(LassoSamlpRequestAbstract_certificateFile_get, NULL)
    PHP_FE(LassoSamlpRequestAbstract_certificateFile_set, NULL)
    PHP_FE(LassoSamlpRequest_assertionArtifact_get, NULL)
    PHP_FE(LassoSamlpRequest_assertionArtifact_set, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_extension_get, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_extension_set, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_providerId_get, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_providerId_set, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_nameIdentifier_get, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_nameIdentifier_set, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_consent_get, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_consent_set, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_relayState_get, NULL)
    PHP_FE(LassoLibFederationTerminationNotification_relayState_set, NULL)
    PHP_FE(LassoLibAuthnRequest_extension_get, NULL)
    PHP_FE(LassoLibAuthnRequest_extension_set, NULL)
    PHP_FE(LassoLibAuthnRequest_providerId_get, NULL)
    PHP_FE(LassoLibAuthnRequest_providerId_set, NULL)
    PHP_FE(LassoLibAuthnRequest_affiliationId_get, NULL)
    PHP_FE(LassoLibAuthnRequest_affiliationId_set, NULL)
    PHP_FE(LassoLibAuthnRequest_nameIdPolicy_get, NULL)
    PHP_FE(LassoLibAuthnRequest_nameIdPolicy_set, NULL)
    PHP_FE(LassoLibAuthnRequest_forceAuthn_get, NULL)
    PHP_FE(LassoLibAuthnRequest_forceAuthn_set, NULL)
    PHP_FE(LassoLibAuthnRequest_isPassive_get, NULL)
    PHP_FE(LassoLibAuthnRequest_isPassive_set, NULL)
    PHP_FE(LassoLibAuthnRequest_protocolProfile_get, NULL)
    PHP_FE(LassoLibAuthnRequest_protocolProfile_set, NULL)
    PHP_FE(LassoLibAuthnRequest_assertionConsumerServiceId_get, NULL)
    PHP_FE(LassoLibAuthnRequest_assertionConsumerServiceId_set, NULL)
    PHP_FE(LassoLibAuthnRequest_requestAuthnContext_get, NULL)
    PHP_FE(LassoLibAuthnRequest_requestAuthnContext_set, NULL)
    PHP_FE(LassoLibAuthnRequest_relayState_get, NULL)
    PHP_FE(LassoLibAuthnRequest_relayState_set, NULL)
    PHP_FE(LassoLibAuthnRequest_scoping_get, NULL)
    PHP_FE(LassoLibAuthnRequest_scoping_set, NULL)
    PHP_FE(LassoLibAuthnRequest_consent_get, NULL)
    PHP_FE(LassoLibAuthnRequest_consent_set, NULL)
    PHP_FE(LassoLibLogoutRequest_extension_get, NULL)
    PHP_FE(LassoLibLogoutRequest_extension_set, NULL)
    PHP_FE(LassoLibLogoutRequest_providerId_get, NULL)
    PHP_FE(LassoLibLogoutRequest_providerId_set, NULL)
    PHP_FE(LassoLibLogoutRequest_nameIdentifier_get, NULL)
    PHP_FE(LassoLibLogoutRequest_nameIdentifier_set, NULL)
    PHP_FE(LassoLibLogoutRequest_sessionIndex_get, NULL)
    PHP_FE(LassoLibLogoutRequest_sessionIndex_set, NULL)
    PHP_FE(LassoLibLogoutRequest_relayState_get, NULL)
    PHP_FE(LassoLibLogoutRequest_relayState_set, NULL)
    PHP_FE(LassoLibLogoutRequest_consent_get, NULL)
    PHP_FE(LassoLibLogoutRequest_consent_set, NULL)
    PHP_FE(LassoLibLogoutRequest_notOnOrAfter_get, NULL)
    PHP_FE(LassoLibLogoutRequest_notOnOrAfter_set, NULL)
    PHP_FE(lasso_lib_logout_request_set_session_indexes, NULL)
    PHP_FE(lasso_lib_logout_request_get_session_indexes, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_extension_get, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_extension_set, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_providerId_get, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_providerId_set, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_idpProvidedNameIdentifier_get, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_idpProvidedNameIdentifier_set, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_spProvidedNameIdentifier_get, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_spProvidedNameIdentifier_set, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_get, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_set, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_relayState_get, NULL)
    PHP_FE(LassoLibRegisterNameIdentifierRequest_relayState_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_extension_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_extension_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_providerId_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_providerId_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_nameIdentifier_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_nameIdentifier_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_targetNamespace_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_targetNamespace_set, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_consent_get, NULL)
    PHP_FE(LassoLibNameIdentifierMappingRequest_consent_set, NULL)
    PHP_FE(LassoSaml2BaseIDAbstract_nameQualifier_get, NULL)
    PHP_FE(LassoSaml2BaseIDAbstract_nameQualifier_set, NULL)
    PHP_FE(LassoSaml2BaseIDAbstract_spNameQualifier_get, NULL)
    PHP_FE(LassoSaml2BaseIDAbstract_spNameQualifier_set, NULL)
    PHP_FE(LassoSaml2AttributeValue_any_get, NULL)
    PHP_FE(LassoSaml2AttributeValue_any_set, NULL)
    PHP_FE(LassoSamlp2NameIDPolicy_format_get, NULL)
    PHP_FE(LassoSamlp2NameIDPolicy_format_set, NULL)
    PHP_FE(LassoSamlp2NameIDPolicy_spNameQualifier_get, NULL)
    PHP_FE(LassoSamlp2NameIDPolicy_spNameQualifier_set, NULL)
    PHP_FE(LassoSamlp2NameIDPolicy_allowCreate_get, NULL)
    PHP_FE(LassoSamlp2NameIDPolicy_allowCreate_set, NULL)
    PHP_FE(LassoSamlp2StatusCode_statusCode_get, NULL)
    PHP_FE(LassoSamlp2StatusCode_statusCode_set, NULL)
    PHP_FE(LassoSamlp2StatusCode_value_get, NULL)
    PHP_FE(LassoSamlp2StatusCode_value_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_notBefore_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_notBefore_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_notOnOrAfter_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_notOnOrAfter_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_recipient_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_recipient_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_inResponseTo_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_inResponseTo_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_address_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmationData_address_set, NULL)
    PHP_FE(LassoSaml2Subject_baseId_get, NULL)
    PHP_FE(LassoSaml2Subject_baseId_set, NULL)
    PHP_FE(LassoSaml2Subject_nameId_get, NULL)
    PHP_FE(LassoSaml2Subject_nameId_set, NULL)
    PHP_FE(LassoSaml2Subject_encryptedId_get, NULL)
    PHP_FE(LassoSaml2Subject_encryptedId_set, NULL)
    PHP_FE(LassoSaml2Subject_subjectConfirmation_get, NULL)
    PHP_FE(LassoSaml2Subject_subjectConfirmation_set, NULL)
    PHP_FE(LassoSaml2Conditions_condition_get, NULL)
    PHP_FE(LassoSaml2Conditions_condition_set, NULL)
    PHP_FE(LassoSaml2Conditions_audienceRestriction_get, NULL)
    PHP_FE(LassoSaml2Conditions_audienceRestriction_set, NULL)
    PHP_FE(LassoSaml2Conditions_oneTimeUse_get, NULL)
    PHP_FE(LassoSaml2Conditions_oneTimeUse_set, NULL)
    PHP_FE(LassoSaml2Conditions_proxyRestriction_get, NULL)
    PHP_FE(LassoSaml2Conditions_proxyRestriction_set, NULL)
    PHP_FE(LassoSaml2Conditions_notBefore_get, NULL)
    PHP_FE(LassoSaml2Conditions_notBefore_set, NULL)
    PHP_FE(LassoSaml2Conditions_notOnOrAfter_get, NULL)
    PHP_FE(LassoSaml2Conditions_notOnOrAfter_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_issuer_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_issuer_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_extensions_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_extensions_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_status_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_status_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_id_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_id_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_inResponseTo_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_inResponseTo_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_version_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_version_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_issueInstant_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_issueInstant_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_destination_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_destination_set, NULL)
    PHP_FE(LassoSamlp2StatusResponse_consent_get, NULL)
    PHP_FE(LassoSamlp2StatusResponse_consent_set, NULL)
    PHP_FE(LassoSaml2ProxyRestriction_audience_get, NULL)
    PHP_FE(LassoSaml2ProxyRestriction_audience_set, NULL)
    PHP_FE(LassoSaml2ProxyRestriction_count_get, NULL)
    PHP_FE(LassoSaml2ProxyRestriction_count_set, NULL)
    PHP_FE(LassoSaml2Advice_assertionIdRef_get, NULL)
    PHP_FE(LassoSaml2Advice_assertionIdRef_set, NULL)
    PHP_FE(LassoSaml2Advice_assertionUriRef_get, NULL)
    PHP_FE(LassoSaml2Advice_assertionUriRef_set, NULL)
    PHP_FE(LassoSaml2Advice_assertion_get, NULL)
    PHP_FE(LassoSaml2Advice_assertion_set, NULL)
    PHP_FE(LassoSaml2Advice_encryptedAssertion_get, NULL)
    PHP_FE(LassoSaml2Advice_encryptedAssertion_set, NULL)
    PHP_FE(LassoSamlp2ArtifactResponse_any_get, NULL)
    PHP_FE(LassoSamlp2ArtifactResponse_any_set, NULL)
    PHP_FE(LassoSaml2Attribute_attributeValue_get, NULL)
    PHP_FE(LassoSaml2Attribute_attributeValue_set, NULL)
    PHP_FE(LassoSaml2Attribute_name_get, NULL)
    PHP_FE(LassoSaml2Attribute_name_set, NULL)
    PHP_FE(LassoSaml2Attribute_nameFormat_get, NULL)
    PHP_FE(LassoSaml2Attribute_nameFormat_set, NULL)
    PHP_FE(LassoSaml2Attribute_friendlyName_get, NULL)
    PHP_FE(LassoSaml2Attribute_friendlyName_set, NULL)
    PHP_FE(LassoSamlp2IDPList_idpEntry_get, NULL)
    PHP_FE(LassoSamlp2IDPList_idpEntry_set, NULL)
    PHP_FE(LassoSamlp2IDPList_getComplete_get, NULL)
    PHP_FE(LassoSamlp2IDPList_getComplete_set, NULL)
    PHP_FE(LassoSamlp2Status_statusCode_get, NULL)
    PHP_FE(LassoSamlp2Status_statusCode_set, NULL)
    PHP_FE(LassoSamlp2Status_statusMessage_get, NULL)
    PHP_FE(LassoSamlp2Status_statusMessage_set, NULL)
    PHP_FE(LassoSamlp2Status_statusDetail_get, NULL)
    PHP_FE(LassoSamlp2Status_statusDetail_set, NULL)
    PHP_FE(LassoSaml2EncryptedElement_encryptedData_get, NULL)
    PHP_FE(LassoSaml2EncryptedElement_encryptedData_set, NULL)
    PHP_FE(LassoSaml2EncryptedElement_encryptedKey_get, NULL)
    PHP_FE(LassoSaml2EncryptedElement_encryptedKey_set, NULL)
    PHP_FE(LassoSaml2EncryptedElement_originalData_get, NULL)
    PHP_FE(LassoSaml2EncryptedElement_originalData_set, NULL)
    PHP_FE(lasso_saml2_encrypted_element_server_decrypt, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_baseId_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_baseId_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_nameId_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_nameId_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_encryptedId_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_encryptedId_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_subjectConfirmationData_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_subjectConfirmationData_set, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_method_get, NULL)
    PHP_FE(LassoSaml2SubjectConfirmation_method_set, NULL)
    PHP_FE(LassoSamlp2IDPEntry_providerId_get, NULL)
    PHP_FE(LassoSamlp2IDPEntry_providerId_set, NULL)
    PHP_FE(LassoSamlp2IDPEntry_name_get, NULL)
    PHP_FE(LassoSamlp2IDPEntry_name_set, NULL)
    PHP_FE(LassoSamlp2IDPEntry_loc_get, NULL)
    PHP_FE(LassoSamlp2IDPEntry_loc_set, NULL)
    PHP_FE(LassoSaml2AudienceRestriction_audience_get, NULL)
    PHP_FE(LassoSaml2AudienceRestriction_audience_set, NULL)
    PHP_FE(LassoSamlp2RequestedAuthnContext_authnContextClassRef_get, NULL)
    PHP_FE(LassoSamlp2RequestedAuthnContext_authnContextClassRef_set, NULL)
    PHP_FE(LassoSamlp2RequestedAuthnContext_authnContextDeclRef_get, NULL)
    PHP_FE(LassoSamlp2RequestedAuthnContext_authnContextDeclRef_set, NULL)
    PHP_FE(LassoSamlp2RequestedAuthnContext_comparison_get, NULL)
    PHP_FE(LassoSamlp2RequestedAuthnContext_comparison_set, NULL)
    PHP_FE(LassoSaml2AttributeStatement_attribute_get, NULL)
    PHP_FE(LassoSaml2AttributeStatement_attribute_set, NULL)
    PHP_FE(LassoSaml2AttributeStatement_encryptedAttribute_get, NULL)
    PHP_FE(LassoSaml2AttributeStatement_encryptedAttribute_set, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_action_get, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_action_set, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_evidence_get, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_evidence_set, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_resource_get, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_resource_set, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_decision_get, NULL)
    PHP_FE(LassoSaml2AuthzDecisionStatement_decision_set, NULL)
    PHP_FE(LassoSaml2Evidence_assertionIdRef_get, NULL)
    PHP_FE(LassoSaml2Evidence_assertionIdRef_set, NULL)
    PHP_FE(LassoSaml2Evidence_assertionUriRef_get, NULL)
    PHP_FE(LassoSaml2Evidence_assertionUriRef_set, NULL)
    PHP_FE(LassoSaml2Evidence_assertion_get, NULL)
    PHP_FE(LassoSaml2Evidence_assertion_set, NULL)
    PHP_FE(LassoSaml2Evidence_encryptedAssertion_get, NULL)
    PHP_FE(LassoSaml2Evidence_encryptedAssertion_set, NULL)
    PHP_FE(lasso_saml2_key_info_confirmation_data_type_get_key_info, NULL)
    PHP_FE(lasso_saml2_key_info_confirmation_data_type_set_key_info, NULL)
    PHP_FE(LassoSamlp2Scoping_idpList_get, NULL)
    PHP_FE(LassoSamlp2Scoping_idpList_set, NULL)
    PHP_FE(LassoSamlp2Scoping_requesterId_get, NULL)
    PHP_FE(LassoSamlp2Scoping_requesterId_set, NULL)
    PHP_FE(LassoSamlp2Scoping_proxyCount_get, NULL)
    PHP_FE(LassoSamlp2Scoping_proxyCount_set, NULL)
    PHP_FE(LassoSaml2AuthnContext_authnContextClassRef_get, NULL)
    PHP_FE(LassoSaml2AuthnContext_authnContextClassRef_set, NULL)
    PHP_FE(LassoSaml2AuthnContext_authnContextDeclRef_get, NULL)
    PHP_FE(LassoSaml2AuthnContext_authnContextDeclRef_set, NULL)
    PHP_FE(LassoSaml2AuthnContext_authenticatingAuthority_get, NULL)
    PHP_FE(LassoSaml2AuthnContext_authenticatingAuthority_set, NULL)
    PHP_FE(LassoSaml2Assertion_issuer_get, NULL)
    PHP_FE(LassoSaml2Assertion_issuer_set, NULL)
    PHP_FE(LassoSaml2Assertion_subject_get, NULL)
    PHP_FE(LassoSaml2Assertion_subject_set, NULL)
    PHP_FE(LassoSaml2Assertion_conditions_get, NULL)
    PHP_FE(LassoSaml2Assertion_conditions_set, NULL)
    PHP_FE(LassoSaml2Assertion_advice_get, NULL)
    PHP_FE(LassoSaml2Assertion_advice_set, NULL)
    PHP_FE(LassoSaml2Assertion_statement_get, NULL)
    PHP_FE(LassoSaml2Assertion_statement_set, NULL)
    PHP_FE(LassoSaml2Assertion_authnStatement_get, NULL)
    PHP_FE(LassoSaml2Assertion_authnStatement_set, NULL)
    PHP_FE(LassoSaml2Assertion_authzDecisionStatement_get, NULL)
    PHP_FE(LassoSaml2Assertion_authzDecisionStatement_set, NULL)
    PHP_FE(LassoSaml2Assertion_attributeStatement_get, NULL)
    PHP_FE(LassoSaml2Assertion_attributeStatement_set, NULL)
    PHP_FE(LassoSaml2Assertion_version_get, NULL)
    PHP_FE(LassoSaml2Assertion_version_set, NULL)
    PHP_FE(LassoSaml2Assertion_id_get, NULL)
    PHP_FE(LassoSaml2Assertion_id_set, NULL)
    PHP_FE(LassoSaml2Assertion_issueInstant_get, NULL)
    PHP_FE(LassoSaml2Assertion_issueInstant_set, NULL)
    PHP_FE(lasso_saml2_assertion_has_audience_restriction, NULL)
    PHP_FE(lasso_saml2_assertion_is_audience_restricted, NULL)
    PHP_FE(lasso_saml2_assertion_set_subject_name_id, NULL)
    PHP_FE(lasso_saml2_assertion_set_subject_confirmation_name_id, NULL)
    PHP_FE(lasso_saml2_assertion_set_subject_confirmation_data, NULL)
    PHP_FE(lasso_saml2_assertion_set_basic_conditions, NULL)
    PHP_FE(lasso_saml2_assertion_add_audience_restriction, NULL)
    PHP_FE(lasso_saml2_assertion_add_proxy_limit, NULL)
    PHP_FE(lasso_saml2_assertion_validate_conditions, NULL)
    PHP_FE(lasso_saml2_assertion_get_issuer_provider, NULL)
    PHP_FE(lasso_saml2_assertion_add_attribute_with_node, NULL)
    PHP_FE(lasso_saml2_assertion_get_subject_confirmation_data, NULL)
    PHP_FE(lasso_saml2_assertion_get_in_response_to, NULL)
    PHP_FE(lasso_saml2_assertion_decrypt_subject, NULL)
    PHP_FE(lasso_saml2_assertion_validate_time_checks, NULL)
    PHP_FE(lasso_saml2_assertion_validate_audience, NULL)
    PHP_FE(lasso_saml2_assertion_has_one_time_use, NULL)
    PHP_FE(lasso_saml2_assertion_allows_proxying, NULL)
    PHP_FE(lasso_saml2_assertion_allows_proxying_to, NULL)
    PHP_FE(lasso_saml2_assertion_set_one_time_use, NULL)
    PHP_FE(LassoSaml2NameID_content_get, NULL)
    PHP_FE(LassoSaml2NameID_content_set, NULL)
    PHP_FE(LassoSaml2NameID_format_get, NULL)
    PHP_FE(LassoSaml2NameID_format_set, NULL)
    PHP_FE(LassoSaml2NameID_spProvidedId_get, NULL)
    PHP_FE(LassoSaml2NameID_spProvidedId_set, NULL)
    PHP_FE(LassoSaml2NameID_nameQualifier_get, NULL)
    PHP_FE(LassoSaml2NameID_nameQualifier_set, NULL)
    PHP_FE(LassoSaml2NameID_spNameQualifier_get, NULL)
    PHP_FE(LassoSaml2NameID_spNameQualifier_set, NULL)
    PHP_FE(lasso_saml2_name_id_equals, NULL)
    PHP_FE(LassoSamlp2NameIDMappingResponse_nameId_get, NULL)
    PHP_FE(LassoSamlp2NameIDMappingResponse_nameId_set, NULL)
    PHP_FE(LassoSamlp2NameIDMappingResponse_encryptedId_get, NULL)
    PHP_FE(LassoSamlp2NameIDMappingResponse_encryptedId_set, NULL)
    PHP_FE(LassoSaml2Action_content_get, NULL)
    PHP_FE(LassoSaml2Action_content_set, NULL)
    PHP_FE(LassoSaml2Action_namespace_get, NULL)
    PHP_FE(LassoSaml2Action_namespace_set, NULL)
    PHP_FE(LassoSamlp2Response_assertion_get, NULL)
    PHP_FE(LassoSamlp2Response_assertion_set, NULL)
    PHP_FE(LassoSamlp2Response_encryptedAssertion_get, NULL)
    PHP_FE(LassoSamlp2Response_encryptedAssertion_set, NULL)
    PHP_FE(LassoSaml2SubjectLocality_address_get, NULL)
    PHP_FE(LassoSaml2SubjectLocality_address_set, NULL)
    PHP_FE(LassoSaml2SubjectLocality_dnsName_get, NULL)
    PHP_FE(LassoSaml2SubjectLocality_dnsName_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_issuer_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_issuer_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_extensions_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_extensions_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_id_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_id_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_version_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_version_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_issueInstant_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_issueInstant_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_destination_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_destination_set, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_consent_get, NULL)
    PHP_FE(LassoSamlp2RequestAbstract_consent_set, NULL)
    PHP_FE(LassoSamlp2AssertionIDRequest_assertionIdRef_get, NULL)
    PHP_FE(LassoSamlp2AssertionIDRequest_assertionIdRef_set, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_baseId_get, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_baseId_set, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_nameId_get, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_nameId_set, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_encryptedId_get, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_encryptedId_set, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_nameIdPolicy_get, NULL)
    PHP_FE(LassoSamlp2NameIDMappingRequest_nameIdPolicy_set, NULL)
    PHP_FE(LassoSamlp2ArtifactResolve_artifact_get, NULL)
    PHP_FE(LassoSamlp2ArtifactResolve_artifact_set, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_nameId_get, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_nameId_set, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_encryptedId_get, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_encryptedId_set, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_newId_get, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_newId_set, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_newEncryptedId_get, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_newEncryptedId_set, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_terminate_get, NULL)
    PHP_FE(LassoSamlp2ManageNameIDRequest_terminate_set, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_baseId_get, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_baseId_set, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_nameId_get, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_nameId_set, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_encryptedId_get, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_encryptedId_set, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_sessionIndex_get, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_sessionIndex_set, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_reason_get, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_reason_set, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_notOnOrAfter_get, NULL)
    PHP_FE(LassoSamlp2LogoutRequest_notOnOrAfter_set, NULL)
    PHP_FE(lasso_samlp2_logout_request_get_session_indexes, NULL)
    PHP_FE(lasso_samlp2_logout_request_set_session_indexes, NULL)
    PHP_FE(LassoSamlp2SubjectQueryAbstract_subject_get, NULL)
    PHP_FE(LassoSamlp2SubjectQueryAbstract_subject_set, NULL)
    PHP_FE(LassoSamlp2AttributeQuery_attribute_get, NULL)
    PHP_FE(LassoSamlp2AttributeQuery_attribute_set, NULL)
    PHP_FE(LassoSamlp2AuthzDecisionQuery_action_get, NULL)
    PHP_FE(LassoSamlp2AuthzDecisionQuery_action_set, NULL)
    PHP_FE(LassoSamlp2AuthzDecisionQuery_evidence_get, NULL)
    PHP_FE(LassoSamlp2AuthzDecisionQuery_evidence_set, NULL)
    PHP_FE(LassoSamlp2AuthzDecisionQuery_resource_get, NULL)
    PHP_FE(LassoSamlp2AuthzDecisionQuery_resource_set, NULL)
    PHP_FE(LassoSaml2AuthnStatement_subjectLocality_get, NULL)
    PHP_FE(LassoSaml2AuthnStatement_subjectLocality_set, NULL)
    PHP_FE(LassoSaml2AuthnStatement_authnContext_get, NULL)
    PHP_FE(LassoSaml2AuthnStatement_authnContext_set, NULL)
    PHP_FE(LassoSaml2AuthnStatement_authnInstant_get, NULL)
    PHP_FE(LassoSaml2AuthnStatement_authnInstant_set, NULL)
    PHP_FE(LassoSaml2AuthnStatement_sessionIndex_get, NULL)
    PHP_FE(LassoSaml2AuthnStatement_sessionIndex_set, NULL)
    PHP_FE(LassoSaml2AuthnStatement_sessionNotOnOrAfter_get, NULL)
    PHP_FE(LassoSaml2AuthnStatement_sessionNotOnOrAfter_set, NULL)
    PHP_FE(LassoSamlp2AuthnQuery_requestedAuthnContext_get, NULL)
    PHP_FE(LassoSamlp2AuthnQuery_requestedAuthnContext_set, NULL)
    PHP_FE(LassoSamlp2AuthnQuery_sessionIndex_get, NULL)
    PHP_FE(LassoSamlp2AuthnQuery_sessionIndex_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_subject_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_subject_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_nameIdPolicy_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_nameIdPolicy_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_conditions_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_conditions_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_requestedAuthnContext_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_requestedAuthnContext_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_scoping_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_scoping_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_forceAuthn_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_forceAuthn_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_isPassive_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_isPassive_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_protocolBinding_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_protocolBinding_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_assertionConsumerServiceUrl_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_assertionConsumerServiceUrl_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_set, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_providerName_get, NULL)
    PHP_FE(LassoSamlp2AuthnRequest_providerName_set, NULL)
    PHP_FE(LassoSoapBody_any_get, NULL)
    PHP_FE(LassoSoapBody_any_set, NULL)
    PHP_FE(LassoSoapBody_id_get, NULL)
    PHP_FE(LassoSoapBody_id_set, NULL)
    PHP_FE(LassoSoapFault_faultcode_get, NULL)
    PHP_FE(LassoSoapFault_faultcode_set, NULL)
    PHP_FE(LassoSoapFault_faultstring_get, NULL)
    PHP_FE(LassoSoapFault_faultstring_set, NULL)
    PHP_FE(LassoSoapFault_faultactor_get, NULL)
    PHP_FE(LassoSoapFault_faultactor_set, NULL)
    PHP_FE(LassoSoapFault_detail_get, NULL)
    PHP_FE(LassoSoapFault_detail_set, NULL)
    PHP_FE(LassoSoapHeader_other_get, NULL)
    PHP_FE(LassoSoapHeader_other_set, NULL)
    PHP_FE(LassoSoapDetail_any_get, NULL)
    PHP_FE(LassoSoapDetail_any_set, NULL)
    PHP_FE(LassoSoapEnvelope_header_get, NULL)
    PHP_FE(LassoSoapEnvelope_header_set, NULL)
    PHP_FE(LassoSoapEnvelope_body_get, NULL)
    PHP_FE(LassoSoapEnvelope_body_set, NULL)
    PHP_FE(lasso_ds_x509_data_get_certificate, NULL)
    PHP_FE(lasso_ds_x509_data_set_certificate, NULL)
    PHP_FE(lasso_ds_x509_data_get_subject_name, NULL)
    PHP_FE(lasso_ds_x509_data_set_subject_name, NULL)
    PHP_FE(lasso_ds_x509_data_get_crl, NULL)
    PHP_FE(lasso_ds_x509_data_set_crl, NULL)
    PHP_FE(LassoDsKeyValue_rsaKeyValue_get, NULL)
    PHP_FE(LassoDsKeyValue_rsaKeyValue_set, NULL)
    PHP_FE(lasso_ds_key_value_get_x509_data, NULL)
    PHP_FE(lasso_ds_key_value_set_x509_data, NULL)
    PHP_FE(LassoDsKeyInfo_keyValue_get, NULL)
    PHP_FE(LassoDsKeyInfo_keyValue_set, NULL)
    PHP_FE(LassoDsRsaKeyValue_modulus_get, NULL)
    PHP_FE(LassoDsRsaKeyValue_modulus_set, NULL)
    PHP_FE(LassoDsRsaKeyValue_exponent_get, NULL)
    PHP_FE(LassoDsRsaKeyValue_exponent_set, NULL)
    {NULL, NULL, NULL, 0, 0}
};

zend_module_entry lasso_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
    STANDARD_MODULE_HEADER,
#endif
    PHP_LASSO_EXTNAME,
    lasso_functions,
    PHP_MINIT(lasso),
    PHP_MSHUTDOWN(lasso),
    NULL,
    NULL,
    NULL,
#if ZEND_MODULE_API_NO >= 20010901
    PHP_LASSO_VERSION,
#endif
    STANDARD_MODULE_PROPERTIES
};

